#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 10
#define STATE_COUNT 175
#define SYMBOL_COUNT 84
#define ALIAS_COUNT 7
#define TOKEN_COUNT 54
#define EXTERNAL_TOKEN_COUNT 1
#define FIELD_COUNT 0
#define MAX_ALIAS_SEQUENCE_LENGTH 6

enum {
  sym_disjunction_delimiter = 1,
  aux_sym__invalid_quantifier_token1 = 2,
  aux_sym__invalid_quantifier_token2 = 3,
  aux_sym__invalid_quantifier_token3 = 4,
  aux_sym__invalid_secondary_quantifier_token1 = 5,
  aux_sym__invalid_secondary_quantifier_token2 = 6,
  anon_sym_STAR = 7,
  anon_sym_QMARK = 8,
  anon_sym_PLUS = 9,
  anon_sym_LBRACE = 10,
  aux_sym_count_quantifier_token1 = 11,
  anon_sym_COMMA = 12,
  anon_sym_RBRACE = 13,
  anon_sym_QMARK_EQ = 14,
  anon_sym_QMARK_BANG = 15,
  anon_sym_QMARK_LT_EQ = 16,
  anon_sym_QMARK_LT_BANG = 17,
  anon_sym_BSLASH = 18,
  aux_sym_backreference_token1 = 19,
  anon_sym_BSLASHk_LT = 20,
  anon_sym_GT = 21,
  anon_sym_QMARK_LT = 22,
  aux_sym_group_name_token1 = 23,
  aux_sym_group_name_token2 = 24,
  anon_sym_QMARK_COLON = 25,
  sym_group_begin = 26,
  sym_group_end = 27,
  anon_sym_LBRACK = 28,
  anon_sym_CARET = 29,
  anon_sym_DASH = 30,
  anon_sym_RBRACK = 31,
  aux_sym_set_atom_token1 = 32,
  anon_sym_BSLASHb = 33,
  aux_sym_character_class_escape_token1 = 34,
  aux_sym_character_class_escape_token2 = 35,
  anon_sym_EQ = 36,
  sym__unicode_property = 37,
  aux_sym_identity_escape_token1 = 38,
  anon_sym_BSLASHu = 39,
  aux_sym_unicode_escape_token1 = 40,
  aux_sym_unicode_escape_token2 = 41,
  aux_sym__invalid_unicode_escape_token1 = 42,
  aux_sym__invalid_unicode_escape_token2 = 43,
  anon_sym_BSLASHx = 44,
  aux_sym_hexadecimal_escape_token1 = 45,
  anon_sym_BSLASHc = 46,
  aux_sym_control_letter_escape_token1 = 47,
  sym_special_escape = 48,
  sym_end_assertion = 49,
  sym_non_boundary_assertion = 50,
  sym_any_character = 51,
  sym_non_syntax_character = 52,
  sym_null_character = 53,
  sym_regex = 54,
  sym_disjunction = 55,
  sym_zero_or_more = 56,
  sym_one_or_more = 57,
  sym_optional = 58,
  sym_count_quantifier = 59,
  sym_lookahead_assertion = 60,
  sym_negative_lookahead_assertion = 61,
  sym_lookbehind_assertion = 62,
  sym_negative_lookbehind_assertion = 63,
  sym_backreference = 64,
  sym_named_capturing_group = 65,
  sym_named_capturing_group_identifier = 66,
  sym_group_name = 67,
  sym_non_capturing_group = 68,
  sym_anonymous_capturing_group = 69,
  sym_character_set = 70,
  sym_set_range = 71,
  sym_set_identity_escape = 72,
  sym_character_class_escape = 73,
  sym_identity_escape = 74,
  sym_unicode_escape = 75,
  sym_hexadecimal_escape = 76,
  sym_control_letter_escape = 77,
  sym__escape_operator = 78,
  sym_start_assertion = 79,
  sym_boundary_assertion = 80,
  aux_sym_pattern_repeat1 = 81,
  aux_sym_group_name_repeat1 = 82,
  aux_sym_character_set_repeat1 = 83,
  alias_sym_lazy = 84,
  alias_sym_range_delimiter = 85,
  alias_sym_set_negation = 86,
  alias_sym_unicode_code = 87,
  alias_sym_unicode_property_name = 88,
  alias_sym_unicode_property_operator = 89,
  alias_sym_unicode_property_value = 90,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_disjunction_delimiter] = "disjunction_delimiter",
  [aux_sym__invalid_quantifier_token1] = "_invalid_quantifier_token1",
  [aux_sym__invalid_quantifier_token2] = "_invalid_quantifier_token2",
  [aux_sym__invalid_quantifier_token3] = "_invalid_quantifier_token3",
  [aux_sym__invalid_secondary_quantifier_token1] = "_invalid_secondary_quantifier_token1",
  [aux_sym__invalid_secondary_quantifier_token2] = "_invalid_secondary_quantifier_token2",
  [anon_sym_STAR] = "*",
  [anon_sym_QMARK] = "?",
  [anon_sym_PLUS] = "+",
  [anon_sym_LBRACE] = "{",
  [aux_sym_count_quantifier_token1] = "count_quantifier_value",
  [anon_sym_COMMA] = "count_quantifier_delimiter",
  [anon_sym_RBRACE] = "}",
  [anon_sym_QMARK_EQ] = "lookahead_identifier",
  [anon_sym_QMARK_BANG] = "negative_lookahead_identifier",
  [anon_sym_QMARK_LT_EQ] = "lookbehind_identifier",
  [anon_sym_QMARK_LT_BANG] = "negative_lookbehind_identifier",
  [anon_sym_BSLASH] = "\\",
  [aux_sym_backreference_token1] = "backreference_token1",
  [anon_sym_BSLASHk_LT] = "\\k<",
  [anon_sym_GT] = ">",
  [anon_sym_QMARK_LT] = "?<",
  [aux_sym_group_name_token1] = "group_name_token1",
  [aux_sym_group_name_token2] = "group_name_token2",
  [anon_sym_QMARK_COLON] = "non_capturing_group_identifier",
  [sym_group_begin] = "group_begin",
  [sym_group_end] = "group_end",
  [anon_sym_LBRACK] = "set_begin",
  [anon_sym_CARET] = "^",
  [anon_sym_DASH] = "-",
  [anon_sym_RBRACK] = "set_end",
  [aux_sym_set_atom_token1] = "non_syntax_character",
  [anon_sym_BSLASHb] = "\\b",
  [aux_sym_character_class_escape_token1] = "character_class_escape_token1",
  [aux_sym_character_class_escape_token2] = "character_class_escape_token2",
  [anon_sym_EQ] = "=",
  [sym__unicode_property] = "_unicode_property",
  [aux_sym_identity_escape_token1] = "identity_escape_token1",
  [anon_sym_BSLASHu] = "\\u",
  [aux_sym_unicode_escape_token1] = "unicode_code",
  [aux_sym_unicode_escape_token2] = "unicode_escape_token2",
  [aux_sym__invalid_unicode_escape_token1] = "_invalid_unicode_escape_token1",
  [aux_sym__invalid_unicode_escape_token2] = "_invalid_unicode_escape_token2",
  [anon_sym_BSLASHx] = "\\x",
  [aux_sym_hexadecimal_escape_token1] = "hexadecimal_code",
  [anon_sym_BSLASHc] = "\\c",
  [aux_sym_control_letter_escape_token1] = "control_letter_code",
  [sym_special_escape] = "special_escape",
  [sym_end_assertion] = "end_assertion",
  [sym_non_boundary_assertion] = "non_boundary_assertion",
  [sym_any_character] = "any_character",
  [sym_non_syntax_character] = "non_syntax_character",
  [sym_null_character] = "null_character",
  [sym_regex] = "regex",
  [sym_disjunction] = "disjunction",
  [sym_zero_or_more] = "zero_or_more",
  [sym_one_or_more] = "one_or_more",
  [sym_optional] = "optional",
  [sym_count_quantifier] = "count_quantifier",
  [sym_lookahead_assertion] = "lookahead_assertion",
  [sym_negative_lookahead_assertion] = "negative_lookahead_assertion",
  [sym_lookbehind_assertion] = "lookbehind_assertion",
  [sym_negative_lookbehind_assertion] = "negative_lookbehind_assertion",
  [sym_backreference] = "backreference",
  [sym_named_capturing_group] = "named_capturing_group",
  [sym_named_capturing_group_identifier] = "named_capturing_group_identifier",
  [sym_group_name] = "group_name",
  [sym_non_capturing_group] = "non_capturing_group",
  [sym_anonymous_capturing_group] = "anonymous_capturing_group",
  [sym_character_set] = "character_class",
  [sym_set_range] = "character_range",
  [sym_set_identity_escape] = "identity_escape",
  [sym_character_class_escape] = "character_class_escape",
  [sym_identity_escape] = "identity_escape",
  [sym_unicode_escape] = "unicode_escape",
  [sym_hexadecimal_escape] = "hexadecimal_escape",
  [sym_control_letter_escape] = "control_letter_escape",
  [sym__escape_operator] = "escape_operator",
  [sym_start_assertion] = "start_assertion",
  [sym_boundary_assertion] = "boundary_assertion",
  [aux_sym_pattern_repeat1] = "pattern_repeat1",
  [aux_sym_group_name_repeat1] = "group_name_repeat1",
  [aux_sym_character_set_repeat1] = "character_set_repeat1",
  [alias_sym_lazy] = "lazy",
  [alias_sym_range_delimiter] = "range_delimiter",
  [alias_sym_set_negation] = "set_negation",
  [alias_sym_unicode_code] = "unicode_code",
  [alias_sym_unicode_property_name] = "unicode_property_name",
  [alias_sym_unicode_property_operator] = "unicode_property_operator",
  [alias_sym_unicode_property_value] = "unicode_property_value",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_disjunction_delimiter] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__invalid_quantifier_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__invalid_quantifier_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__invalid_quantifier_token3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__invalid_secondary_quantifier_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__invalid_secondary_quantifier_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_count_quantifier_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_EQ] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_QMARK_BANG] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_QMARK_LT_EQ] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_QMARK_LT_BANG] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BSLASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_backreference_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_BSLASHk_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_LT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_group_name_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_group_name_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_QMARK_COLON] = {
    .visible = true,
    .named = true,
  },
  [sym_group_begin] = {
    .visible = true,
    .named = true,
  },
  [sym_group_end] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_set_atom_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BSLASHb] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_character_class_escape_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_character_class_escape_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [sym__unicode_property] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_identity_escape_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_BSLASHu] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_unicode_escape_token1] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_unicode_escape_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__invalid_unicode_escape_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__invalid_unicode_escape_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_BSLASHx] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_hexadecimal_escape_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BSLASHc] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_control_letter_escape_token1] = {
    .visible = true,
    .named = true,
  },
  [sym_special_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_end_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_non_boundary_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_any_character] = {
    .visible = true,
    .named = true,
  },
  [sym_non_syntax_character] = {
    .visible = true,
    .named = true,
  },
  [sym_null_character] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_disjunction] = {
    .visible = true,
    .named = true,
  },
  [sym_zero_or_more] = {
    .visible = true,
    .named = true,
  },
  [sym_one_or_more] = {
    .visible = true,
    .named = true,
  },
  [sym_optional] = {
    .visible = true,
    .named = true,
  },
  [sym_count_quantifier] = {
    .visible = true,
    .named = true,
  },
  [sym_lookahead_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_negative_lookahead_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_lookbehind_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_negative_lookbehind_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_backreference] = {
    .visible = true,
    .named = true,
  },
  [sym_named_capturing_group] = {
    .visible = true,
    .named = true,
  },
  [sym_named_capturing_group_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_group_name] = {
    .visible = true,
    .named = true,
  },
  [sym_non_capturing_group] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_capturing_group] = {
    .visible = true,
    .named = true,
  },
  [sym_character_set] = {
    .visible = true,
    .named = true,
  },
  [sym_set_range] = {
    .visible = true,
    .named = true,
  },
  [sym_set_identity_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_character_class_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_identity_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_unicode_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_hexadecimal_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_control_letter_escape] = {
    .visible = true,
    .named = true,
  },
  [sym__escape_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_start_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_boundary_assertion] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_group_name_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_character_set_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_lazy] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_range_delimiter] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_set_negation] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_unicode_code] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_unicode_property_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_unicode_property_operator] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_unicode_property_value] = {
    .visible = true,
    .named = true,
  },
};

static TSSymbol ts_alias_sequences[19][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_special_escape,
  },
  [2] = {
    [1] = alias_sym_lazy,
  },
  [3] = {
    [1] = sym_non_syntax_character,
  },
  [4] = {
    [1] = alias_sym_set_negation,
  },
  [5] = {
    [0] = sym_special_escape,
    [1] = sym_non_syntax_character,
  },
  [6] = {
    [1] = alias_sym_unicode_property_value,
  },
  [7] = {
    [1] = alias_sym_range_delimiter,
  },
  [8] = {
    [1] = alias_sym_range_delimiter,
    [2] = sym_special_escape,
  },
  [9] = {
    [0] = sym_special_escape,
    [1] = alias_sym_range_delimiter,
  },
  [10] = {
    [0] = sym_special_escape,
    [1] = alias_sym_range_delimiter,
    [2] = sym_special_escape,
  },
  [11] = {
    [2] = sym_non_syntax_character,
  },
  [12] = {
    [2] = alias_sym_unicode_code,
  },
  [13] = {
    [3] = alias_sym_lazy,
  },
  [14] = {
    [3] = sym_non_syntax_character,
  },
  [15] = {
    [1] = alias_sym_unicode_property_name,
    [2] = alias_sym_unicode_property_operator,
    [3] = alias_sym_unicode_property_value,
  },
  [16] = {
    [4] = alias_sym_lazy,
  },
  [17] = {
    [4] = sym_non_syntax_character,
  },
  [18] = {
    [5] = alias_sym_lazy,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lookahead == 0;
  switch (state) {
    case 0:
      if (eof) ADVANCE(29);
      if (lookahead == '\n') ADVANCE(65);
      if (lookahead == '$') ADVANCE(92);
      if (lookahead == '(') ADVANCE(59);
      if (lookahead == ')') ADVANCE(60);
      if (lookahead == '*') ADVANCE(36);
      if (lookahead == '+') ADVANCE(39);
      if (lookahead == ',') ADVANCE(44);
      if (lookahead == '-') ADVANCE(63);
      if (lookahead == '.') ADVANCE(94);
      if (lookahead == '/') ADVANCE(65);
      if (lookahead == '0') ADVANCE(43);
      if (lookahead == '=') ADVANCE(70);
      if (lookahead == '>') ADVANCE(54);
      if (lookahead == '?') ADVANCE(38);
      if (lookahead == '[') ADVANCE(61);
      if (lookahead == '\\') ADVANCE(50);
      if (lookahead == ']') ADVANCE(64);
      if (lookahead == '^') ADVANCE(62);
      if (lookahead == '_') ADVANCE(56);
      if (lookahead == '{') ADVANCE(41);
      if (lookahead == '|') ADVANCE(30);
      if (lookahead == '}') ADVANCE(45);
      if (lookahead == 8204 ||
          lookahead == 8205) ADVANCE(57);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(43);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(56);
      if (lookahead != 0) ADVANCE(65);
      END_STATE();
    case 1:
      if (lookahead == '!') ADVANCE(47);
      if (lookahead == ':') ADVANCE(58);
      if (lookahead == '<') ADVANCE(55);
      if (lookahead == '=') ADVANCE(46);
      END_STATE();
    case 2:
      if (lookahead == ',') ADVANCE(44);
      if (lookahead == '>') ADVANCE(54);
      if (lookahead == '\\') ADVANCE(15);
      if (lookahead == '}') ADVANCE(45);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 8204 ||
          lookahead == 8205) ADVANCE(57);
      END_STATE();
    case 3:
      if (lookahead == ',') ADVANCE(18);
      if (lookahead == '}') ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3);
      if (lookahead != 0) ADVANCE(32);
      END_STATE();
    case 4:
      if (lookahead == ',') ADVANCE(20);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '}') ADVANCE(32);
      END_STATE();
    case 5:
      if (lookahead == ',') ADVANCE(19);
      if (lookahead == '}') ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(5);
      END_STATE();
    case 6:
      if (lookahead == '-') ADVANCE(63);
      if (lookahead == '=') ADVANCE(70);
      if (lookahead == '\\') ADVANCE(51);
      if (lookahead == ']') ADVANCE(64);
      if (lookahead == '}') ADVANCE(45);
      if (lookahead != 0) ADVANCE(65);
      END_STATE();
    case 7:
      if (lookahead == '-') ADVANCE(63);
      if (lookahead == '\\') ADVANCE(51);
      if (lookahead == ']') ADVANCE(64);
      if (lookahead == '}') ADVANCE(45);
      if (lookahead != 0) ADVANCE(65);
      END_STATE();
    case 8:
      if (lookahead == '-') ADVANCE(63);
      if (lookahead == '\\') ADVANCE(51);
      if (lookahead == ']') ADVANCE(64);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(66);
      if (lookahead != 0) ADVANCE(65);
      END_STATE();
    case 9:
      if (lookahead == '-') ADVANCE(63);
      if (lookahead == '\\') ADVANCE(51);
      if (lookahead == ']') ADVANCE(64);
      if (lookahead != 0) ADVANCE(65);
      END_STATE();
    case 10:
      if (lookahead == '-') ADVANCE(63);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(52);
      if (lookahead == '$' ||
          ('(' <= lookahead && lookahead <= '+') ||
          lookahead == '.' ||
          lookahead == '/' ||
          lookahead == '?' ||
          ('[' <= lookahead && lookahead <= '^') ||
          ('{' <= lookahead && lookahead <= '}')) ADVANCE(72);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(90);
      END_STATE();
    case 11:
      if (lookahead == '<') ADVANCE(53);
      END_STATE();
    case 12:
      if (lookahead == '\\') ADVANCE(51);
      if (lookahead == ']') ADVANCE(64);
      if (lookahead == '^') ADVANCE(62);
      if (lookahead != 0) ADVANCE(65);
      END_STATE();
    case 13:
      if (lookahead == '\\') ADVANCE(51);
      if (lookahead == ']') ADVANCE(64);
      if (lookahead != 0) ADVANCE(65);
      END_STATE();
    case 14:
      if (lookahead == '\\') ADVANCE(15);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(56);
      END_STATE();
    case 15:
      if (lookahead == 'u') ADVANCE(73);
      END_STATE();
    case 16:
      if (lookahead == '{') ADVANCE(69);
      END_STATE();
    case 17:
      if (lookahead == '}') ADVANCE(45);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(43);
      END_STATE();
    case 18:
      if (lookahead == '}') ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(18);
      if (lookahead != 0) ADVANCE(33);
      END_STATE();
    case 19:
      if (lookahead == '}') ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(19);
      END_STATE();
    case 20:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(20);
      if (lookahead != 0 &&
          lookahead != '}') ADVANCE(33);
      END_STATE();
    case 21:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(5);
      END_STATE();
    case 22:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(71);
      END_STATE();
    case 23:
      if (eof) ADVANCE(29);
      if (lookahead == '$') ADVANCE(92);
      if (lookahead == '(') ADVANCE(59);
      if (lookahead == ')') ADVANCE(60);
      if (lookahead == '*') ADVANCE(36);
      if (lookahead == '+') ADVANCE(39);
      if (lookahead == '.') ADVANCE(94);
      if (lookahead == '=') ADVANCE(70);
      if (lookahead == '?') ADVANCE(37);
      if (lookahead == '[') ADVANCE(61);
      if (lookahead == '\\') ADVANCE(50);
      if (lookahead == '^') ADVANCE(62);
      if (lookahead == '{') ADVANCE(42);
      if (lookahead == '|') ADVANCE(30);
      if (lookahead == '}') ADVANCE(45);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/' &&
          lookahead != ']') ADVANCE(95);
      END_STATE();
    case 24:
      if (eof) ADVANCE(29);
      if (lookahead == '$') ADVANCE(92);
      if (lookahead == '(') ADVANCE(59);
      if (lookahead == ')') ADVANCE(60);
      if (lookahead == '*') ADVANCE(36);
      if (lookahead == '+') ADVANCE(39);
      if (lookahead == '.') ADVANCE(94);
      if (lookahead == '?') ADVANCE(37);
      if (lookahead == '[') ADVANCE(61);
      if (lookahead == '\\') ADVANCE(50);
      if (lookahead == '^') ADVANCE(62);
      if (lookahead == '{') ADVANCE(42);
      if (lookahead == '|') ADVANCE(30);
      if (lookahead == '}') ADVANCE(45);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/' &&
          lookahead != ']') ADVANCE(95);
      END_STATE();
    case 25:
      if (eof) ADVANCE(29);
      if (lookahead == '$') ADVANCE(92);
      if (lookahead == '(') ADVANCE(59);
      if (lookahead == ')') ADVANCE(60);
      if (lookahead == '*') ADVANCE(36);
      if (lookahead == '+') ADVANCE(39);
      if (lookahead == '.') ADVANCE(94);
      if (lookahead == '?') ADVANCE(37);
      if (lookahead == '[') ADVANCE(61);
      if (lookahead == '\\') ADVANCE(50);
      if (lookahead == '^') ADVANCE(62);
      if (lookahead == '{') ADVANCE(42);
      if (lookahead == '|') ADVANCE(30);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(96);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/' &&
          lookahead != ']' &&
          lookahead != '}') ADVANCE(95);
      END_STATE();
    case 26:
      if (eof) ADVANCE(29);
      if (lookahead == '$') ADVANCE(92);
      if (lookahead == '(') ADVANCE(59);
      if (lookahead == ')') ADVANCE(60);
      if (lookahead == '.') ADVANCE(94);
      if (lookahead == '?') ADVANCE(1);
      if (lookahead == '[') ADVANCE(61);
      if (lookahead == '\\') ADVANCE(50);
      if (lookahead == '^') ADVANCE(62);
      if (lookahead == '|') ADVANCE(30);
      if (lookahead == '}') ADVANCE(45);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '*' &&
          lookahead != '+' &&
          lookahead != '/' &&
          lookahead != ']' &&
          lookahead != '{') ADVANCE(95);
      END_STATE();
    case 27:
      if (eof) ADVANCE(29);
      if (lookahead == '$') ADVANCE(92);
      if (lookahead == '(') ADVANCE(59);
      if (lookahead == ')') ADVANCE(60);
      if (lookahead == '.') ADVANCE(94);
      if (lookahead == '?') ADVANCE(37);
      if (lookahead == '[') ADVANCE(61);
      if (lookahead == '\\') ADVANCE(50);
      if (lookahead == '^') ADVANCE(62);
      if (lookahead == '{') ADVANCE(21);
      if (lookahead == '|') ADVANCE(30);
      if (lookahead == '*' ||
          lookahead == '+') ADVANCE(34);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/' &&
          lookahead != ']' &&
          lookahead != '}') ADVANCE(95);
      END_STATE();
    case 28:
      if (eof) ADVANCE(29);
      if (lookahead == '$') ADVANCE(92);
      if (lookahead == '(') ADVANCE(59);
      if (lookahead == ')') ADVANCE(60);
      if (lookahead == '.') ADVANCE(94);
      if (lookahead == '[') ADVANCE(61);
      if (lookahead == '\\') ADVANCE(50);
      if (lookahead == '^') ADVANCE(62);
      if (lookahead == '{') ADVANCE(21);
      if (lookahead == '|') ADVANCE(30);
      if (lookahead == '*' ||
          lookahead == '+' ||
          lookahead == '?') ADVANCE(34);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/' &&
          lookahead != ']' &&
          lookahead != '}') ADVANCE(95);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(sym_disjunction_delimiter);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(aux_sym__invalid_quantifier_token1);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(aux_sym__invalid_quantifier_token2);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(aux_sym__invalid_quantifier_token3);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(aux_sym__invalid_secondary_quantifier_token1);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(aux_sym__invalid_secondary_quantifier_token2);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '!') ADVANCE(47);
      if (lookahead == ':') ADVANCE(58);
      if (lookahead == '<') ADVANCE(55);
      if (lookahead == '=') ADVANCE(46);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == ',') ADVANCE(31);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(3);
      if (lookahead != 0 &&
          lookahead != '}') ADVANCE(32);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == ',') ADVANCE(31);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '}') ADVANCE(32);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(aux_sym_count_quantifier_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(43);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_QMARK_EQ);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_QMARK_BANG);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_QMARK_LT_EQ);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_QMARK_LT_BANG);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      if (lookahead == 'B') ADVANCE(93);
      if (lookahead == 'b') ADVANCE(67);
      if (lookahead == 'c') ADVANCE(89);
      if (lookahead == 'k') ADVANCE(11);
      if (lookahead == 'u') ADVANCE(73);
      if (lookahead == 'x') ADVANCE(87);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(16);
      if (lookahead == 'f' ||
          lookahead == 'n' ||
          lookahead == 'r' ||
          ('t' <= lookahead && lookahead <= 'v')) ADVANCE(91);
      if (lookahead == 'D' ||
          lookahead == 'S' ||
          lookahead == 'W' ||
          lookahead == 'd' ||
          ('s' <= lookahead && lookahead <= 'w')) ADVANCE(68);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      if (lookahead == 'b') ADVANCE(67);
      if (lookahead == 'c') ADVANCE(89);
      if (lookahead == 'u') ADVANCE(73);
      if (lookahead == 'x') ADVANCE(87);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(16);
      if (lookahead == 'f' ||
          lookahead == 'n' ||
          lookahead == 'r' ||
          ('t' <= lookahead && lookahead <= 'v')) ADVANCE(91);
      if (lookahead == 'D' ||
          lookahead == 'S' ||
          lookahead == 'W' ||
          lookahead == 'd' ||
          ('s' <= lookahead && lookahead <= 'w')) ADVANCE(68);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(aux_sym_backreference_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(52);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_BSLASHk_LT);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_QMARK_LT);
      if (lookahead == '!') ADVANCE(49);
      if (lookahead == '=') ADVANCE(48);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(aux_sym_group_name_token1);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(aux_sym_group_name_token2);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_QMARK_COLON);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(sym_group_begin);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(sym_group_end);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(aux_sym_set_atom_token1);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(aux_sym_set_atom_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(88);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_BSLASHb);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(aux_sym_character_class_escape_token1);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(aux_sym_character_class_escape_token2);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(sym__unicode_property);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(71);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(aux_sym_identity_escape_token1);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_BSLASHu);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token2);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token2);
      if (lookahead == '0') ADVANCE(76);
      if (lookahead == '1') ADVANCE(77);
      if (('2' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(81);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token2);
      if (lookahead == '0') ADVANCE(81);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(80);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(75);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(78);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(79);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(80);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(aux_sym__invalid_unicode_escape_token1);
      if (lookahead == '{') ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(85);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(aux_sym__invalid_unicode_escape_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(74);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(aux_sym__invalid_unicode_escape_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(83);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(aux_sym__invalid_unicode_escape_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(84);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(aux_sym__invalid_unicode_escape_token2);
      if (lookahead == '0') ADVANCE(76);
      if (lookahead == '1') ADVANCE(77);
      if (lookahead == '}') ADVANCE(45);
      if (('2' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(81);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_BSLASHx);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(aux_sym_hexadecimal_escape_token1);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_BSLASHc);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(aux_sym_control_letter_escape_token1);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym_special_escape);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym_end_assertion);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(sym_non_boundary_assertion);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(sym_any_character);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(sym_non_syntax_character);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(sym_non_syntax_character);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(88);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 26, .external_lex_state = 1},
  [2] = {.lex_state = 26, .external_lex_state = 1},
  [3] = {.lex_state = 26, .external_lex_state = 1},
  [4] = {.lex_state = 26, .external_lex_state = 1},
  [5] = {.lex_state = 26, .external_lex_state = 1},
  [6] = {.lex_state = 26, .external_lex_state = 1},
  [7] = {.lex_state = 26, .external_lex_state = 1},
  [8] = {.lex_state = 26, .external_lex_state = 1},
  [9] = {.lex_state = 26, .external_lex_state = 1},
  [10] = {.lex_state = 26, .external_lex_state = 1},
  [11] = {.lex_state = 26, .external_lex_state = 1},
  [12] = {.lex_state = 26, .external_lex_state = 1},
  [13] = {.lex_state = 26, .external_lex_state = 1},
  [14] = {.lex_state = 26, .external_lex_state = 1},
  [15] = {.lex_state = 26, .external_lex_state = 1},
  [16] = {.lex_state = 26, .external_lex_state = 1},
  [17] = {.lex_state = 26, .external_lex_state = 1},
  [18] = {.lex_state = 26, .external_lex_state = 1},
  [19] = {.lex_state = 26, .external_lex_state = 1},
  [20] = {.lex_state = 23, .external_lex_state = 1},
  [21] = {.lex_state = 25, .external_lex_state = 1},
  [22] = {.lex_state = 24, .external_lex_state = 1},
  [23] = {.lex_state = 24, .external_lex_state = 1},
  [24] = {.lex_state = 24, .external_lex_state = 1},
  [25] = {.lex_state = 24, .external_lex_state = 1},
  [26] = {.lex_state = 24, .external_lex_state = 1},
  [27] = {.lex_state = 24, .external_lex_state = 1},
  [28] = {.lex_state = 24, .external_lex_state = 1},
  [29] = {.lex_state = 24, .external_lex_state = 1},
  [30] = {.lex_state = 24, .external_lex_state = 1},
  [31] = {.lex_state = 24, .external_lex_state = 1},
  [32] = {.lex_state = 24, .external_lex_state = 1},
  [33] = {.lex_state = 24, .external_lex_state = 1},
  [34] = {.lex_state = 24, .external_lex_state = 1},
  [35] = {.lex_state = 24, .external_lex_state = 1},
  [36] = {.lex_state = 24, .external_lex_state = 1},
  [37] = {.lex_state = 24, .external_lex_state = 1},
  [38] = {.lex_state = 24, .external_lex_state = 1},
  [39] = {.lex_state = 24, .external_lex_state = 1},
  [40] = {.lex_state = 24, .external_lex_state = 1},
  [41] = {.lex_state = 24, .external_lex_state = 1},
  [42] = {.lex_state = 24, .external_lex_state = 1},
  [43] = {.lex_state = 24, .external_lex_state = 1},
  [44] = {.lex_state = 24, .external_lex_state = 1},
  [45] = {.lex_state = 24, .external_lex_state = 1},
  [46] = {.lex_state = 24, .external_lex_state = 1},
  [47] = {.lex_state = 24, .external_lex_state = 1},
  [48] = {.lex_state = 24, .external_lex_state = 1},
  [49] = {.lex_state = 24, .external_lex_state = 1},
  [50] = {.lex_state = 24, .external_lex_state = 1},
  [51] = {.lex_state = 24, .external_lex_state = 1},
  [52] = {.lex_state = 24, .external_lex_state = 1},
  [53] = {.lex_state = 24, .external_lex_state = 1},
  [54] = {.lex_state = 24, .external_lex_state = 1},
  [55] = {.lex_state = 24, .external_lex_state = 1},
  [56] = {.lex_state = 24, .external_lex_state = 1},
  [57] = {.lex_state = 24, .external_lex_state = 1},
  [58] = {.lex_state = 24, .external_lex_state = 1},
  [59] = {.lex_state = 24, .external_lex_state = 1},
  [60] = {.lex_state = 24, .external_lex_state = 1},
  [61] = {.lex_state = 24, .external_lex_state = 1},
  [62] = {.lex_state = 24, .external_lex_state = 1},
  [63] = {.lex_state = 24, .external_lex_state = 1},
  [64] = {.lex_state = 24, .external_lex_state = 1},
  [65] = {.lex_state = 27, .external_lex_state = 1},
  [66] = {.lex_state = 27, .external_lex_state = 1},
  [67] = {.lex_state = 27, .external_lex_state = 1},
  [68] = {.lex_state = 27, .external_lex_state = 1},
  [69] = {.lex_state = 27, .external_lex_state = 1},
  [70] = {.lex_state = 27, .external_lex_state = 1},
  [71] = {.lex_state = 28, .external_lex_state = 1},
  [72] = {.lex_state = 28, .external_lex_state = 1},
  [73] = {.lex_state = 28, .external_lex_state = 1},
  [74] = {.lex_state = 28, .external_lex_state = 1},
  [75] = {.lex_state = 28, .external_lex_state = 1},
  [76] = {.lex_state = 28, .external_lex_state = 1},
  [77] = {.lex_state = 28, .external_lex_state = 1},
  [78] = {.lex_state = 28, .external_lex_state = 1},
  [79] = {.lex_state = 28, .external_lex_state = 1},
  [80] = {.lex_state = 28, .external_lex_state = 1},
  [81] = {.lex_state = 12, .external_lex_state = 1},
  [82] = {.lex_state = 26, .external_lex_state = 1},
  [83] = {.lex_state = 13, .external_lex_state = 1},
  [84] = {.lex_state = 13, .external_lex_state = 1},
  [85] = {.lex_state = 13, .external_lex_state = 1},
  [86] = {.lex_state = 26, .external_lex_state = 1},
  [87] = {.lex_state = 13, .external_lex_state = 1},
  [88] = {.lex_state = 26, .external_lex_state = 1},
  [89] = {.lex_state = 26, .external_lex_state = 1},
  [90] = {.lex_state = 26, .external_lex_state = 1},
  [91] = {.lex_state = 26, .external_lex_state = 1},
  [92] = {.lex_state = 13, .external_lex_state = 1},
  [93] = {.lex_state = 13, .external_lex_state = 1},
  [94] = {.lex_state = 6, .external_lex_state = 1},
  [95] = {.lex_state = 7, .external_lex_state = 1},
  [96] = {.lex_state = 7, .external_lex_state = 1},
  [97] = {.lex_state = 8, .external_lex_state = 1},
  [98] = {.lex_state = 9, .external_lex_state = 1},
  [99] = {.lex_state = 9, .external_lex_state = 1},
  [100] = {.lex_state = 9, .external_lex_state = 1},
  [101] = {.lex_state = 9, .external_lex_state = 1},
  [102] = {.lex_state = 9, .external_lex_state = 1},
  [103] = {.lex_state = 9, .external_lex_state = 1},
  [104] = {.lex_state = 9, .external_lex_state = 1},
  [105] = {.lex_state = 9, .external_lex_state = 1},
  [106] = {.lex_state = 9, .external_lex_state = 1},
  [107] = {.lex_state = 9, .external_lex_state = 1},
  [108] = {.lex_state = 9, .external_lex_state = 1},
  [109] = {.lex_state = 9, .external_lex_state = 1},
  [110] = {.lex_state = 9, .external_lex_state = 1},
  [111] = {.lex_state = 9, .external_lex_state = 1},
  [112] = {.lex_state = 9, .external_lex_state = 1},
  [113] = {.lex_state = 13, .external_lex_state = 1},
  [114] = {.lex_state = 13, .external_lex_state = 1},
  [115] = {.lex_state = 13, .external_lex_state = 1},
  [116] = {.lex_state = 13, .external_lex_state = 1},
  [117] = {.lex_state = 13, .external_lex_state = 1},
  [118] = {.lex_state = 13, .external_lex_state = 1},
  [119] = {.lex_state = 13, .external_lex_state = 1},
  [120] = {.lex_state = 13, .external_lex_state = 1},
  [121] = {.lex_state = 13, .external_lex_state = 1},
  [122] = {.lex_state = 13, .external_lex_state = 1},
  [123] = {.lex_state = 13, .external_lex_state = 1},
  [124] = {.lex_state = 13, .external_lex_state = 1},
  [125] = {.lex_state = 13, .external_lex_state = 1},
  [126] = {.lex_state = 13, .external_lex_state = 1},
  [127] = {.lex_state = 13, .external_lex_state = 1},
  [128] = {.lex_state = 13, .external_lex_state = 1},
  [129] = {.lex_state = 2},
  [130] = {.lex_state = 2},
  [131] = {.lex_state = 2},
  [132] = {.lex_state = 14},
  [133] = {.lex_state = 14},
  [134] = {.lex_state = 2},
  [135] = {.lex_state = 82},
  [136] = {.lex_state = 86},
  [137] = {.lex_state = 82},
  [138] = {.lex_state = 2},
  [139] = {.lex_state = 86},
  [140] = {.lex_state = 26},
  [141] = {.lex_state = 10},
  [142] = {.lex_state = 82},
  [143] = {.lex_state = 10},
  [144] = {.lex_state = 82},
  [145] = {.lex_state = 2},
  [146] = {.lex_state = 17},
  [147] = {.lex_state = 10},
  [148] = {.lex_state = 10},
  [149] = {.lex_state = 2},
  [150] = {.lex_state = 26},
  [151] = {.lex_state = 22},
  [152] = {.lex_state = 22},
  [153] = {.lex_state = 26},
  [154] = {.lex_state = 26},
  [155] = {.lex_state = 22},
  [156] = {.lex_state = 0},
  [157] = {.lex_state = 26},
  [158] = {.lex_state = 25},
  [159] = {.lex_state = 86},
  [160] = {.lex_state = 17},
  [161] = {.lex_state = 26},
  [162] = {.lex_state = 10},
  [163] = {.lex_state = 22},
  [164] = {.lex_state = 2},
  [165] = {.lex_state = 26},
  [166] = {.lex_state = 26},
  [167] = {.lex_state = 0},
  [168] = {.lex_state = 26},
  [169] = {.lex_state = 10},
  [170] = {.lex_state = 10},
  [171] = {.lex_state = 26},
  [172] = {.lex_state = 26},
  [173] = {.lex_state = 10},
  [174] = {.lex_state = 86},
};

enum {
  ts_external_token_null_character = 0,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_null_character] = sym_null_character,
};

static bool ts_external_scanner_states[2][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_null_character] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_disjunction_delimiter] = ACTIONS(1),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(1),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(1),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(1),
    [aux_sym__invalid_secondary_quantifier_token1] = ACTIONS(1),
    [aux_sym__invalid_secondary_quantifier_token2] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [aux_sym_count_quantifier_token1] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_QMARK_EQ] = ACTIONS(1),
    [anon_sym_QMARK_BANG] = ACTIONS(1),
    [anon_sym_QMARK_LT_EQ] = ACTIONS(1),
    [anon_sym_QMARK_LT_BANG] = ACTIONS(1),
    [anon_sym_BSLASH] = ACTIONS(1),
    [aux_sym_backreference_token1] = ACTIONS(1),
    [anon_sym_BSLASHk_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_QMARK_LT] = ACTIONS(1),
    [aux_sym_group_name_token1] = ACTIONS(1),
    [aux_sym_group_name_token2] = ACTIONS(1),
    [anon_sym_QMARK_COLON] = ACTIONS(1),
    [sym_group_begin] = ACTIONS(1),
    [sym_group_end] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [aux_sym_set_atom_token1] = ACTIONS(1),
    [anon_sym_BSLASHb] = ACTIONS(1),
    [aux_sym_character_class_escape_token1] = ACTIONS(1),
    [aux_sym_character_class_escape_token2] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [aux_sym_identity_escape_token1] = ACTIONS(1),
    [anon_sym_BSLASHu] = ACTIONS(1),
    [anon_sym_BSLASHx] = ACTIONS(1),
    [anon_sym_BSLASHc] = ACTIONS(1),
    [aux_sym_control_letter_escape_token1] = ACTIONS(1),
    [sym_special_escape] = ACTIONS(1),
    [sym_end_assertion] = ACTIONS(1),
    [sym_non_boundary_assertion] = ACTIONS(1),
    [sym_any_character] = ACTIONS(1),
    [sym_non_syntax_character] = ACTIONS(1),
    [sym_null_character] = ACTIONS(1),
  },
  [1] = {
    [sym_regex] = STATE(156),
    [sym_lookahead_assertion] = STATE(24),
    [sym_negative_lookahead_assertion] = STATE(24),
    [sym_lookbehind_assertion] = STATE(24),
    [sym_negative_lookbehind_assertion] = STATE(24),
    [sym_backreference] = STATE(24),
    [sym_named_capturing_group] = STATE(24),
    [sym_non_capturing_group] = STATE(24),
    [sym_anonymous_capturing_group] = STATE(24),
    [sym_character_set] = STATE(24),
    [sym_character_class_escape] = STATE(24),
    [sym_identity_escape] = STATE(24),
    [sym_unicode_escape] = STATE(25),
    [sym_hexadecimal_escape] = STATE(25),
    [sym_control_letter_escape] = STATE(25),
    [sym__escape_operator] = STATE(170),
    [sym_start_assertion] = STATE(24),
    [sym_boundary_assertion] = STATE(24),
    [aux_sym_pattern_repeat1] = STATE(6),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [aux_sym_character_class_escape_token1] = ACTIONS(15),
    [aux_sym_character_class_escape_token2] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHx] = ACTIONS(21),
    [anon_sym_BSLASHc] = ACTIONS(23),
    [sym_special_escape] = ACTIONS(25),
    [sym_end_assertion] = ACTIONS(27),
    [sym_non_boundary_assertion] = ACTIONS(27),
    [sym_any_character] = ACTIONS(27),
    [sym_non_syntax_character] = ACTIONS(27),
    [sym_null_character] = ACTIONS(25),
  },
  [2] = {
    [sym_lookahead_assertion] = STATE(24),
    [sym_negative_lookahead_assertion] = STATE(24),
    [sym_lookbehind_assertion] = STATE(24),
    [sym_negative_lookbehind_assertion] = STATE(24),
    [sym_backreference] = STATE(24),
    [sym_named_capturing_group] = STATE(24),
    [sym_named_capturing_group_identifier] = STATE(19),
    [sym_non_capturing_group] = STATE(24),
    [sym_anonymous_capturing_group] = STATE(24),
    [sym_character_set] = STATE(24),
    [sym_character_class_escape] = STATE(24),
    [sym_identity_escape] = STATE(24),
    [sym_unicode_escape] = STATE(25),
    [sym_hexadecimal_escape] = STATE(25),
    [sym_control_letter_escape] = STATE(25),
    [sym__escape_operator] = STATE(170),
    [sym_start_assertion] = STATE(24),
    [sym_boundary_assertion] = STATE(24),
    [aux_sym_pattern_repeat1] = STATE(5),
    [anon_sym_QMARK_EQ] = ACTIONS(29),
    [anon_sym_QMARK_BANG] = ACTIONS(31),
    [anon_sym_QMARK_LT_EQ] = ACTIONS(33),
    [anon_sym_QMARK_LT_BANG] = ACTIONS(35),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [anon_sym_QMARK_LT] = ACTIONS(37),
    [anon_sym_QMARK_COLON] = ACTIONS(39),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [aux_sym_character_class_escape_token1] = ACTIONS(15),
    [aux_sym_character_class_escape_token2] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHx] = ACTIONS(21),
    [anon_sym_BSLASHc] = ACTIONS(23),
    [sym_special_escape] = ACTIONS(25),
    [sym_end_assertion] = ACTIONS(27),
    [sym_non_boundary_assertion] = ACTIONS(27),
    [sym_any_character] = ACTIONS(27),
    [sym_non_syntax_character] = ACTIONS(27),
    [sym_null_character] = ACTIONS(25),
  },
  [3] = {
    [sym_disjunction] = STATE(140),
    [sym_lookahead_assertion] = STATE(24),
    [sym_negative_lookahead_assertion] = STATE(24),
    [sym_lookbehind_assertion] = STATE(24),
    [sym_negative_lookbehind_assertion] = STATE(24),
    [sym_backreference] = STATE(24),
    [sym_named_capturing_group] = STATE(24),
    [sym_non_capturing_group] = STATE(24),
    [sym_anonymous_capturing_group] = STATE(24),
    [sym_character_set] = STATE(24),
    [sym_character_class_escape] = STATE(24),
    [sym_identity_escape] = STATE(24),
    [sym_unicode_escape] = STATE(25),
    [sym_hexadecimal_escape] = STATE(25),
    [sym_control_letter_escape] = STATE(25),
    [sym__escape_operator] = STATE(170),
    [sym_start_assertion] = STATE(24),
    [sym_boundary_assertion] = STATE(24),
    [aux_sym_pattern_repeat1] = STATE(11),
    [ts_builtin_sym_end] = ACTIONS(43),
    [sym_disjunction_delimiter] = ACTIONS(45),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [aux_sym_character_class_escape_token1] = ACTIONS(15),
    [aux_sym_character_class_escape_token2] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHx] = ACTIONS(21),
    [anon_sym_BSLASHc] = ACTIONS(23),
    [sym_special_escape] = ACTIONS(25),
    [sym_end_assertion] = ACTIONS(27),
    [sym_non_boundary_assertion] = ACTIONS(27),
    [sym_any_character] = ACTIONS(27),
    [sym_non_syntax_character] = ACTIONS(27),
    [sym_null_character] = ACTIONS(25),
  },
  [4] = {
    [sym_disjunction] = STATE(161),
    [sym_lookahead_assertion] = STATE(24),
    [sym_negative_lookahead_assertion] = STATE(24),
    [sym_lookbehind_assertion] = STATE(24),
    [sym_negative_lookbehind_assertion] = STATE(24),
    [sym_backreference] = STATE(24),
    [sym_named_capturing_group] = STATE(24),
    [sym_non_capturing_group] = STATE(24),
    [sym_anonymous_capturing_group] = STATE(24),
    [sym_character_set] = STATE(24),
    [sym_character_class_escape] = STATE(24),
    [sym_identity_escape] = STATE(24),
    [sym_unicode_escape] = STATE(25),
    [sym_hexadecimal_escape] = STATE(25),
    [sym_control_letter_escape] = STATE(25),
    [sym__escape_operator] = STATE(170),
    [sym_start_assertion] = STATE(24),
    [sym_boundary_assertion] = STATE(24),
    [aux_sym_pattern_repeat1] = STATE(11),
    [sym_disjunction_delimiter] = ACTIONS(45),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [aux_sym_character_class_escape_token1] = ACTIONS(15),
    [aux_sym_character_class_escape_token2] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHx] = ACTIONS(21),
    [anon_sym_BSLASHc] = ACTIONS(23),
    [sym_special_escape] = ACTIONS(25),
    [sym_end_assertion] = ACTIONS(27),
    [sym_non_boundary_assertion] = ACTIONS(27),
    [sym_any_character] = ACTIONS(27),
    [sym_non_syntax_character] = ACTIONS(27),
    [sym_null_character] = ACTIONS(25),
  },
  [5] = {
    [sym_disjunction] = STATE(150),
    [sym_lookahead_assertion] = STATE(24),
    [sym_negative_lookahead_assertion] = STATE(24),
    [sym_lookbehind_assertion] = STATE(24),
    [sym_negative_lookbehind_assertion] = STATE(24),
    [sym_backreference] = STATE(24),
    [sym_named_capturing_group] = STATE(24),
    [sym_non_capturing_group] = STATE(24),
    [sym_anonymous_capturing_group] = STATE(24),
    [sym_character_set] = STATE(24),
    [sym_character_class_escape] = STATE(24),
    [sym_identity_escape] = STATE(24),
    [sym_unicode_escape] = STATE(25),
    [sym_hexadecimal_escape] = STATE(25),
    [sym_control_letter_escape] = STATE(25),
    [sym__escape_operator] = STATE(170),
    [sym_start_assertion] = STATE(24),
    [sym_boundary_assertion] = STATE(24),
    [aux_sym_pattern_repeat1] = STATE(11),
    [sym_disjunction_delimiter] = ACTIONS(45),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [aux_sym_character_class_escape_token1] = ACTIONS(15),
    [aux_sym_character_class_escape_token2] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHx] = ACTIONS(21),
    [anon_sym_BSLASHc] = ACTIONS(23),
    [sym_special_escape] = ACTIONS(25),
    [sym_end_assertion] = ACTIONS(27),
    [sym_non_boundary_assertion] = ACTIONS(27),
    [sym_any_character] = ACTIONS(27),
    [sym_non_syntax_character] = ACTIONS(27),
    [sym_null_character] = ACTIONS(25),
  },
  [6] = {
    [sym_disjunction] = STATE(167),
    [sym_lookahead_assertion] = STATE(24),
    [sym_negative_lookahead_assertion] = STATE(24),
    [sym_lookbehind_assertion] = STATE(24),
    [sym_negative_lookbehind_assertion] = STATE(24),
    [sym_backreference] = STATE(24),
    [sym_named_capturing_group] = STATE(24),
    [sym_non_capturing_group] = STATE(24),
    [sym_anonymous_capturing_group] = STATE(24),
    [sym_character_set] = STATE(24),
    [sym_character_class_escape] = STATE(24),
    [sym_identity_escape] = STATE(24),
    [sym_unicode_escape] = STATE(25),
    [sym_hexadecimal_escape] = STATE(25),
    [sym_control_letter_escape] = STATE(25),
    [sym__escape_operator] = STATE(170),
    [sym_start_assertion] = STATE(24),
    [sym_boundary_assertion] = STATE(24),
    [aux_sym_pattern_repeat1] = STATE(11),
    [ts_builtin_sym_end] = ACTIONS(51),
    [sym_disjunction_delimiter] = ACTIONS(45),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [aux_sym_character_class_escape_token1] = ACTIONS(15),
    [aux_sym_character_class_escape_token2] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHx] = ACTIONS(21),
    [anon_sym_BSLASHc] = ACTIONS(23),
    [sym_special_escape] = ACTIONS(25),
    [sym_end_assertion] = ACTIONS(27),
    [sym_non_boundary_assertion] = ACTIONS(27),
    [sym_any_character] = ACTIONS(27),
    [sym_non_syntax_character] = ACTIONS(27),
    [sym_null_character] = ACTIONS(25),
  },
  [7] = {
    [sym_disjunction] = STATE(165),
    [sym_lookahead_assertion] = STATE(24),
    [sym_negative_lookahead_assertion] = STATE(24),
    [sym_lookbehind_assertion] = STATE(24),
    [sym_negative_lookbehind_assertion] = STATE(24),
    [sym_backreference] = STATE(24),
    [sym_named_capturing_group] = STATE(24),
    [sym_non_capturing_group] = STATE(24),
    [sym_anonymous_capturing_group] = STATE(24),
    [sym_character_set] = STATE(24),
    [sym_character_class_escape] = STATE(24),
    [sym_identity_escape] = STATE(24),
    [sym_unicode_escape] = STATE(25),
    [sym_hexadecimal_escape] = STATE(25),
    [sym_control_letter_escape] = STATE(25),
    [sym__escape_operator] = STATE(170),
    [sym_start_assertion] = STATE(24),
    [sym_boundary_assertion] = STATE(24),
    [aux_sym_pattern_repeat1] = STATE(11),
    [sym_disjunction_delimiter] = ACTIONS(45),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [aux_sym_character_class_escape_token1] = ACTIONS(15),
    [aux_sym_character_class_escape_token2] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHx] = ACTIONS(21),
    [anon_sym_BSLASHc] = ACTIONS(23),
    [sym_special_escape] = ACTIONS(25),
    [sym_end_assertion] = ACTIONS(27),
    [sym_non_boundary_assertion] = ACTIONS(27),
    [sym_any_character] = ACTIONS(27),
    [sym_non_syntax_character] = ACTIONS(27),
    [sym_null_character] = ACTIONS(25),
  },
  [8] = {
    [sym_disjunction] = STATE(168),
    [sym_lookahead_assertion] = STATE(24),
    [sym_negative_lookahead_assertion] = STATE(24),
    [sym_lookbehind_assertion] = STATE(24),
    [sym_negative_lookbehind_assertion] = STATE(24),
    [sym_backreference] = STATE(24),
    [sym_named_capturing_group] = STATE(24),
    [sym_non_capturing_group] = STATE(24),
    [sym_anonymous_capturing_group] = STATE(24),
    [sym_character_set] = STATE(24),
    [sym_character_class_escape] = STATE(24),
    [sym_identity_escape] = STATE(24),
    [sym_unicode_escape] = STATE(25),
    [sym_hexadecimal_escape] = STATE(25),
    [sym_control_letter_escape] = STATE(25),
    [sym__escape_operator] = STATE(170),
    [sym_start_assertion] = STATE(24),
    [sym_boundary_assertion] = STATE(24),
    [aux_sym_pattern_repeat1] = STATE(11),
    [sym_disjunction_delimiter] = ACTIONS(45),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [aux_sym_character_class_escape_token1] = ACTIONS(15),
    [aux_sym_character_class_escape_token2] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHx] = ACTIONS(21),
    [anon_sym_BSLASHc] = ACTIONS(23),
    [sym_special_escape] = ACTIONS(25),
    [sym_end_assertion] = ACTIONS(27),
    [sym_non_boundary_assertion] = ACTIONS(27),
    [sym_any_character] = ACTIONS(27),
    [sym_non_syntax_character] = ACTIONS(27),
    [sym_null_character] = ACTIONS(25),
  },
  [9] = {
    [sym_disjunction] = STATE(171),
    [sym_lookahead_assertion] = STATE(24),
    [sym_negative_lookahead_assertion] = STATE(24),
    [sym_lookbehind_assertion] = STATE(24),
    [sym_negative_lookbehind_assertion] = STATE(24),
    [sym_backreference] = STATE(24),
    [sym_named_capturing_group] = STATE(24),
    [sym_non_capturing_group] = STATE(24),
    [sym_anonymous_capturing_group] = STATE(24),
    [sym_character_set] = STATE(24),
    [sym_character_class_escape] = STATE(24),
    [sym_identity_escape] = STATE(24),
    [sym_unicode_escape] = STATE(25),
    [sym_hexadecimal_escape] = STATE(25),
    [sym_control_letter_escape] = STATE(25),
    [sym__escape_operator] = STATE(170),
    [sym_start_assertion] = STATE(24),
    [sym_boundary_assertion] = STATE(24),
    [aux_sym_pattern_repeat1] = STATE(11),
    [sym_disjunction_delimiter] = ACTIONS(45),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [aux_sym_character_class_escape_token1] = ACTIONS(15),
    [aux_sym_character_class_escape_token2] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHx] = ACTIONS(21),
    [anon_sym_BSLASHc] = ACTIONS(23),
    [sym_special_escape] = ACTIONS(25),
    [sym_end_assertion] = ACTIONS(27),
    [sym_non_boundary_assertion] = ACTIONS(27),
    [sym_any_character] = ACTIONS(27),
    [sym_non_syntax_character] = ACTIONS(27),
    [sym_null_character] = ACTIONS(25),
  },
  [10] = {
    [sym_disjunction] = STATE(153),
    [sym_lookahead_assertion] = STATE(24),
    [sym_negative_lookahead_assertion] = STATE(24),
    [sym_lookbehind_assertion] = STATE(24),
    [sym_negative_lookbehind_assertion] = STATE(24),
    [sym_backreference] = STATE(24),
    [sym_named_capturing_group] = STATE(24),
    [sym_non_capturing_group] = STATE(24),
    [sym_anonymous_capturing_group] = STATE(24),
    [sym_character_set] = STATE(24),
    [sym_character_class_escape] = STATE(24),
    [sym_identity_escape] = STATE(24),
    [sym_unicode_escape] = STATE(25),
    [sym_hexadecimal_escape] = STATE(25),
    [sym_control_letter_escape] = STATE(25),
    [sym__escape_operator] = STATE(170),
    [sym_start_assertion] = STATE(24),
    [sym_boundary_assertion] = STATE(24),
    [aux_sym_pattern_repeat1] = STATE(11),
    [sym_disjunction_delimiter] = ACTIONS(45),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [aux_sym_character_class_escape_token1] = ACTIONS(15),
    [aux_sym_character_class_escape_token2] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHx] = ACTIONS(21),
    [anon_sym_BSLASHc] = ACTIONS(23),
    [sym_special_escape] = ACTIONS(25),
    [sym_end_assertion] = ACTIONS(27),
    [sym_non_boundary_assertion] = ACTIONS(27),
    [sym_any_character] = ACTIONS(27),
    [sym_non_syntax_character] = ACTIONS(27),
    [sym_null_character] = ACTIONS(25),
  },
  [11] = {
    [sym_lookahead_assertion] = STATE(24),
    [sym_negative_lookahead_assertion] = STATE(24),
    [sym_lookbehind_assertion] = STATE(24),
    [sym_negative_lookbehind_assertion] = STATE(24),
    [sym_backreference] = STATE(24),
    [sym_named_capturing_group] = STATE(24),
    [sym_non_capturing_group] = STATE(24),
    [sym_anonymous_capturing_group] = STATE(24),
    [sym_character_set] = STATE(24),
    [sym_character_class_escape] = STATE(24),
    [sym_identity_escape] = STATE(24),
    [sym_unicode_escape] = STATE(25),
    [sym_hexadecimal_escape] = STATE(25),
    [sym_control_letter_escape] = STATE(25),
    [sym__escape_operator] = STATE(170),
    [sym_start_assertion] = STATE(24),
    [sym_boundary_assertion] = STATE(24),
    [aux_sym_pattern_repeat1] = STATE(11),
    [ts_builtin_sym_end] = ACTIONS(61),
    [sym_disjunction_delimiter] = ACTIONS(61),
    [anon_sym_BSLASH] = ACTIONS(63),
    [anon_sym_BSLASHk_LT] = ACTIONS(66),
    [sym_group_begin] = ACTIONS(69),
    [sym_group_end] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(72),
    [anon_sym_CARET] = ACTIONS(75),
    [anon_sym_BSLASHb] = ACTIONS(78),
    [aux_sym_character_class_escape_token1] = ACTIONS(81),
    [aux_sym_character_class_escape_token2] = ACTIONS(84),
    [anon_sym_BSLASHu] = ACTIONS(87),
    [anon_sym_BSLASHx] = ACTIONS(90),
    [anon_sym_BSLASHc] = ACTIONS(93),
    [sym_special_escape] = ACTIONS(96),
    [sym_end_assertion] = ACTIONS(99),
    [sym_non_boundary_assertion] = ACTIONS(99),
    [sym_any_character] = ACTIONS(99),
    [sym_non_syntax_character] = ACTIONS(99),
    [sym_null_character] = ACTIONS(96),
  },
  [12] = {
    [sym_disjunction] = STATE(157),
    [sym_lookahead_assertion] = STATE(24),
    [sym_negative_lookahead_assertion] = STATE(24),
    [sym_lookbehind_assertion] = STATE(24),
    [sym_negative_lookbehind_assertion] = STATE(24),
    [sym_backreference] = STATE(24),
    [sym_named_capturing_group] = STATE(24),
    [sym_non_capturing_group] = STATE(24),
    [sym_anonymous_capturing_group] = STATE(24),
    [sym_character_set] = STATE(24),
    [sym_character_class_escape] = STATE(24),
    [sym_identity_escape] = STATE(24),
    [sym_unicode_escape] = STATE(25),
    [sym_hexadecimal_escape] = STATE(25),
    [sym_control_letter_escape] = STATE(25),
    [sym__escape_operator] = STATE(170),
    [sym_start_assertion] = STATE(24),
    [sym_boundary_assertion] = STATE(24),
    [aux_sym_pattern_repeat1] = STATE(11),
    [sym_disjunction_delimiter] = ACTIONS(45),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(102),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [aux_sym_character_class_escape_token1] = ACTIONS(15),
    [aux_sym_character_class_escape_token2] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHx] = ACTIONS(21),
    [anon_sym_BSLASHc] = ACTIONS(23),
    [sym_special_escape] = ACTIONS(25),
    [sym_end_assertion] = ACTIONS(27),
    [sym_non_boundary_assertion] = ACTIONS(27),
    [sym_any_character] = ACTIONS(27),
    [sym_non_syntax_character] = ACTIONS(27),
    [sym_null_character] = ACTIONS(25),
  },
  [13] = {
    [sym_lookahead_assertion] = STATE(24),
    [sym_negative_lookahead_assertion] = STATE(24),
    [sym_lookbehind_assertion] = STATE(24),
    [sym_negative_lookbehind_assertion] = STATE(24),
    [sym_backreference] = STATE(24),
    [sym_named_capturing_group] = STATE(24),
    [sym_non_capturing_group] = STATE(24),
    [sym_anonymous_capturing_group] = STATE(24),
    [sym_character_set] = STATE(24),
    [sym_character_class_escape] = STATE(24),
    [sym_identity_escape] = STATE(24),
    [sym_unicode_escape] = STATE(25),
    [sym_hexadecimal_escape] = STATE(25),
    [sym_control_letter_escape] = STATE(25),
    [sym__escape_operator] = STATE(170),
    [sym_start_assertion] = STATE(24),
    [sym_boundary_assertion] = STATE(24),
    [aux_sym_pattern_repeat1] = STATE(3),
    [ts_builtin_sym_end] = ACTIONS(104),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(104),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [aux_sym_character_class_escape_token1] = ACTIONS(15),
    [aux_sym_character_class_escape_token2] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHx] = ACTIONS(21),
    [anon_sym_BSLASHc] = ACTIONS(23),
    [sym_special_escape] = ACTIONS(25),
    [sym_end_assertion] = ACTIONS(27),
    [sym_non_boundary_assertion] = ACTIONS(27),
    [sym_any_character] = ACTIONS(27),
    [sym_non_syntax_character] = ACTIONS(27),
    [sym_null_character] = ACTIONS(25),
  },
  [14] = {
    [sym_lookahead_assertion] = STATE(24),
    [sym_negative_lookahead_assertion] = STATE(24),
    [sym_lookbehind_assertion] = STATE(24),
    [sym_negative_lookbehind_assertion] = STATE(24),
    [sym_backreference] = STATE(24),
    [sym_named_capturing_group] = STATE(24),
    [sym_non_capturing_group] = STATE(24),
    [sym_anonymous_capturing_group] = STATE(24),
    [sym_character_set] = STATE(24),
    [sym_character_class_escape] = STATE(24),
    [sym_identity_escape] = STATE(24),
    [sym_unicode_escape] = STATE(25),
    [sym_hexadecimal_escape] = STATE(25),
    [sym_control_letter_escape] = STATE(25),
    [sym__escape_operator] = STATE(170),
    [sym_start_assertion] = STATE(24),
    [sym_boundary_assertion] = STATE(24),
    [aux_sym_pattern_repeat1] = STATE(12),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(106),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [aux_sym_character_class_escape_token1] = ACTIONS(15),
    [aux_sym_character_class_escape_token2] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHx] = ACTIONS(21),
    [anon_sym_BSLASHc] = ACTIONS(23),
    [sym_special_escape] = ACTIONS(25),
    [sym_end_assertion] = ACTIONS(27),
    [sym_non_boundary_assertion] = ACTIONS(27),
    [sym_any_character] = ACTIONS(27),
    [sym_non_syntax_character] = ACTIONS(27),
    [sym_null_character] = ACTIONS(25),
  },
  [15] = {
    [sym_lookahead_assertion] = STATE(24),
    [sym_negative_lookahead_assertion] = STATE(24),
    [sym_lookbehind_assertion] = STATE(24),
    [sym_negative_lookbehind_assertion] = STATE(24),
    [sym_backreference] = STATE(24),
    [sym_named_capturing_group] = STATE(24),
    [sym_non_capturing_group] = STATE(24),
    [sym_anonymous_capturing_group] = STATE(24),
    [sym_character_set] = STATE(24),
    [sym_character_class_escape] = STATE(24),
    [sym_identity_escape] = STATE(24),
    [sym_unicode_escape] = STATE(25),
    [sym_hexadecimal_escape] = STATE(25),
    [sym_control_letter_escape] = STATE(25),
    [sym__escape_operator] = STATE(170),
    [sym_start_assertion] = STATE(24),
    [sym_boundary_assertion] = STATE(24),
    [aux_sym_pattern_repeat1] = STATE(4),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(108),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [aux_sym_character_class_escape_token1] = ACTIONS(15),
    [aux_sym_character_class_escape_token2] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHx] = ACTIONS(21),
    [anon_sym_BSLASHc] = ACTIONS(23),
    [sym_special_escape] = ACTIONS(25),
    [sym_end_assertion] = ACTIONS(27),
    [sym_non_boundary_assertion] = ACTIONS(27),
    [sym_any_character] = ACTIONS(27),
    [sym_non_syntax_character] = ACTIONS(27),
    [sym_null_character] = ACTIONS(25),
  },
  [16] = {
    [sym_lookahead_assertion] = STATE(24),
    [sym_negative_lookahead_assertion] = STATE(24),
    [sym_lookbehind_assertion] = STATE(24),
    [sym_negative_lookbehind_assertion] = STATE(24),
    [sym_backreference] = STATE(24),
    [sym_named_capturing_group] = STATE(24),
    [sym_non_capturing_group] = STATE(24),
    [sym_anonymous_capturing_group] = STATE(24),
    [sym_character_set] = STATE(24),
    [sym_character_class_escape] = STATE(24),
    [sym_identity_escape] = STATE(24),
    [sym_unicode_escape] = STATE(25),
    [sym_hexadecimal_escape] = STATE(25),
    [sym_control_letter_escape] = STATE(25),
    [sym__escape_operator] = STATE(170),
    [sym_start_assertion] = STATE(24),
    [sym_boundary_assertion] = STATE(24),
    [aux_sym_pattern_repeat1] = STATE(10),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(110),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [aux_sym_character_class_escape_token1] = ACTIONS(15),
    [aux_sym_character_class_escape_token2] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHx] = ACTIONS(21),
    [anon_sym_BSLASHc] = ACTIONS(23),
    [sym_special_escape] = ACTIONS(25),
    [sym_end_assertion] = ACTIONS(27),
    [sym_non_boundary_assertion] = ACTIONS(27),
    [sym_any_character] = ACTIONS(27),
    [sym_non_syntax_character] = ACTIONS(27),
    [sym_null_character] = ACTIONS(25),
  },
  [17] = {
    [sym_lookahead_assertion] = STATE(24),
    [sym_negative_lookahead_assertion] = STATE(24),
    [sym_lookbehind_assertion] = STATE(24),
    [sym_negative_lookbehind_assertion] = STATE(24),
    [sym_backreference] = STATE(24),
    [sym_named_capturing_group] = STATE(24),
    [sym_non_capturing_group] = STATE(24),
    [sym_anonymous_capturing_group] = STATE(24),
    [sym_character_set] = STATE(24),
    [sym_character_class_escape] = STATE(24),
    [sym_identity_escape] = STATE(24),
    [sym_unicode_escape] = STATE(25),
    [sym_hexadecimal_escape] = STATE(25),
    [sym_control_letter_escape] = STATE(25),
    [sym__escape_operator] = STATE(170),
    [sym_start_assertion] = STATE(24),
    [sym_boundary_assertion] = STATE(24),
    [aux_sym_pattern_repeat1] = STATE(9),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(112),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [aux_sym_character_class_escape_token1] = ACTIONS(15),
    [aux_sym_character_class_escape_token2] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHx] = ACTIONS(21),
    [anon_sym_BSLASHc] = ACTIONS(23),
    [sym_special_escape] = ACTIONS(25),
    [sym_end_assertion] = ACTIONS(27),
    [sym_non_boundary_assertion] = ACTIONS(27),
    [sym_any_character] = ACTIONS(27),
    [sym_non_syntax_character] = ACTIONS(27),
    [sym_null_character] = ACTIONS(25),
  },
  [18] = {
    [sym_lookahead_assertion] = STATE(24),
    [sym_negative_lookahead_assertion] = STATE(24),
    [sym_lookbehind_assertion] = STATE(24),
    [sym_negative_lookbehind_assertion] = STATE(24),
    [sym_backreference] = STATE(24),
    [sym_named_capturing_group] = STATE(24),
    [sym_non_capturing_group] = STATE(24),
    [sym_anonymous_capturing_group] = STATE(24),
    [sym_character_set] = STATE(24),
    [sym_character_class_escape] = STATE(24),
    [sym_identity_escape] = STATE(24),
    [sym_unicode_escape] = STATE(25),
    [sym_hexadecimal_escape] = STATE(25),
    [sym_control_letter_escape] = STATE(25),
    [sym__escape_operator] = STATE(170),
    [sym_start_assertion] = STATE(24),
    [sym_boundary_assertion] = STATE(24),
    [aux_sym_pattern_repeat1] = STATE(8),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(114),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [aux_sym_character_class_escape_token1] = ACTIONS(15),
    [aux_sym_character_class_escape_token2] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHx] = ACTIONS(21),
    [anon_sym_BSLASHc] = ACTIONS(23),
    [sym_special_escape] = ACTIONS(25),
    [sym_end_assertion] = ACTIONS(27),
    [sym_non_boundary_assertion] = ACTIONS(27),
    [sym_any_character] = ACTIONS(27),
    [sym_non_syntax_character] = ACTIONS(27),
    [sym_null_character] = ACTIONS(25),
  },
  [19] = {
    [sym_lookahead_assertion] = STATE(24),
    [sym_negative_lookahead_assertion] = STATE(24),
    [sym_lookbehind_assertion] = STATE(24),
    [sym_negative_lookbehind_assertion] = STATE(24),
    [sym_backreference] = STATE(24),
    [sym_named_capturing_group] = STATE(24),
    [sym_non_capturing_group] = STATE(24),
    [sym_anonymous_capturing_group] = STATE(24),
    [sym_character_set] = STATE(24),
    [sym_character_class_escape] = STATE(24),
    [sym_identity_escape] = STATE(24),
    [sym_unicode_escape] = STATE(25),
    [sym_hexadecimal_escape] = STATE(25),
    [sym_control_letter_escape] = STATE(25),
    [sym__escape_operator] = STATE(170),
    [sym_start_assertion] = STATE(24),
    [sym_boundary_assertion] = STATE(24),
    [aux_sym_pattern_repeat1] = STATE(7),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(116),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [aux_sym_character_class_escape_token1] = ACTIONS(15),
    [aux_sym_character_class_escape_token2] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHx] = ACTIONS(21),
    [anon_sym_BSLASHc] = ACTIONS(23),
    [sym_special_escape] = ACTIONS(25),
    [sym_end_assertion] = ACTIONS(27),
    [sym_non_boundary_assertion] = ACTIONS(27),
    [sym_any_character] = ACTIONS(27),
    [sym_non_syntax_character] = ACTIONS(27),
    [sym_null_character] = ACTIONS(25),
  },
  [20] = {
    [sym_zero_or_more] = STATE(74),
    [sym_one_or_more] = STATE(74),
    [sym_optional] = STATE(74),
    [sym_count_quantifier] = STATE(74),
    [ts_builtin_sym_end] = ACTIONS(61),
    [sym_disjunction_delimiter] = ACTIONS(61),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(118),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(118),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(118),
    [anon_sym_STAR] = ACTIONS(120),
    [anon_sym_QMARK] = ACTIONS(122),
    [anon_sym_PLUS] = ACTIONS(124),
    [anon_sym_LBRACE] = ACTIONS(126),
    [anon_sym_RBRACE] = ACTIONS(128),
    [anon_sym_BSLASH] = ACTIONS(130),
    [anon_sym_BSLASHk_LT] = ACTIONS(61),
    [sym_group_begin] = ACTIONS(61),
    [sym_group_end] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_CARET] = ACTIONS(61),
    [anon_sym_BSLASHb] = ACTIONS(61),
    [aux_sym_character_class_escape_token1] = ACTIONS(61),
    [aux_sym_character_class_escape_token2] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(132),
    [anon_sym_BSLASHu] = ACTIONS(61),
    [anon_sym_BSLASHx] = ACTIONS(61),
    [anon_sym_BSLASHc] = ACTIONS(61),
    [sym_special_escape] = ACTIONS(61),
    [sym_end_assertion] = ACTIONS(61),
    [sym_non_boundary_assertion] = ACTIONS(61),
    [sym_any_character] = ACTIONS(61),
    [sym_non_syntax_character] = ACTIONS(130),
    [sym_null_character] = ACTIONS(61),
  },
  [21] = {
    [sym_zero_or_more] = STATE(75),
    [sym_one_or_more] = STATE(75),
    [sym_optional] = STATE(75),
    [sym_count_quantifier] = STATE(75),
    [ts_builtin_sym_end] = ACTIONS(134),
    [sym_disjunction_delimiter] = ACTIONS(134),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(136),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(136),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(136),
    [anon_sym_STAR] = ACTIONS(120),
    [anon_sym_QMARK] = ACTIONS(122),
    [anon_sym_PLUS] = ACTIONS(124),
    [anon_sym_LBRACE] = ACTIONS(126),
    [anon_sym_BSLASH] = ACTIONS(138),
    [anon_sym_BSLASHk_LT] = ACTIONS(134),
    [sym_group_begin] = ACTIONS(134),
    [sym_group_end] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(134),
    [anon_sym_CARET] = ACTIONS(134),
    [anon_sym_BSLASHb] = ACTIONS(134),
    [aux_sym_character_class_escape_token1] = ACTIONS(134),
    [aux_sym_character_class_escape_token2] = ACTIONS(134),
    [anon_sym_BSLASHu] = ACTIONS(134),
    [anon_sym_BSLASHx] = ACTIONS(134),
    [aux_sym_hexadecimal_escape_token1] = ACTIONS(140),
    [anon_sym_BSLASHc] = ACTIONS(134),
    [sym_special_escape] = ACTIONS(134),
    [sym_end_assertion] = ACTIONS(134),
    [sym_non_boundary_assertion] = ACTIONS(134),
    [sym_any_character] = ACTIONS(134),
    [sym_non_syntax_character] = ACTIONS(138),
    [sym_null_character] = ACTIONS(134),
  },
  [22] = {
    [sym_zero_or_more] = STATE(71),
    [sym_one_or_more] = STATE(71),
    [sym_optional] = STATE(71),
    [sym_count_quantifier] = STATE(71),
    [ts_builtin_sym_end] = ACTIONS(142),
    [sym_disjunction_delimiter] = ACTIONS(142),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(144),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(144),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(144),
    [anon_sym_STAR] = ACTIONS(120),
    [anon_sym_QMARK] = ACTIONS(122),
    [anon_sym_PLUS] = ACTIONS(124),
    [anon_sym_LBRACE] = ACTIONS(126),
    [anon_sym_RBRACE] = ACTIONS(146),
    [anon_sym_BSLASH] = ACTIONS(148),
    [anon_sym_BSLASHk_LT] = ACTIONS(142),
    [sym_group_begin] = ACTIONS(142),
    [sym_group_end] = ACTIONS(142),
    [anon_sym_LBRACK] = ACTIONS(142),
    [anon_sym_CARET] = ACTIONS(142),
    [anon_sym_BSLASHb] = ACTIONS(142),
    [aux_sym_character_class_escape_token1] = ACTIONS(142),
    [aux_sym_character_class_escape_token2] = ACTIONS(142),
    [anon_sym_BSLASHu] = ACTIONS(142),
    [anon_sym_BSLASHx] = ACTIONS(142),
    [anon_sym_BSLASHc] = ACTIONS(142),
    [sym_special_escape] = ACTIONS(142),
    [sym_end_assertion] = ACTIONS(142),
    [sym_non_boundary_assertion] = ACTIONS(142),
    [sym_any_character] = ACTIONS(142),
    [sym_non_syntax_character] = ACTIONS(142),
    [sym_null_character] = ACTIONS(142),
  },
  [23] = {
    [sym_zero_or_more] = STATE(72),
    [sym_one_or_more] = STATE(72),
    [sym_optional] = STATE(72),
    [sym_count_quantifier] = STATE(72),
    [ts_builtin_sym_end] = ACTIONS(150),
    [sym_disjunction_delimiter] = ACTIONS(150),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(152),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(152),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(152),
    [anon_sym_STAR] = ACTIONS(120),
    [anon_sym_QMARK] = ACTIONS(122),
    [anon_sym_PLUS] = ACTIONS(124),
    [anon_sym_LBRACE] = ACTIONS(126),
    [anon_sym_RBRACE] = ACTIONS(154),
    [anon_sym_BSLASH] = ACTIONS(156),
    [anon_sym_BSLASHk_LT] = ACTIONS(150),
    [sym_group_begin] = ACTIONS(150),
    [sym_group_end] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_CARET] = ACTIONS(150),
    [anon_sym_BSLASHb] = ACTIONS(150),
    [aux_sym_character_class_escape_token1] = ACTIONS(150),
    [aux_sym_character_class_escape_token2] = ACTIONS(150),
    [anon_sym_BSLASHu] = ACTIONS(150),
    [anon_sym_BSLASHx] = ACTIONS(150),
    [anon_sym_BSLASHc] = ACTIONS(150),
    [sym_special_escape] = ACTIONS(150),
    [sym_end_assertion] = ACTIONS(150),
    [sym_non_boundary_assertion] = ACTIONS(150),
    [sym_any_character] = ACTIONS(150),
    [sym_non_syntax_character] = ACTIONS(150),
    [sym_null_character] = ACTIONS(150),
  },
  [24] = {
    [sym_zero_or_more] = STATE(75),
    [sym_one_or_more] = STATE(75),
    [sym_optional] = STATE(75),
    [sym_count_quantifier] = STATE(75),
    [ts_builtin_sym_end] = ACTIONS(134),
    [sym_disjunction_delimiter] = ACTIONS(134),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(136),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(136),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(136),
    [anon_sym_STAR] = ACTIONS(120),
    [anon_sym_QMARK] = ACTIONS(122),
    [anon_sym_PLUS] = ACTIONS(124),
    [anon_sym_LBRACE] = ACTIONS(126),
    [anon_sym_BSLASH] = ACTIONS(138),
    [anon_sym_BSLASHk_LT] = ACTIONS(134),
    [sym_group_begin] = ACTIONS(134),
    [sym_group_end] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(134),
    [anon_sym_CARET] = ACTIONS(134),
    [anon_sym_BSLASHb] = ACTIONS(134),
    [aux_sym_character_class_escape_token1] = ACTIONS(134),
    [aux_sym_character_class_escape_token2] = ACTIONS(134),
    [anon_sym_BSLASHu] = ACTIONS(134),
    [anon_sym_BSLASHx] = ACTIONS(134),
    [anon_sym_BSLASHc] = ACTIONS(134),
    [sym_special_escape] = ACTIONS(134),
    [sym_end_assertion] = ACTIONS(134),
    [sym_non_boundary_assertion] = ACTIONS(134),
    [sym_any_character] = ACTIONS(134),
    [sym_non_syntax_character] = ACTIONS(134),
    [sym_null_character] = ACTIONS(134),
  },
  [25] = {
    [sym_zero_or_more] = STATE(75),
    [sym_one_or_more] = STATE(75),
    [sym_optional] = STATE(75),
    [sym_count_quantifier] = STATE(75),
    [ts_builtin_sym_end] = ACTIONS(134),
    [sym_disjunction_delimiter] = ACTIONS(134),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(136),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(136),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(136),
    [anon_sym_STAR] = ACTIONS(120),
    [anon_sym_QMARK] = ACTIONS(122),
    [anon_sym_PLUS] = ACTIONS(124),
    [anon_sym_LBRACE] = ACTIONS(126),
    [anon_sym_BSLASH] = ACTIONS(138),
    [anon_sym_BSLASHk_LT] = ACTIONS(134),
    [sym_group_begin] = ACTIONS(134),
    [sym_group_end] = ACTIONS(134),
    [anon_sym_LBRACK] = ACTIONS(134),
    [anon_sym_CARET] = ACTIONS(134),
    [anon_sym_BSLASHb] = ACTIONS(134),
    [aux_sym_character_class_escape_token1] = ACTIONS(134),
    [aux_sym_character_class_escape_token2] = ACTIONS(134),
    [anon_sym_BSLASHu] = ACTIONS(134),
    [anon_sym_BSLASHx] = ACTIONS(134),
    [anon_sym_BSLASHc] = ACTIONS(134),
    [sym_special_escape] = ACTIONS(134),
    [sym_end_assertion] = ACTIONS(134),
    [sym_non_boundary_assertion] = ACTIONS(134),
    [sym_any_character] = ACTIONS(134),
    [sym_non_syntax_character] = ACTIONS(134),
    [sym_null_character] = ACTIONS(134),
  },
  [26] = {
    [sym_zero_or_more] = STATE(71),
    [sym_one_or_more] = STATE(71),
    [sym_optional] = STATE(71),
    [sym_count_quantifier] = STATE(71),
    [ts_builtin_sym_end] = ACTIONS(142),
    [sym_disjunction_delimiter] = ACTIONS(142),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(144),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(144),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(144),
    [anon_sym_STAR] = ACTIONS(120),
    [anon_sym_QMARK] = ACTIONS(122),
    [anon_sym_PLUS] = ACTIONS(124),
    [anon_sym_LBRACE] = ACTIONS(126),
    [anon_sym_BSLASH] = ACTIONS(148),
    [anon_sym_BSLASHk_LT] = ACTIONS(142),
    [sym_group_begin] = ACTIONS(142),
    [sym_group_end] = ACTIONS(142),
    [anon_sym_LBRACK] = ACTIONS(142),
    [anon_sym_CARET] = ACTIONS(142),
    [anon_sym_BSLASHb] = ACTIONS(142),
    [aux_sym_character_class_escape_token1] = ACTIONS(142),
    [aux_sym_character_class_escape_token2] = ACTIONS(142),
    [anon_sym_BSLASHu] = ACTIONS(142),
    [anon_sym_BSLASHx] = ACTIONS(142),
    [anon_sym_BSLASHc] = ACTIONS(142),
    [sym_special_escape] = ACTIONS(142),
    [sym_end_assertion] = ACTIONS(142),
    [sym_non_boundary_assertion] = ACTIONS(142),
    [sym_any_character] = ACTIONS(142),
    [sym_non_syntax_character] = ACTIONS(142),
    [sym_null_character] = ACTIONS(142),
  },
  [27] = {
    [sym_zero_or_more] = STATE(74),
    [sym_one_or_more] = STATE(74),
    [sym_optional] = STATE(74),
    [sym_count_quantifier] = STATE(74),
    [ts_builtin_sym_end] = ACTIONS(61),
    [sym_disjunction_delimiter] = ACTIONS(61),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(118),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(118),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(118),
    [anon_sym_STAR] = ACTIONS(120),
    [anon_sym_QMARK] = ACTIONS(122),
    [anon_sym_PLUS] = ACTIONS(124),
    [anon_sym_LBRACE] = ACTIONS(126),
    [anon_sym_BSLASH] = ACTIONS(130),
    [anon_sym_BSLASHk_LT] = ACTIONS(61),
    [sym_group_begin] = ACTIONS(61),
    [sym_group_end] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_CARET] = ACTIONS(61),
    [anon_sym_BSLASHb] = ACTIONS(61),
    [aux_sym_character_class_escape_token1] = ACTIONS(61),
    [aux_sym_character_class_escape_token2] = ACTIONS(61),
    [anon_sym_BSLASHu] = ACTIONS(61),
    [anon_sym_BSLASHx] = ACTIONS(61),
    [anon_sym_BSLASHc] = ACTIONS(61),
    [sym_special_escape] = ACTIONS(61),
    [sym_end_assertion] = ACTIONS(61),
    [sym_non_boundary_assertion] = ACTIONS(61),
    [sym_any_character] = ACTIONS(61),
    [sym_non_syntax_character] = ACTIONS(61),
    [sym_null_character] = ACTIONS(61),
  },
  [28] = {
    [ts_builtin_sym_end] = ACTIONS(158),
    [sym_disjunction_delimiter] = ACTIONS(158),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(158),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(158),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(158),
    [anon_sym_STAR] = ACTIONS(158),
    [anon_sym_QMARK] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(158),
    [anon_sym_LBRACE] = ACTIONS(160),
    [anon_sym_BSLASH] = ACTIONS(160),
    [anon_sym_BSLASHk_LT] = ACTIONS(158),
    [sym_group_begin] = ACTIONS(158),
    [sym_group_end] = ACTIONS(158),
    [anon_sym_LBRACK] = ACTIONS(158),
    [anon_sym_CARET] = ACTIONS(158),
    [anon_sym_BSLASHb] = ACTIONS(158),
    [aux_sym_character_class_escape_token1] = ACTIONS(158),
    [aux_sym_character_class_escape_token2] = ACTIONS(158),
    [anon_sym_BSLASHu] = ACTIONS(158),
    [anon_sym_BSLASHx] = ACTIONS(158),
    [anon_sym_BSLASHc] = ACTIONS(158),
    [sym_special_escape] = ACTIONS(158),
    [sym_end_assertion] = ACTIONS(158),
    [sym_non_boundary_assertion] = ACTIONS(158),
    [sym_any_character] = ACTIONS(158),
    [sym_non_syntax_character] = ACTIONS(158),
    [sym_null_character] = ACTIONS(158),
  },
  [29] = {
    [ts_builtin_sym_end] = ACTIONS(162),
    [sym_disjunction_delimiter] = ACTIONS(162),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(162),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(162),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(162),
    [anon_sym_STAR] = ACTIONS(162),
    [anon_sym_QMARK] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_LBRACE] = ACTIONS(164),
    [anon_sym_BSLASH] = ACTIONS(164),
    [anon_sym_BSLASHk_LT] = ACTIONS(162),
    [sym_group_begin] = ACTIONS(162),
    [sym_group_end] = ACTIONS(162),
    [anon_sym_LBRACK] = ACTIONS(162),
    [anon_sym_CARET] = ACTIONS(162),
    [anon_sym_BSLASHb] = ACTIONS(162),
    [aux_sym_character_class_escape_token1] = ACTIONS(162),
    [aux_sym_character_class_escape_token2] = ACTIONS(162),
    [anon_sym_BSLASHu] = ACTIONS(162),
    [anon_sym_BSLASHx] = ACTIONS(162),
    [anon_sym_BSLASHc] = ACTIONS(162),
    [sym_special_escape] = ACTIONS(162),
    [sym_end_assertion] = ACTIONS(162),
    [sym_non_boundary_assertion] = ACTIONS(162),
    [sym_any_character] = ACTIONS(162),
    [sym_non_syntax_character] = ACTIONS(162),
    [sym_null_character] = ACTIONS(162),
  },
  [30] = {
    [ts_builtin_sym_end] = ACTIONS(166),
    [sym_disjunction_delimiter] = ACTIONS(166),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(166),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(166),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(166),
    [anon_sym_STAR] = ACTIONS(166),
    [anon_sym_QMARK] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(166),
    [anon_sym_LBRACE] = ACTIONS(168),
    [anon_sym_BSLASH] = ACTIONS(168),
    [anon_sym_BSLASHk_LT] = ACTIONS(166),
    [sym_group_begin] = ACTIONS(166),
    [sym_group_end] = ACTIONS(166),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_CARET] = ACTIONS(166),
    [anon_sym_BSLASHb] = ACTIONS(166),
    [aux_sym_character_class_escape_token1] = ACTIONS(166),
    [aux_sym_character_class_escape_token2] = ACTIONS(166),
    [anon_sym_BSLASHu] = ACTIONS(166),
    [anon_sym_BSLASHx] = ACTIONS(166),
    [anon_sym_BSLASHc] = ACTIONS(166),
    [sym_special_escape] = ACTIONS(166),
    [sym_end_assertion] = ACTIONS(166),
    [sym_non_boundary_assertion] = ACTIONS(166),
    [sym_any_character] = ACTIONS(166),
    [sym_non_syntax_character] = ACTIONS(166),
    [sym_null_character] = ACTIONS(166),
  },
  [31] = {
    [ts_builtin_sym_end] = ACTIONS(170),
    [sym_disjunction_delimiter] = ACTIONS(170),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(170),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(170),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(170),
    [anon_sym_STAR] = ACTIONS(170),
    [anon_sym_QMARK] = ACTIONS(170),
    [anon_sym_PLUS] = ACTIONS(170),
    [anon_sym_LBRACE] = ACTIONS(172),
    [anon_sym_BSLASH] = ACTIONS(172),
    [anon_sym_BSLASHk_LT] = ACTIONS(170),
    [sym_group_begin] = ACTIONS(170),
    [sym_group_end] = ACTIONS(170),
    [anon_sym_LBRACK] = ACTIONS(170),
    [anon_sym_CARET] = ACTIONS(170),
    [anon_sym_BSLASHb] = ACTIONS(170),
    [aux_sym_character_class_escape_token1] = ACTIONS(170),
    [aux_sym_character_class_escape_token2] = ACTIONS(170),
    [anon_sym_BSLASHu] = ACTIONS(170),
    [anon_sym_BSLASHx] = ACTIONS(170),
    [anon_sym_BSLASHc] = ACTIONS(170),
    [sym_special_escape] = ACTIONS(170),
    [sym_end_assertion] = ACTIONS(170),
    [sym_non_boundary_assertion] = ACTIONS(170),
    [sym_any_character] = ACTIONS(170),
    [sym_non_syntax_character] = ACTIONS(170),
    [sym_null_character] = ACTIONS(170),
  },
  [32] = {
    [ts_builtin_sym_end] = ACTIONS(174),
    [sym_disjunction_delimiter] = ACTIONS(174),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(174),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(174),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(174),
    [anon_sym_STAR] = ACTIONS(174),
    [anon_sym_QMARK] = ACTIONS(174),
    [anon_sym_PLUS] = ACTIONS(174),
    [anon_sym_LBRACE] = ACTIONS(176),
    [anon_sym_BSLASH] = ACTIONS(176),
    [anon_sym_BSLASHk_LT] = ACTIONS(174),
    [sym_group_begin] = ACTIONS(174),
    [sym_group_end] = ACTIONS(174),
    [anon_sym_LBRACK] = ACTIONS(174),
    [anon_sym_CARET] = ACTIONS(174),
    [anon_sym_BSLASHb] = ACTIONS(174),
    [aux_sym_character_class_escape_token1] = ACTIONS(174),
    [aux_sym_character_class_escape_token2] = ACTIONS(174),
    [anon_sym_BSLASHu] = ACTIONS(174),
    [anon_sym_BSLASHx] = ACTIONS(174),
    [anon_sym_BSLASHc] = ACTIONS(174),
    [sym_special_escape] = ACTIONS(174),
    [sym_end_assertion] = ACTIONS(174),
    [sym_non_boundary_assertion] = ACTIONS(174),
    [sym_any_character] = ACTIONS(174),
    [sym_non_syntax_character] = ACTIONS(174),
    [sym_null_character] = ACTIONS(174),
  },
  [33] = {
    [ts_builtin_sym_end] = ACTIONS(178),
    [sym_disjunction_delimiter] = ACTIONS(178),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(178),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(178),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(178),
    [anon_sym_STAR] = ACTIONS(178),
    [anon_sym_QMARK] = ACTIONS(178),
    [anon_sym_PLUS] = ACTIONS(178),
    [anon_sym_LBRACE] = ACTIONS(180),
    [anon_sym_BSLASH] = ACTIONS(180),
    [anon_sym_BSLASHk_LT] = ACTIONS(178),
    [sym_group_begin] = ACTIONS(178),
    [sym_group_end] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(178),
    [anon_sym_CARET] = ACTIONS(178),
    [anon_sym_BSLASHb] = ACTIONS(178),
    [aux_sym_character_class_escape_token1] = ACTIONS(178),
    [aux_sym_character_class_escape_token2] = ACTIONS(178),
    [anon_sym_BSLASHu] = ACTIONS(178),
    [anon_sym_BSLASHx] = ACTIONS(178),
    [anon_sym_BSLASHc] = ACTIONS(178),
    [sym_special_escape] = ACTIONS(178),
    [sym_end_assertion] = ACTIONS(178),
    [sym_non_boundary_assertion] = ACTIONS(178),
    [sym_any_character] = ACTIONS(178),
    [sym_non_syntax_character] = ACTIONS(178),
    [sym_null_character] = ACTIONS(178),
  },
  [34] = {
    [ts_builtin_sym_end] = ACTIONS(182),
    [sym_disjunction_delimiter] = ACTIONS(182),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(182),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(182),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(182),
    [anon_sym_STAR] = ACTIONS(182),
    [anon_sym_QMARK] = ACTIONS(182),
    [anon_sym_PLUS] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(184),
    [anon_sym_BSLASHk_LT] = ACTIONS(182),
    [sym_group_begin] = ACTIONS(182),
    [sym_group_end] = ACTIONS(182),
    [anon_sym_LBRACK] = ACTIONS(182),
    [anon_sym_CARET] = ACTIONS(182),
    [anon_sym_BSLASHb] = ACTIONS(182),
    [aux_sym_character_class_escape_token1] = ACTIONS(182),
    [aux_sym_character_class_escape_token2] = ACTIONS(182),
    [anon_sym_BSLASHu] = ACTIONS(182),
    [anon_sym_BSLASHx] = ACTIONS(182),
    [anon_sym_BSLASHc] = ACTIONS(182),
    [sym_special_escape] = ACTIONS(182),
    [sym_end_assertion] = ACTIONS(182),
    [sym_non_boundary_assertion] = ACTIONS(182),
    [sym_any_character] = ACTIONS(182),
    [sym_non_syntax_character] = ACTIONS(182),
    [sym_null_character] = ACTIONS(182),
  },
  [35] = {
    [ts_builtin_sym_end] = ACTIONS(186),
    [sym_disjunction_delimiter] = ACTIONS(186),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(186),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(186),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(186),
    [anon_sym_STAR] = ACTIONS(186),
    [anon_sym_QMARK] = ACTIONS(186),
    [anon_sym_PLUS] = ACTIONS(186),
    [anon_sym_LBRACE] = ACTIONS(188),
    [anon_sym_BSLASH] = ACTIONS(188),
    [anon_sym_BSLASHk_LT] = ACTIONS(186),
    [sym_group_begin] = ACTIONS(186),
    [sym_group_end] = ACTIONS(186),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_CARET] = ACTIONS(186),
    [anon_sym_BSLASHb] = ACTIONS(186),
    [aux_sym_character_class_escape_token1] = ACTIONS(186),
    [aux_sym_character_class_escape_token2] = ACTIONS(186),
    [anon_sym_BSLASHu] = ACTIONS(186),
    [anon_sym_BSLASHx] = ACTIONS(186),
    [anon_sym_BSLASHc] = ACTIONS(186),
    [sym_special_escape] = ACTIONS(186),
    [sym_end_assertion] = ACTIONS(186),
    [sym_non_boundary_assertion] = ACTIONS(186),
    [sym_any_character] = ACTIONS(186),
    [sym_non_syntax_character] = ACTIONS(186),
    [sym_null_character] = ACTIONS(186),
  },
  [36] = {
    [ts_builtin_sym_end] = ACTIONS(190),
    [sym_disjunction_delimiter] = ACTIONS(190),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(190),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(190),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(190),
    [anon_sym_STAR] = ACTIONS(190),
    [anon_sym_QMARK] = ACTIONS(190),
    [anon_sym_PLUS] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_BSLASH] = ACTIONS(192),
    [anon_sym_BSLASHk_LT] = ACTIONS(190),
    [sym_group_begin] = ACTIONS(190),
    [sym_group_end] = ACTIONS(190),
    [anon_sym_LBRACK] = ACTIONS(190),
    [anon_sym_CARET] = ACTIONS(190),
    [anon_sym_BSLASHb] = ACTIONS(190),
    [aux_sym_character_class_escape_token1] = ACTIONS(190),
    [aux_sym_character_class_escape_token2] = ACTIONS(190),
    [anon_sym_BSLASHu] = ACTIONS(190),
    [anon_sym_BSLASHx] = ACTIONS(190),
    [anon_sym_BSLASHc] = ACTIONS(190),
    [sym_special_escape] = ACTIONS(190),
    [sym_end_assertion] = ACTIONS(190),
    [sym_non_boundary_assertion] = ACTIONS(190),
    [sym_any_character] = ACTIONS(190),
    [sym_non_syntax_character] = ACTIONS(190),
    [sym_null_character] = ACTIONS(190),
  },
  [37] = {
    [ts_builtin_sym_end] = ACTIONS(194),
    [sym_disjunction_delimiter] = ACTIONS(194),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(194),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(194),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(194),
    [anon_sym_STAR] = ACTIONS(194),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_PLUS] = ACTIONS(194),
    [anon_sym_LBRACE] = ACTIONS(196),
    [anon_sym_BSLASH] = ACTIONS(196),
    [anon_sym_BSLASHk_LT] = ACTIONS(194),
    [sym_group_begin] = ACTIONS(194),
    [sym_group_end] = ACTIONS(194),
    [anon_sym_LBRACK] = ACTIONS(194),
    [anon_sym_CARET] = ACTIONS(194),
    [anon_sym_BSLASHb] = ACTIONS(194),
    [aux_sym_character_class_escape_token1] = ACTIONS(194),
    [aux_sym_character_class_escape_token2] = ACTIONS(194),
    [anon_sym_BSLASHu] = ACTIONS(194),
    [anon_sym_BSLASHx] = ACTIONS(194),
    [anon_sym_BSLASHc] = ACTIONS(194),
    [sym_special_escape] = ACTIONS(194),
    [sym_end_assertion] = ACTIONS(194),
    [sym_non_boundary_assertion] = ACTIONS(194),
    [sym_any_character] = ACTIONS(194),
    [sym_non_syntax_character] = ACTIONS(194),
    [sym_null_character] = ACTIONS(194),
  },
  [38] = {
    [ts_builtin_sym_end] = ACTIONS(198),
    [sym_disjunction_delimiter] = ACTIONS(198),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(198),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(198),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(198),
    [anon_sym_STAR] = ACTIONS(198),
    [anon_sym_QMARK] = ACTIONS(198),
    [anon_sym_PLUS] = ACTIONS(198),
    [anon_sym_LBRACE] = ACTIONS(200),
    [anon_sym_BSLASH] = ACTIONS(200),
    [anon_sym_BSLASHk_LT] = ACTIONS(198),
    [sym_group_begin] = ACTIONS(198),
    [sym_group_end] = ACTIONS(198),
    [anon_sym_LBRACK] = ACTIONS(198),
    [anon_sym_CARET] = ACTIONS(198),
    [anon_sym_BSLASHb] = ACTIONS(198),
    [aux_sym_character_class_escape_token1] = ACTIONS(198),
    [aux_sym_character_class_escape_token2] = ACTIONS(198),
    [anon_sym_BSLASHu] = ACTIONS(198),
    [anon_sym_BSLASHx] = ACTIONS(198),
    [anon_sym_BSLASHc] = ACTIONS(198),
    [sym_special_escape] = ACTIONS(198),
    [sym_end_assertion] = ACTIONS(198),
    [sym_non_boundary_assertion] = ACTIONS(198),
    [sym_any_character] = ACTIONS(198),
    [sym_non_syntax_character] = ACTIONS(198),
    [sym_null_character] = ACTIONS(198),
  },
  [39] = {
    [ts_builtin_sym_end] = ACTIONS(202),
    [sym_disjunction_delimiter] = ACTIONS(202),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(202),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(202),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(202),
    [anon_sym_STAR] = ACTIONS(202),
    [anon_sym_QMARK] = ACTIONS(202),
    [anon_sym_PLUS] = ACTIONS(202),
    [anon_sym_LBRACE] = ACTIONS(204),
    [anon_sym_BSLASH] = ACTIONS(204),
    [anon_sym_BSLASHk_LT] = ACTIONS(202),
    [sym_group_begin] = ACTIONS(202),
    [sym_group_end] = ACTIONS(202),
    [anon_sym_LBRACK] = ACTIONS(202),
    [anon_sym_CARET] = ACTIONS(202),
    [anon_sym_BSLASHb] = ACTIONS(202),
    [aux_sym_character_class_escape_token1] = ACTIONS(202),
    [aux_sym_character_class_escape_token2] = ACTIONS(202),
    [anon_sym_BSLASHu] = ACTIONS(202),
    [anon_sym_BSLASHx] = ACTIONS(202),
    [anon_sym_BSLASHc] = ACTIONS(202),
    [sym_special_escape] = ACTIONS(202),
    [sym_end_assertion] = ACTIONS(202),
    [sym_non_boundary_assertion] = ACTIONS(202),
    [sym_any_character] = ACTIONS(202),
    [sym_non_syntax_character] = ACTIONS(202),
    [sym_null_character] = ACTIONS(202),
  },
  [40] = {
    [ts_builtin_sym_end] = ACTIONS(206),
    [sym_disjunction_delimiter] = ACTIONS(206),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(206),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(206),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(206),
    [anon_sym_STAR] = ACTIONS(206),
    [anon_sym_QMARK] = ACTIONS(206),
    [anon_sym_PLUS] = ACTIONS(206),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_BSLASH] = ACTIONS(208),
    [anon_sym_BSLASHk_LT] = ACTIONS(206),
    [sym_group_begin] = ACTIONS(206),
    [sym_group_end] = ACTIONS(206),
    [anon_sym_LBRACK] = ACTIONS(206),
    [anon_sym_CARET] = ACTIONS(206),
    [anon_sym_BSLASHb] = ACTIONS(206),
    [aux_sym_character_class_escape_token1] = ACTIONS(206),
    [aux_sym_character_class_escape_token2] = ACTIONS(206),
    [anon_sym_BSLASHu] = ACTIONS(206),
    [anon_sym_BSLASHx] = ACTIONS(206),
    [anon_sym_BSLASHc] = ACTIONS(206),
    [sym_special_escape] = ACTIONS(206),
    [sym_end_assertion] = ACTIONS(206),
    [sym_non_boundary_assertion] = ACTIONS(206),
    [sym_any_character] = ACTIONS(206),
    [sym_non_syntax_character] = ACTIONS(206),
    [sym_null_character] = ACTIONS(206),
  },
  [41] = {
    [ts_builtin_sym_end] = ACTIONS(210),
    [sym_disjunction_delimiter] = ACTIONS(210),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(210),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(210),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(210),
    [anon_sym_STAR] = ACTIONS(210),
    [anon_sym_QMARK] = ACTIONS(210),
    [anon_sym_PLUS] = ACTIONS(210),
    [anon_sym_LBRACE] = ACTIONS(212),
    [anon_sym_BSLASH] = ACTIONS(212),
    [anon_sym_BSLASHk_LT] = ACTIONS(210),
    [sym_group_begin] = ACTIONS(210),
    [sym_group_end] = ACTIONS(210),
    [anon_sym_LBRACK] = ACTIONS(210),
    [anon_sym_CARET] = ACTIONS(210),
    [anon_sym_BSLASHb] = ACTIONS(210),
    [aux_sym_character_class_escape_token1] = ACTIONS(210),
    [aux_sym_character_class_escape_token2] = ACTIONS(210),
    [anon_sym_BSLASHu] = ACTIONS(210),
    [anon_sym_BSLASHx] = ACTIONS(210),
    [anon_sym_BSLASHc] = ACTIONS(210),
    [sym_special_escape] = ACTIONS(210),
    [sym_end_assertion] = ACTIONS(210),
    [sym_non_boundary_assertion] = ACTIONS(210),
    [sym_any_character] = ACTIONS(210),
    [sym_non_syntax_character] = ACTIONS(210),
    [sym_null_character] = ACTIONS(210),
  },
  [42] = {
    [ts_builtin_sym_end] = ACTIONS(214),
    [sym_disjunction_delimiter] = ACTIONS(214),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(214),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(214),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(214),
    [anon_sym_STAR] = ACTIONS(214),
    [anon_sym_QMARK] = ACTIONS(214),
    [anon_sym_PLUS] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(216),
    [anon_sym_BSLASH] = ACTIONS(216),
    [anon_sym_BSLASHk_LT] = ACTIONS(214),
    [sym_group_begin] = ACTIONS(214),
    [sym_group_end] = ACTIONS(214),
    [anon_sym_LBRACK] = ACTIONS(214),
    [anon_sym_CARET] = ACTIONS(214),
    [anon_sym_BSLASHb] = ACTIONS(214),
    [aux_sym_character_class_escape_token1] = ACTIONS(214),
    [aux_sym_character_class_escape_token2] = ACTIONS(214),
    [anon_sym_BSLASHu] = ACTIONS(214),
    [anon_sym_BSLASHx] = ACTIONS(214),
    [anon_sym_BSLASHc] = ACTIONS(214),
    [sym_special_escape] = ACTIONS(214),
    [sym_end_assertion] = ACTIONS(214),
    [sym_non_boundary_assertion] = ACTIONS(214),
    [sym_any_character] = ACTIONS(214),
    [sym_non_syntax_character] = ACTIONS(214),
    [sym_null_character] = ACTIONS(214),
  },
  [43] = {
    [ts_builtin_sym_end] = ACTIONS(218),
    [sym_disjunction_delimiter] = ACTIONS(218),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(218),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(218),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(218),
    [anon_sym_STAR] = ACTIONS(218),
    [anon_sym_QMARK] = ACTIONS(218),
    [anon_sym_PLUS] = ACTIONS(218),
    [anon_sym_LBRACE] = ACTIONS(220),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_BSLASHk_LT] = ACTIONS(218),
    [sym_group_begin] = ACTIONS(218),
    [sym_group_end] = ACTIONS(218),
    [anon_sym_LBRACK] = ACTIONS(218),
    [anon_sym_CARET] = ACTIONS(218),
    [anon_sym_BSLASHb] = ACTIONS(218),
    [aux_sym_character_class_escape_token1] = ACTIONS(218),
    [aux_sym_character_class_escape_token2] = ACTIONS(218),
    [anon_sym_BSLASHu] = ACTIONS(218),
    [anon_sym_BSLASHx] = ACTIONS(218),
    [anon_sym_BSLASHc] = ACTIONS(218),
    [sym_special_escape] = ACTIONS(218),
    [sym_end_assertion] = ACTIONS(218),
    [sym_non_boundary_assertion] = ACTIONS(218),
    [sym_any_character] = ACTIONS(218),
    [sym_non_syntax_character] = ACTIONS(218),
    [sym_null_character] = ACTIONS(218),
  },
  [44] = {
    [ts_builtin_sym_end] = ACTIONS(222),
    [sym_disjunction_delimiter] = ACTIONS(222),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(222),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(222),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(222),
    [anon_sym_STAR] = ACTIONS(222),
    [anon_sym_QMARK] = ACTIONS(222),
    [anon_sym_PLUS] = ACTIONS(222),
    [anon_sym_LBRACE] = ACTIONS(224),
    [anon_sym_BSLASH] = ACTIONS(224),
    [anon_sym_BSLASHk_LT] = ACTIONS(222),
    [sym_group_begin] = ACTIONS(222),
    [sym_group_end] = ACTIONS(222),
    [anon_sym_LBRACK] = ACTIONS(222),
    [anon_sym_CARET] = ACTIONS(222),
    [anon_sym_BSLASHb] = ACTIONS(222),
    [aux_sym_character_class_escape_token1] = ACTIONS(222),
    [aux_sym_character_class_escape_token2] = ACTIONS(222),
    [anon_sym_BSLASHu] = ACTIONS(222),
    [anon_sym_BSLASHx] = ACTIONS(222),
    [anon_sym_BSLASHc] = ACTIONS(222),
    [sym_special_escape] = ACTIONS(222),
    [sym_end_assertion] = ACTIONS(222),
    [sym_non_boundary_assertion] = ACTIONS(222),
    [sym_any_character] = ACTIONS(222),
    [sym_non_syntax_character] = ACTIONS(222),
    [sym_null_character] = ACTIONS(222),
  },
  [45] = {
    [ts_builtin_sym_end] = ACTIONS(226),
    [sym_disjunction_delimiter] = ACTIONS(226),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(226),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(226),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(226),
    [anon_sym_STAR] = ACTIONS(226),
    [anon_sym_QMARK] = ACTIONS(226),
    [anon_sym_PLUS] = ACTIONS(226),
    [anon_sym_LBRACE] = ACTIONS(228),
    [anon_sym_BSLASH] = ACTIONS(228),
    [anon_sym_BSLASHk_LT] = ACTIONS(226),
    [sym_group_begin] = ACTIONS(226),
    [sym_group_end] = ACTIONS(226),
    [anon_sym_LBRACK] = ACTIONS(226),
    [anon_sym_CARET] = ACTIONS(226),
    [anon_sym_BSLASHb] = ACTIONS(226),
    [aux_sym_character_class_escape_token1] = ACTIONS(226),
    [aux_sym_character_class_escape_token2] = ACTIONS(226),
    [anon_sym_BSLASHu] = ACTIONS(226),
    [anon_sym_BSLASHx] = ACTIONS(226),
    [anon_sym_BSLASHc] = ACTIONS(226),
    [sym_special_escape] = ACTIONS(226),
    [sym_end_assertion] = ACTIONS(226),
    [sym_non_boundary_assertion] = ACTIONS(226),
    [sym_any_character] = ACTIONS(226),
    [sym_non_syntax_character] = ACTIONS(226),
    [sym_null_character] = ACTIONS(226),
  },
  [46] = {
    [ts_builtin_sym_end] = ACTIONS(230),
    [sym_disjunction_delimiter] = ACTIONS(230),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(230),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(230),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(230),
    [anon_sym_STAR] = ACTIONS(230),
    [anon_sym_QMARK] = ACTIONS(230),
    [anon_sym_PLUS] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_BSLASH] = ACTIONS(232),
    [anon_sym_BSLASHk_LT] = ACTIONS(230),
    [sym_group_begin] = ACTIONS(230),
    [sym_group_end] = ACTIONS(230),
    [anon_sym_LBRACK] = ACTIONS(230),
    [anon_sym_CARET] = ACTIONS(230),
    [anon_sym_BSLASHb] = ACTIONS(230),
    [aux_sym_character_class_escape_token1] = ACTIONS(230),
    [aux_sym_character_class_escape_token2] = ACTIONS(230),
    [anon_sym_BSLASHu] = ACTIONS(230),
    [anon_sym_BSLASHx] = ACTIONS(230),
    [anon_sym_BSLASHc] = ACTIONS(230),
    [sym_special_escape] = ACTIONS(230),
    [sym_end_assertion] = ACTIONS(230),
    [sym_non_boundary_assertion] = ACTIONS(230),
    [sym_any_character] = ACTIONS(230),
    [sym_non_syntax_character] = ACTIONS(230),
    [sym_null_character] = ACTIONS(230),
  },
  [47] = {
    [ts_builtin_sym_end] = ACTIONS(234),
    [sym_disjunction_delimiter] = ACTIONS(234),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(234),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(234),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(234),
    [anon_sym_STAR] = ACTIONS(234),
    [anon_sym_QMARK] = ACTIONS(234),
    [anon_sym_PLUS] = ACTIONS(234),
    [anon_sym_LBRACE] = ACTIONS(236),
    [anon_sym_BSLASH] = ACTIONS(236),
    [anon_sym_BSLASHk_LT] = ACTIONS(234),
    [sym_group_begin] = ACTIONS(234),
    [sym_group_end] = ACTIONS(234),
    [anon_sym_LBRACK] = ACTIONS(234),
    [anon_sym_CARET] = ACTIONS(234),
    [anon_sym_BSLASHb] = ACTIONS(234),
    [aux_sym_character_class_escape_token1] = ACTIONS(234),
    [aux_sym_character_class_escape_token2] = ACTIONS(234),
    [anon_sym_BSLASHu] = ACTIONS(234),
    [anon_sym_BSLASHx] = ACTIONS(234),
    [anon_sym_BSLASHc] = ACTIONS(234),
    [sym_special_escape] = ACTIONS(234),
    [sym_end_assertion] = ACTIONS(234),
    [sym_non_boundary_assertion] = ACTIONS(234),
    [sym_any_character] = ACTIONS(234),
    [sym_non_syntax_character] = ACTIONS(234),
    [sym_null_character] = ACTIONS(234),
  },
  [48] = {
    [ts_builtin_sym_end] = ACTIONS(238),
    [sym_disjunction_delimiter] = ACTIONS(238),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(238),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(238),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(238),
    [anon_sym_STAR] = ACTIONS(238),
    [anon_sym_QMARK] = ACTIONS(238),
    [anon_sym_PLUS] = ACTIONS(238),
    [anon_sym_LBRACE] = ACTIONS(240),
    [anon_sym_BSLASH] = ACTIONS(240),
    [anon_sym_BSLASHk_LT] = ACTIONS(238),
    [sym_group_begin] = ACTIONS(238),
    [sym_group_end] = ACTIONS(238),
    [anon_sym_LBRACK] = ACTIONS(238),
    [anon_sym_CARET] = ACTIONS(238),
    [anon_sym_BSLASHb] = ACTIONS(238),
    [aux_sym_character_class_escape_token1] = ACTIONS(238),
    [aux_sym_character_class_escape_token2] = ACTIONS(238),
    [anon_sym_BSLASHu] = ACTIONS(238),
    [anon_sym_BSLASHx] = ACTIONS(238),
    [anon_sym_BSLASHc] = ACTIONS(238),
    [sym_special_escape] = ACTIONS(238),
    [sym_end_assertion] = ACTIONS(238),
    [sym_non_boundary_assertion] = ACTIONS(238),
    [sym_any_character] = ACTIONS(238),
    [sym_non_syntax_character] = ACTIONS(238),
    [sym_null_character] = ACTIONS(238),
  },
  [49] = {
    [ts_builtin_sym_end] = ACTIONS(242),
    [sym_disjunction_delimiter] = ACTIONS(242),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(242),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(242),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(242),
    [anon_sym_STAR] = ACTIONS(242),
    [anon_sym_QMARK] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(242),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_BSLASH] = ACTIONS(244),
    [anon_sym_BSLASHk_LT] = ACTIONS(242),
    [sym_group_begin] = ACTIONS(242),
    [sym_group_end] = ACTIONS(242),
    [anon_sym_LBRACK] = ACTIONS(242),
    [anon_sym_CARET] = ACTIONS(242),
    [anon_sym_BSLASHb] = ACTIONS(242),
    [aux_sym_character_class_escape_token1] = ACTIONS(242),
    [aux_sym_character_class_escape_token2] = ACTIONS(242),
    [anon_sym_BSLASHu] = ACTIONS(242),
    [anon_sym_BSLASHx] = ACTIONS(242),
    [anon_sym_BSLASHc] = ACTIONS(242),
    [sym_special_escape] = ACTIONS(242),
    [sym_end_assertion] = ACTIONS(242),
    [sym_non_boundary_assertion] = ACTIONS(242),
    [sym_any_character] = ACTIONS(242),
    [sym_non_syntax_character] = ACTIONS(242),
    [sym_null_character] = ACTIONS(242),
  },
  [50] = {
    [ts_builtin_sym_end] = ACTIONS(246),
    [sym_disjunction_delimiter] = ACTIONS(246),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(246),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(246),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(246),
    [anon_sym_STAR] = ACTIONS(246),
    [anon_sym_QMARK] = ACTIONS(246),
    [anon_sym_PLUS] = ACTIONS(246),
    [anon_sym_LBRACE] = ACTIONS(248),
    [anon_sym_BSLASH] = ACTIONS(248),
    [anon_sym_BSLASHk_LT] = ACTIONS(246),
    [sym_group_begin] = ACTIONS(246),
    [sym_group_end] = ACTIONS(246),
    [anon_sym_LBRACK] = ACTIONS(246),
    [anon_sym_CARET] = ACTIONS(246),
    [anon_sym_BSLASHb] = ACTIONS(246),
    [aux_sym_character_class_escape_token1] = ACTIONS(246),
    [aux_sym_character_class_escape_token2] = ACTIONS(246),
    [anon_sym_BSLASHu] = ACTIONS(246),
    [anon_sym_BSLASHx] = ACTIONS(246),
    [anon_sym_BSLASHc] = ACTIONS(246),
    [sym_special_escape] = ACTIONS(246),
    [sym_end_assertion] = ACTIONS(246),
    [sym_non_boundary_assertion] = ACTIONS(246),
    [sym_any_character] = ACTIONS(246),
    [sym_non_syntax_character] = ACTIONS(246),
    [sym_null_character] = ACTIONS(246),
  },
  [51] = {
    [ts_builtin_sym_end] = ACTIONS(250),
    [sym_disjunction_delimiter] = ACTIONS(250),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(250),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(250),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(250),
    [anon_sym_STAR] = ACTIONS(250),
    [anon_sym_QMARK] = ACTIONS(250),
    [anon_sym_PLUS] = ACTIONS(250),
    [anon_sym_LBRACE] = ACTIONS(252),
    [anon_sym_BSLASH] = ACTIONS(252),
    [anon_sym_BSLASHk_LT] = ACTIONS(250),
    [sym_group_begin] = ACTIONS(250),
    [sym_group_end] = ACTIONS(250),
    [anon_sym_LBRACK] = ACTIONS(250),
    [anon_sym_CARET] = ACTIONS(250),
    [anon_sym_BSLASHb] = ACTIONS(250),
    [aux_sym_character_class_escape_token1] = ACTIONS(250),
    [aux_sym_character_class_escape_token2] = ACTIONS(250),
    [anon_sym_BSLASHu] = ACTIONS(250),
    [anon_sym_BSLASHx] = ACTIONS(250),
    [anon_sym_BSLASHc] = ACTIONS(250),
    [sym_special_escape] = ACTIONS(250),
    [sym_end_assertion] = ACTIONS(250),
    [sym_non_boundary_assertion] = ACTIONS(250),
    [sym_any_character] = ACTIONS(250),
    [sym_non_syntax_character] = ACTIONS(250),
    [sym_null_character] = ACTIONS(250),
  },
  [52] = {
    [ts_builtin_sym_end] = ACTIONS(254),
    [sym_disjunction_delimiter] = ACTIONS(254),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(254),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(254),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(254),
    [anon_sym_STAR] = ACTIONS(254),
    [anon_sym_QMARK] = ACTIONS(254),
    [anon_sym_PLUS] = ACTIONS(254),
    [anon_sym_LBRACE] = ACTIONS(256),
    [anon_sym_BSLASH] = ACTIONS(256),
    [anon_sym_BSLASHk_LT] = ACTIONS(254),
    [sym_group_begin] = ACTIONS(254),
    [sym_group_end] = ACTIONS(254),
    [anon_sym_LBRACK] = ACTIONS(254),
    [anon_sym_CARET] = ACTIONS(254),
    [anon_sym_BSLASHb] = ACTIONS(254),
    [aux_sym_character_class_escape_token1] = ACTIONS(254),
    [aux_sym_character_class_escape_token2] = ACTIONS(254),
    [anon_sym_BSLASHu] = ACTIONS(254),
    [anon_sym_BSLASHx] = ACTIONS(254),
    [anon_sym_BSLASHc] = ACTIONS(254),
    [sym_special_escape] = ACTIONS(254),
    [sym_end_assertion] = ACTIONS(254),
    [sym_non_boundary_assertion] = ACTIONS(254),
    [sym_any_character] = ACTIONS(254),
    [sym_non_syntax_character] = ACTIONS(254),
    [sym_null_character] = ACTIONS(254),
  },
  [53] = {
    [ts_builtin_sym_end] = ACTIONS(258),
    [sym_disjunction_delimiter] = ACTIONS(258),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(258),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(258),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(258),
    [anon_sym_STAR] = ACTIONS(258),
    [anon_sym_QMARK] = ACTIONS(258),
    [anon_sym_PLUS] = ACTIONS(258),
    [anon_sym_LBRACE] = ACTIONS(260),
    [anon_sym_BSLASH] = ACTIONS(260),
    [anon_sym_BSLASHk_LT] = ACTIONS(258),
    [sym_group_begin] = ACTIONS(258),
    [sym_group_end] = ACTIONS(258),
    [anon_sym_LBRACK] = ACTIONS(258),
    [anon_sym_CARET] = ACTIONS(258),
    [anon_sym_BSLASHb] = ACTIONS(258),
    [aux_sym_character_class_escape_token1] = ACTIONS(258),
    [aux_sym_character_class_escape_token2] = ACTIONS(258),
    [anon_sym_BSLASHu] = ACTIONS(258),
    [anon_sym_BSLASHx] = ACTIONS(258),
    [anon_sym_BSLASHc] = ACTIONS(258),
    [sym_special_escape] = ACTIONS(258),
    [sym_end_assertion] = ACTIONS(258),
    [sym_non_boundary_assertion] = ACTIONS(258),
    [sym_any_character] = ACTIONS(258),
    [sym_non_syntax_character] = ACTIONS(258),
    [sym_null_character] = ACTIONS(258),
  },
  [54] = {
    [ts_builtin_sym_end] = ACTIONS(262),
    [sym_disjunction_delimiter] = ACTIONS(262),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(262),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(262),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(262),
    [anon_sym_STAR] = ACTIONS(262),
    [anon_sym_QMARK] = ACTIONS(262),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_LBRACE] = ACTIONS(264),
    [anon_sym_BSLASH] = ACTIONS(264),
    [anon_sym_BSLASHk_LT] = ACTIONS(262),
    [sym_group_begin] = ACTIONS(262),
    [sym_group_end] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(262),
    [anon_sym_CARET] = ACTIONS(262),
    [anon_sym_BSLASHb] = ACTIONS(262),
    [aux_sym_character_class_escape_token1] = ACTIONS(262),
    [aux_sym_character_class_escape_token2] = ACTIONS(262),
    [anon_sym_BSLASHu] = ACTIONS(262),
    [anon_sym_BSLASHx] = ACTIONS(262),
    [anon_sym_BSLASHc] = ACTIONS(262),
    [sym_special_escape] = ACTIONS(262),
    [sym_end_assertion] = ACTIONS(262),
    [sym_non_boundary_assertion] = ACTIONS(262),
    [sym_any_character] = ACTIONS(262),
    [sym_non_syntax_character] = ACTIONS(262),
    [sym_null_character] = ACTIONS(262),
  },
  [55] = {
    [ts_builtin_sym_end] = ACTIONS(266),
    [sym_disjunction_delimiter] = ACTIONS(266),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(266),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(266),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(266),
    [anon_sym_STAR] = ACTIONS(266),
    [anon_sym_QMARK] = ACTIONS(266),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_BSLASH] = ACTIONS(268),
    [anon_sym_BSLASHk_LT] = ACTIONS(266),
    [sym_group_begin] = ACTIONS(266),
    [sym_group_end] = ACTIONS(266),
    [anon_sym_LBRACK] = ACTIONS(266),
    [anon_sym_CARET] = ACTIONS(266),
    [anon_sym_BSLASHb] = ACTIONS(266),
    [aux_sym_character_class_escape_token1] = ACTIONS(266),
    [aux_sym_character_class_escape_token2] = ACTIONS(266),
    [anon_sym_BSLASHu] = ACTIONS(266),
    [anon_sym_BSLASHx] = ACTIONS(266),
    [anon_sym_BSLASHc] = ACTIONS(266),
    [sym_special_escape] = ACTIONS(266),
    [sym_end_assertion] = ACTIONS(266),
    [sym_non_boundary_assertion] = ACTIONS(266),
    [sym_any_character] = ACTIONS(266),
    [sym_non_syntax_character] = ACTIONS(266),
    [sym_null_character] = ACTIONS(266),
  },
  [56] = {
    [ts_builtin_sym_end] = ACTIONS(270),
    [sym_disjunction_delimiter] = ACTIONS(270),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(270),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(270),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(270),
    [anon_sym_STAR] = ACTIONS(270),
    [anon_sym_QMARK] = ACTIONS(270),
    [anon_sym_PLUS] = ACTIONS(270),
    [anon_sym_LBRACE] = ACTIONS(272),
    [anon_sym_BSLASH] = ACTIONS(272),
    [anon_sym_BSLASHk_LT] = ACTIONS(270),
    [sym_group_begin] = ACTIONS(270),
    [sym_group_end] = ACTIONS(270),
    [anon_sym_LBRACK] = ACTIONS(270),
    [anon_sym_CARET] = ACTIONS(270),
    [anon_sym_BSLASHb] = ACTIONS(270),
    [aux_sym_character_class_escape_token1] = ACTIONS(270),
    [aux_sym_character_class_escape_token2] = ACTIONS(270),
    [anon_sym_BSLASHu] = ACTIONS(270),
    [anon_sym_BSLASHx] = ACTIONS(270),
    [anon_sym_BSLASHc] = ACTIONS(270),
    [sym_special_escape] = ACTIONS(270),
    [sym_end_assertion] = ACTIONS(270),
    [sym_non_boundary_assertion] = ACTIONS(270),
    [sym_any_character] = ACTIONS(270),
    [sym_non_syntax_character] = ACTIONS(270),
    [sym_null_character] = ACTIONS(270),
  },
  [57] = {
    [ts_builtin_sym_end] = ACTIONS(274),
    [sym_disjunction_delimiter] = ACTIONS(274),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(274),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(274),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(274),
    [anon_sym_STAR] = ACTIONS(274),
    [anon_sym_QMARK] = ACTIONS(274),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_LBRACE] = ACTIONS(276),
    [anon_sym_BSLASH] = ACTIONS(276),
    [anon_sym_BSLASHk_LT] = ACTIONS(274),
    [sym_group_begin] = ACTIONS(274),
    [sym_group_end] = ACTIONS(274),
    [anon_sym_LBRACK] = ACTIONS(274),
    [anon_sym_CARET] = ACTIONS(274),
    [anon_sym_BSLASHb] = ACTIONS(274),
    [aux_sym_character_class_escape_token1] = ACTIONS(274),
    [aux_sym_character_class_escape_token2] = ACTIONS(274),
    [anon_sym_BSLASHu] = ACTIONS(274),
    [anon_sym_BSLASHx] = ACTIONS(274),
    [anon_sym_BSLASHc] = ACTIONS(274),
    [sym_special_escape] = ACTIONS(274),
    [sym_end_assertion] = ACTIONS(274),
    [sym_non_boundary_assertion] = ACTIONS(274),
    [sym_any_character] = ACTIONS(274),
    [sym_non_syntax_character] = ACTIONS(274),
    [sym_null_character] = ACTIONS(274),
  },
  [58] = {
    [ts_builtin_sym_end] = ACTIONS(278),
    [sym_disjunction_delimiter] = ACTIONS(278),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(278),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(278),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(278),
    [anon_sym_STAR] = ACTIONS(278),
    [anon_sym_QMARK] = ACTIONS(278),
    [anon_sym_PLUS] = ACTIONS(278),
    [anon_sym_LBRACE] = ACTIONS(280),
    [anon_sym_BSLASH] = ACTIONS(280),
    [anon_sym_BSLASHk_LT] = ACTIONS(278),
    [sym_group_begin] = ACTIONS(278),
    [sym_group_end] = ACTIONS(278),
    [anon_sym_LBRACK] = ACTIONS(278),
    [anon_sym_CARET] = ACTIONS(278),
    [anon_sym_BSLASHb] = ACTIONS(278),
    [aux_sym_character_class_escape_token1] = ACTIONS(278),
    [aux_sym_character_class_escape_token2] = ACTIONS(278),
    [anon_sym_BSLASHu] = ACTIONS(278),
    [anon_sym_BSLASHx] = ACTIONS(278),
    [anon_sym_BSLASHc] = ACTIONS(278),
    [sym_special_escape] = ACTIONS(278),
    [sym_end_assertion] = ACTIONS(278),
    [sym_non_boundary_assertion] = ACTIONS(278),
    [sym_any_character] = ACTIONS(278),
    [sym_non_syntax_character] = ACTIONS(278),
    [sym_null_character] = ACTIONS(278),
  },
  [59] = {
    [ts_builtin_sym_end] = ACTIONS(282),
    [sym_disjunction_delimiter] = ACTIONS(282),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(282),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(282),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(282),
    [anon_sym_STAR] = ACTIONS(282),
    [anon_sym_QMARK] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(282),
    [anon_sym_LBRACE] = ACTIONS(284),
    [anon_sym_BSLASH] = ACTIONS(284),
    [anon_sym_BSLASHk_LT] = ACTIONS(282),
    [sym_group_begin] = ACTIONS(282),
    [sym_group_end] = ACTIONS(282),
    [anon_sym_LBRACK] = ACTIONS(282),
    [anon_sym_CARET] = ACTIONS(282),
    [anon_sym_BSLASHb] = ACTIONS(282),
    [aux_sym_character_class_escape_token1] = ACTIONS(282),
    [aux_sym_character_class_escape_token2] = ACTIONS(282),
    [anon_sym_BSLASHu] = ACTIONS(282),
    [anon_sym_BSLASHx] = ACTIONS(282),
    [anon_sym_BSLASHc] = ACTIONS(282),
    [sym_special_escape] = ACTIONS(282),
    [sym_end_assertion] = ACTIONS(282),
    [sym_non_boundary_assertion] = ACTIONS(282),
    [sym_any_character] = ACTIONS(282),
    [sym_non_syntax_character] = ACTIONS(282),
    [sym_null_character] = ACTIONS(282),
  },
  [60] = {
    [ts_builtin_sym_end] = ACTIONS(286),
    [sym_disjunction_delimiter] = ACTIONS(286),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(286),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(286),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(286),
    [anon_sym_STAR] = ACTIONS(286),
    [anon_sym_QMARK] = ACTIONS(286),
    [anon_sym_PLUS] = ACTIONS(286),
    [anon_sym_LBRACE] = ACTIONS(288),
    [anon_sym_BSLASH] = ACTIONS(288),
    [anon_sym_BSLASHk_LT] = ACTIONS(286),
    [sym_group_begin] = ACTIONS(286),
    [sym_group_end] = ACTIONS(286),
    [anon_sym_LBRACK] = ACTIONS(286),
    [anon_sym_CARET] = ACTIONS(286),
    [anon_sym_BSLASHb] = ACTIONS(286),
    [aux_sym_character_class_escape_token1] = ACTIONS(286),
    [aux_sym_character_class_escape_token2] = ACTIONS(286),
    [anon_sym_BSLASHu] = ACTIONS(286),
    [anon_sym_BSLASHx] = ACTIONS(286),
    [anon_sym_BSLASHc] = ACTIONS(286),
    [sym_special_escape] = ACTIONS(286),
    [sym_end_assertion] = ACTIONS(286),
    [sym_non_boundary_assertion] = ACTIONS(286),
    [sym_any_character] = ACTIONS(286),
    [sym_non_syntax_character] = ACTIONS(286),
    [sym_null_character] = ACTIONS(286),
  },
  [61] = {
    [ts_builtin_sym_end] = ACTIONS(290),
    [sym_disjunction_delimiter] = ACTIONS(290),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(290),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(290),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(290),
    [anon_sym_STAR] = ACTIONS(290),
    [anon_sym_QMARK] = ACTIONS(290),
    [anon_sym_PLUS] = ACTIONS(290),
    [anon_sym_LBRACE] = ACTIONS(292),
    [anon_sym_BSLASH] = ACTIONS(292),
    [anon_sym_BSLASHk_LT] = ACTIONS(290),
    [sym_group_begin] = ACTIONS(290),
    [sym_group_end] = ACTIONS(290),
    [anon_sym_LBRACK] = ACTIONS(290),
    [anon_sym_CARET] = ACTIONS(290),
    [anon_sym_BSLASHb] = ACTIONS(290),
    [aux_sym_character_class_escape_token1] = ACTIONS(290),
    [aux_sym_character_class_escape_token2] = ACTIONS(290),
    [anon_sym_BSLASHu] = ACTIONS(290),
    [anon_sym_BSLASHx] = ACTIONS(290),
    [anon_sym_BSLASHc] = ACTIONS(290),
    [sym_special_escape] = ACTIONS(290),
    [sym_end_assertion] = ACTIONS(290),
    [sym_non_boundary_assertion] = ACTIONS(290),
    [sym_any_character] = ACTIONS(290),
    [sym_non_syntax_character] = ACTIONS(290),
    [sym_null_character] = ACTIONS(290),
  },
  [62] = {
    [ts_builtin_sym_end] = ACTIONS(294),
    [sym_disjunction_delimiter] = ACTIONS(294),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(294),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(294),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(294),
    [anon_sym_STAR] = ACTIONS(294),
    [anon_sym_QMARK] = ACTIONS(294),
    [anon_sym_PLUS] = ACTIONS(294),
    [anon_sym_LBRACE] = ACTIONS(296),
    [anon_sym_BSLASH] = ACTIONS(296),
    [anon_sym_BSLASHk_LT] = ACTIONS(294),
    [sym_group_begin] = ACTIONS(294),
    [sym_group_end] = ACTIONS(294),
    [anon_sym_LBRACK] = ACTIONS(294),
    [anon_sym_CARET] = ACTIONS(294),
    [anon_sym_BSLASHb] = ACTIONS(294),
    [aux_sym_character_class_escape_token1] = ACTIONS(294),
    [aux_sym_character_class_escape_token2] = ACTIONS(294),
    [anon_sym_BSLASHu] = ACTIONS(294),
    [anon_sym_BSLASHx] = ACTIONS(294),
    [anon_sym_BSLASHc] = ACTIONS(294),
    [sym_special_escape] = ACTIONS(294),
    [sym_end_assertion] = ACTIONS(294),
    [sym_non_boundary_assertion] = ACTIONS(294),
    [sym_any_character] = ACTIONS(294),
    [sym_non_syntax_character] = ACTIONS(294),
    [sym_null_character] = ACTIONS(294),
  },
  [63] = {
    [ts_builtin_sym_end] = ACTIONS(298),
    [sym_disjunction_delimiter] = ACTIONS(298),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(298),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(298),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(298),
    [anon_sym_STAR] = ACTIONS(298),
    [anon_sym_QMARK] = ACTIONS(298),
    [anon_sym_PLUS] = ACTIONS(298),
    [anon_sym_LBRACE] = ACTIONS(300),
    [anon_sym_BSLASH] = ACTIONS(300),
    [anon_sym_BSLASHk_LT] = ACTIONS(298),
    [sym_group_begin] = ACTIONS(298),
    [sym_group_end] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(298),
    [anon_sym_CARET] = ACTIONS(298),
    [anon_sym_BSLASHb] = ACTIONS(298),
    [aux_sym_character_class_escape_token1] = ACTIONS(298),
    [aux_sym_character_class_escape_token2] = ACTIONS(298),
    [anon_sym_BSLASHu] = ACTIONS(298),
    [anon_sym_BSLASHx] = ACTIONS(298),
    [anon_sym_BSLASHc] = ACTIONS(298),
    [sym_special_escape] = ACTIONS(298),
    [sym_end_assertion] = ACTIONS(298),
    [sym_non_boundary_assertion] = ACTIONS(298),
    [sym_any_character] = ACTIONS(298),
    [sym_non_syntax_character] = ACTIONS(298),
    [sym_null_character] = ACTIONS(298),
  },
  [64] = {
    [ts_builtin_sym_end] = ACTIONS(302),
    [sym_disjunction_delimiter] = ACTIONS(302),
    [aux_sym__invalid_quantifier_token1] = ACTIONS(302),
    [aux_sym__invalid_quantifier_token2] = ACTIONS(302),
    [aux_sym__invalid_quantifier_token3] = ACTIONS(302),
    [anon_sym_STAR] = ACTIONS(302),
    [anon_sym_QMARK] = ACTIONS(302),
    [anon_sym_PLUS] = ACTIONS(302),
    [anon_sym_LBRACE] = ACTIONS(304),
    [anon_sym_BSLASH] = ACTIONS(304),
    [anon_sym_BSLASHk_LT] = ACTIONS(302),
    [sym_group_begin] = ACTIONS(302),
    [sym_group_end] = ACTIONS(302),
    [anon_sym_LBRACK] = ACTIONS(302),
    [anon_sym_CARET] = ACTIONS(302),
    [anon_sym_BSLASHb] = ACTIONS(302),
    [aux_sym_character_class_escape_token1] = ACTIONS(302),
    [aux_sym_character_class_escape_token2] = ACTIONS(302),
    [anon_sym_BSLASHu] = ACTIONS(302),
    [anon_sym_BSLASHx] = ACTIONS(302),
    [anon_sym_BSLASHc] = ACTIONS(302),
    [sym_special_escape] = ACTIONS(302),
    [sym_end_assertion] = ACTIONS(302),
    [sym_non_boundary_assertion] = ACTIONS(302),
    [sym_any_character] = ACTIONS(302),
    [sym_non_syntax_character] = ACTIONS(302),
    [sym_null_character] = ACTIONS(302),
  },
  [65] = {
    [ts_builtin_sym_end] = ACTIONS(306),
    [sym_disjunction_delimiter] = ACTIONS(306),
    [aux_sym__invalid_secondary_quantifier_token1] = ACTIONS(308),
    [aux_sym__invalid_secondary_quantifier_token2] = ACTIONS(306),
    [anon_sym_QMARK] = ACTIONS(310),
    [anon_sym_BSLASH] = ACTIONS(308),
    [anon_sym_BSLASHk_LT] = ACTIONS(306),
    [sym_group_begin] = ACTIONS(306),
    [sym_group_end] = ACTIONS(306),
    [anon_sym_LBRACK] = ACTIONS(306),
    [anon_sym_CARET] = ACTIONS(306),
    [anon_sym_BSLASHb] = ACTIONS(306),
    [aux_sym_character_class_escape_token1] = ACTIONS(306),
    [aux_sym_character_class_escape_token2] = ACTIONS(306),
    [anon_sym_BSLASHu] = ACTIONS(306),
    [anon_sym_BSLASHx] = ACTIONS(306),
    [anon_sym_BSLASHc] = ACTIONS(306),
    [sym_special_escape] = ACTIONS(306),
    [sym_end_assertion] = ACTIONS(306),
    [sym_non_boundary_assertion] = ACTIONS(306),
    [sym_any_character] = ACTIONS(306),
    [sym_non_syntax_character] = ACTIONS(306),
    [sym_null_character] = ACTIONS(306),
  },
  [66] = {
    [ts_builtin_sym_end] = ACTIONS(312),
    [sym_disjunction_delimiter] = ACTIONS(312),
    [aux_sym__invalid_secondary_quantifier_token1] = ACTIONS(314),
    [aux_sym__invalid_secondary_quantifier_token2] = ACTIONS(312),
    [anon_sym_QMARK] = ACTIONS(316),
    [anon_sym_BSLASH] = ACTIONS(314),
    [anon_sym_BSLASHk_LT] = ACTIONS(312),
    [sym_group_begin] = ACTIONS(312),
    [sym_group_end] = ACTIONS(312),
    [anon_sym_LBRACK] = ACTIONS(312),
    [anon_sym_CARET] = ACTIONS(312),
    [anon_sym_BSLASHb] = ACTIONS(312),
    [aux_sym_character_class_escape_token1] = ACTIONS(312),
    [aux_sym_character_class_escape_token2] = ACTIONS(312),
    [anon_sym_BSLASHu] = ACTIONS(312),
    [anon_sym_BSLASHx] = ACTIONS(312),
    [anon_sym_BSLASHc] = ACTIONS(312),
    [sym_special_escape] = ACTIONS(312),
    [sym_end_assertion] = ACTIONS(312),
    [sym_non_boundary_assertion] = ACTIONS(312),
    [sym_any_character] = ACTIONS(312),
    [sym_non_syntax_character] = ACTIONS(312),
    [sym_null_character] = ACTIONS(312),
  },
  [67] = {
    [ts_builtin_sym_end] = ACTIONS(318),
    [sym_disjunction_delimiter] = ACTIONS(318),
    [aux_sym__invalid_secondary_quantifier_token1] = ACTIONS(320),
    [aux_sym__invalid_secondary_quantifier_token2] = ACTIONS(318),
    [anon_sym_QMARK] = ACTIONS(322),
    [anon_sym_BSLASH] = ACTIONS(320),
    [anon_sym_BSLASHk_LT] = ACTIONS(318),
    [sym_group_begin] = ACTIONS(318),
    [sym_group_end] = ACTIONS(318),
    [anon_sym_LBRACK] = ACTIONS(318),
    [anon_sym_CARET] = ACTIONS(318),
    [anon_sym_BSLASHb] = ACTIONS(318),
    [aux_sym_character_class_escape_token1] = ACTIONS(318),
    [aux_sym_character_class_escape_token2] = ACTIONS(318),
    [anon_sym_BSLASHu] = ACTIONS(318),
    [anon_sym_BSLASHx] = ACTIONS(318),
    [anon_sym_BSLASHc] = ACTIONS(318),
    [sym_special_escape] = ACTIONS(318),
    [sym_end_assertion] = ACTIONS(318),
    [sym_non_boundary_assertion] = ACTIONS(318),
    [sym_any_character] = ACTIONS(318),
    [sym_non_syntax_character] = ACTIONS(318),
    [sym_null_character] = ACTIONS(318),
  },
  [68] = {
    [ts_builtin_sym_end] = ACTIONS(324),
    [sym_disjunction_delimiter] = ACTIONS(324),
    [aux_sym__invalid_secondary_quantifier_token1] = ACTIONS(326),
    [aux_sym__invalid_secondary_quantifier_token2] = ACTIONS(324),
    [anon_sym_QMARK] = ACTIONS(328),
    [anon_sym_BSLASH] = ACTIONS(326),
    [anon_sym_BSLASHk_LT] = ACTIONS(324),
    [sym_group_begin] = ACTIONS(324),
    [sym_group_end] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(324),
    [anon_sym_CARET] = ACTIONS(324),
    [anon_sym_BSLASHb] = ACTIONS(324),
    [aux_sym_character_class_escape_token1] = ACTIONS(324),
    [aux_sym_character_class_escape_token2] = ACTIONS(324),
    [anon_sym_BSLASHu] = ACTIONS(324),
    [anon_sym_BSLASHx] = ACTIONS(324),
    [anon_sym_BSLASHc] = ACTIONS(324),
    [sym_special_escape] = ACTIONS(324),
    [sym_end_assertion] = ACTIONS(324),
    [sym_non_boundary_assertion] = ACTIONS(324),
    [sym_any_character] = ACTIONS(324),
    [sym_non_syntax_character] = ACTIONS(324),
    [sym_null_character] = ACTIONS(324),
  },
  [69] = {
    [ts_builtin_sym_end] = ACTIONS(330),
    [sym_disjunction_delimiter] = ACTIONS(330),
    [aux_sym__invalid_secondary_quantifier_token1] = ACTIONS(332),
    [aux_sym__invalid_secondary_quantifier_token2] = ACTIONS(330),
    [anon_sym_QMARK] = ACTIONS(334),
    [anon_sym_BSLASH] = ACTIONS(332),
    [anon_sym_BSLASHk_LT] = ACTIONS(330),
    [sym_group_begin] = ACTIONS(330),
    [sym_group_end] = ACTIONS(330),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_CARET] = ACTIONS(330),
    [anon_sym_BSLASHb] = ACTIONS(330),
    [aux_sym_character_class_escape_token1] = ACTIONS(330),
    [aux_sym_character_class_escape_token2] = ACTIONS(330),
    [anon_sym_BSLASHu] = ACTIONS(330),
    [anon_sym_BSLASHx] = ACTIONS(330),
    [anon_sym_BSLASHc] = ACTIONS(330),
    [sym_special_escape] = ACTIONS(330),
    [sym_end_assertion] = ACTIONS(330),
    [sym_non_boundary_assertion] = ACTIONS(330),
    [sym_any_character] = ACTIONS(330),
    [sym_non_syntax_character] = ACTIONS(330),
    [sym_null_character] = ACTIONS(330),
  },
  [70] = {
    [ts_builtin_sym_end] = ACTIONS(336),
    [sym_disjunction_delimiter] = ACTIONS(336),
    [aux_sym__invalid_secondary_quantifier_token1] = ACTIONS(338),
    [aux_sym__invalid_secondary_quantifier_token2] = ACTIONS(336),
    [anon_sym_QMARK] = ACTIONS(340),
    [anon_sym_BSLASH] = ACTIONS(338),
    [anon_sym_BSLASHk_LT] = ACTIONS(336),
    [sym_group_begin] = ACTIONS(336),
    [sym_group_end] = ACTIONS(336),
    [anon_sym_LBRACK] = ACTIONS(336),
    [anon_sym_CARET] = ACTIONS(336),
    [anon_sym_BSLASHb] = ACTIONS(336),
    [aux_sym_character_class_escape_token1] = ACTIONS(336),
    [aux_sym_character_class_escape_token2] = ACTIONS(336),
    [anon_sym_BSLASHu] = ACTIONS(336),
    [anon_sym_BSLASHx] = ACTIONS(336),
    [anon_sym_BSLASHc] = ACTIONS(336),
    [sym_special_escape] = ACTIONS(336),
    [sym_end_assertion] = ACTIONS(336),
    [sym_non_boundary_assertion] = ACTIONS(336),
    [sym_any_character] = ACTIONS(336),
    [sym_non_syntax_character] = ACTIONS(336),
    [sym_null_character] = ACTIONS(336),
  },
  [71] = {
    [ts_builtin_sym_end] = ACTIONS(150),
    [sym_disjunction_delimiter] = ACTIONS(150),
    [aux_sym__invalid_secondary_quantifier_token1] = ACTIONS(152),
    [aux_sym__invalid_secondary_quantifier_token2] = ACTIONS(152),
    [anon_sym_BSLASH] = ACTIONS(156),
    [anon_sym_BSLASHk_LT] = ACTIONS(150),
    [sym_group_begin] = ACTIONS(150),
    [sym_group_end] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_CARET] = ACTIONS(150),
    [anon_sym_BSLASHb] = ACTIONS(150),
    [aux_sym_character_class_escape_token1] = ACTIONS(150),
    [aux_sym_character_class_escape_token2] = ACTIONS(150),
    [anon_sym_BSLASHu] = ACTIONS(150),
    [anon_sym_BSLASHx] = ACTIONS(150),
    [anon_sym_BSLASHc] = ACTIONS(150),
    [sym_special_escape] = ACTIONS(150),
    [sym_end_assertion] = ACTIONS(150),
    [sym_non_boundary_assertion] = ACTIONS(150),
    [sym_any_character] = ACTIONS(150),
    [sym_non_syntax_character] = ACTIONS(150),
    [sym_null_character] = ACTIONS(150),
  },
  [72] = {
    [ts_builtin_sym_end] = ACTIONS(342),
    [sym_disjunction_delimiter] = ACTIONS(342),
    [aux_sym__invalid_secondary_quantifier_token1] = ACTIONS(344),
    [aux_sym__invalid_secondary_quantifier_token2] = ACTIONS(344),
    [anon_sym_BSLASH] = ACTIONS(346),
    [anon_sym_BSLASHk_LT] = ACTIONS(342),
    [sym_group_begin] = ACTIONS(342),
    [sym_group_end] = ACTIONS(342),
    [anon_sym_LBRACK] = ACTIONS(342),
    [anon_sym_CARET] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(342),
    [aux_sym_character_class_escape_token1] = ACTIONS(342),
    [aux_sym_character_class_escape_token2] = ACTIONS(342),
    [anon_sym_BSLASHu] = ACTIONS(342),
    [anon_sym_BSLASHx] = ACTIONS(342),
    [anon_sym_BSLASHc] = ACTIONS(342),
    [sym_special_escape] = ACTIONS(342),
    [sym_end_assertion] = ACTIONS(342),
    [sym_non_boundary_assertion] = ACTIONS(342),
    [sym_any_character] = ACTIONS(342),
    [sym_non_syntax_character] = ACTIONS(342),
    [sym_null_character] = ACTIONS(342),
  },
  [73] = {
    [ts_builtin_sym_end] = ACTIONS(348),
    [sym_disjunction_delimiter] = ACTIONS(348),
    [aux_sym__invalid_secondary_quantifier_token1] = ACTIONS(348),
    [aux_sym__invalid_secondary_quantifier_token2] = ACTIONS(348),
    [anon_sym_BSLASH] = ACTIONS(350),
    [anon_sym_BSLASHk_LT] = ACTIONS(348),
    [sym_group_begin] = ACTIONS(348),
    [sym_group_end] = ACTIONS(348),
    [anon_sym_LBRACK] = ACTIONS(348),
    [anon_sym_CARET] = ACTIONS(348),
    [anon_sym_BSLASHb] = ACTIONS(348),
    [aux_sym_character_class_escape_token1] = ACTIONS(348),
    [aux_sym_character_class_escape_token2] = ACTIONS(348),
    [anon_sym_BSLASHu] = ACTIONS(348),
    [anon_sym_BSLASHx] = ACTIONS(348),
    [anon_sym_BSLASHc] = ACTIONS(348),
    [sym_special_escape] = ACTIONS(348),
    [sym_end_assertion] = ACTIONS(348),
    [sym_non_boundary_assertion] = ACTIONS(348),
    [sym_any_character] = ACTIONS(348),
    [sym_non_syntax_character] = ACTIONS(348),
    [sym_null_character] = ACTIONS(348),
  },
  [74] = {
    [ts_builtin_sym_end] = ACTIONS(142),
    [sym_disjunction_delimiter] = ACTIONS(142),
    [aux_sym__invalid_secondary_quantifier_token1] = ACTIONS(144),
    [aux_sym__invalid_secondary_quantifier_token2] = ACTIONS(144),
    [anon_sym_BSLASH] = ACTIONS(148),
    [anon_sym_BSLASHk_LT] = ACTIONS(142),
    [sym_group_begin] = ACTIONS(142),
    [sym_group_end] = ACTIONS(142),
    [anon_sym_LBRACK] = ACTIONS(142),
    [anon_sym_CARET] = ACTIONS(142),
    [anon_sym_BSLASHb] = ACTIONS(142),
    [aux_sym_character_class_escape_token1] = ACTIONS(142),
    [aux_sym_character_class_escape_token2] = ACTIONS(142),
    [anon_sym_BSLASHu] = ACTIONS(142),
    [anon_sym_BSLASHx] = ACTIONS(142),
    [anon_sym_BSLASHc] = ACTIONS(142),
    [sym_special_escape] = ACTIONS(142),
    [sym_end_assertion] = ACTIONS(142),
    [sym_non_boundary_assertion] = ACTIONS(142),
    [sym_any_character] = ACTIONS(142),
    [sym_non_syntax_character] = ACTIONS(142),
    [sym_null_character] = ACTIONS(142),
  },
  [75] = {
    [ts_builtin_sym_end] = ACTIONS(61),
    [sym_disjunction_delimiter] = ACTIONS(61),
    [aux_sym__invalid_secondary_quantifier_token1] = ACTIONS(118),
    [aux_sym__invalid_secondary_quantifier_token2] = ACTIONS(118),
    [anon_sym_BSLASH] = ACTIONS(130),
    [anon_sym_BSLASHk_LT] = ACTIONS(61),
    [sym_group_begin] = ACTIONS(61),
    [sym_group_end] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_CARET] = ACTIONS(61),
    [anon_sym_BSLASHb] = ACTIONS(61),
    [aux_sym_character_class_escape_token1] = ACTIONS(61),
    [aux_sym_character_class_escape_token2] = ACTIONS(61),
    [anon_sym_BSLASHu] = ACTIONS(61),
    [anon_sym_BSLASHx] = ACTIONS(61),
    [anon_sym_BSLASHc] = ACTIONS(61),
    [sym_special_escape] = ACTIONS(61),
    [sym_end_assertion] = ACTIONS(61),
    [sym_non_boundary_assertion] = ACTIONS(61),
    [sym_any_character] = ACTIONS(61),
    [sym_non_syntax_character] = ACTIONS(61),
    [sym_null_character] = ACTIONS(61),
  },
  [76] = {
    [ts_builtin_sym_end] = ACTIONS(352),
    [sym_disjunction_delimiter] = ACTIONS(352),
    [aux_sym__invalid_secondary_quantifier_token1] = ACTIONS(352),
    [aux_sym__invalid_secondary_quantifier_token2] = ACTIONS(352),
    [anon_sym_BSLASH] = ACTIONS(354),
    [anon_sym_BSLASHk_LT] = ACTIONS(352),
    [sym_group_begin] = ACTIONS(352),
    [sym_group_end] = ACTIONS(352),
    [anon_sym_LBRACK] = ACTIONS(352),
    [anon_sym_CARET] = ACTIONS(352),
    [anon_sym_BSLASHb] = ACTIONS(352),
    [aux_sym_character_class_escape_token1] = ACTIONS(352),
    [aux_sym_character_class_escape_token2] = ACTIONS(352),
    [anon_sym_BSLASHu] = ACTIONS(352),
    [anon_sym_BSLASHx] = ACTIONS(352),
    [anon_sym_BSLASHc] = ACTIONS(352),
    [sym_special_escape] = ACTIONS(352),
    [sym_end_assertion] = ACTIONS(352),
    [sym_non_boundary_assertion] = ACTIONS(352),
    [sym_any_character] = ACTIONS(352),
    [sym_non_syntax_character] = ACTIONS(352),
    [sym_null_character] = ACTIONS(352),
  },
  [77] = {
    [ts_builtin_sym_end] = ACTIONS(356),
    [sym_disjunction_delimiter] = ACTIONS(356),
    [aux_sym__invalid_secondary_quantifier_token1] = ACTIONS(356),
    [aux_sym__invalid_secondary_quantifier_token2] = ACTIONS(356),
    [anon_sym_BSLASH] = ACTIONS(358),
    [anon_sym_BSLASHk_LT] = ACTIONS(356),
    [sym_group_begin] = ACTIONS(356),
    [sym_group_end] = ACTIONS(356),
    [anon_sym_LBRACK] = ACTIONS(356),
    [anon_sym_CARET] = ACTIONS(356),
    [anon_sym_BSLASHb] = ACTIONS(356),
    [aux_sym_character_class_escape_token1] = ACTIONS(356),
    [aux_sym_character_class_escape_token2] = ACTIONS(356),
    [anon_sym_BSLASHu] = ACTIONS(356),
    [anon_sym_BSLASHx] = ACTIONS(356),
    [anon_sym_BSLASHc] = ACTIONS(356),
    [sym_special_escape] = ACTIONS(356),
    [sym_end_assertion] = ACTIONS(356),
    [sym_non_boundary_assertion] = ACTIONS(356),
    [sym_any_character] = ACTIONS(356),
    [sym_non_syntax_character] = ACTIONS(356),
    [sym_null_character] = ACTIONS(356),
  },
  [78] = {
    [ts_builtin_sym_end] = ACTIONS(360),
    [sym_disjunction_delimiter] = ACTIONS(360),
    [aux_sym__invalid_secondary_quantifier_token1] = ACTIONS(360),
    [aux_sym__invalid_secondary_quantifier_token2] = ACTIONS(360),
    [anon_sym_BSLASH] = ACTIONS(362),
    [anon_sym_BSLASHk_LT] = ACTIONS(360),
    [sym_group_begin] = ACTIONS(360),
    [sym_group_end] = ACTIONS(360),
    [anon_sym_LBRACK] = ACTIONS(360),
    [anon_sym_CARET] = ACTIONS(360),
    [anon_sym_BSLASHb] = ACTIONS(360),
    [aux_sym_character_class_escape_token1] = ACTIONS(360),
    [aux_sym_character_class_escape_token2] = ACTIONS(360),
    [anon_sym_BSLASHu] = ACTIONS(360),
    [anon_sym_BSLASHx] = ACTIONS(360),
    [anon_sym_BSLASHc] = ACTIONS(360),
    [sym_special_escape] = ACTIONS(360),
    [sym_end_assertion] = ACTIONS(360),
    [sym_non_boundary_assertion] = ACTIONS(360),
    [sym_any_character] = ACTIONS(360),
    [sym_non_syntax_character] = ACTIONS(360),
    [sym_null_character] = ACTIONS(360),
  },
  [79] = {
    [ts_builtin_sym_end] = ACTIONS(364),
    [sym_disjunction_delimiter] = ACTIONS(364),
    [aux_sym__invalid_secondary_quantifier_token1] = ACTIONS(364),
    [aux_sym__invalid_secondary_quantifier_token2] = ACTIONS(364),
    [anon_sym_BSLASH] = ACTIONS(366),
    [anon_sym_BSLASHk_LT] = ACTIONS(364),
    [sym_group_begin] = ACTIONS(364),
    [sym_group_end] = ACTIONS(364),
    [anon_sym_LBRACK] = ACTIONS(364),
    [anon_sym_CARET] = ACTIONS(364),
    [anon_sym_BSLASHb] = ACTIONS(364),
    [aux_sym_character_class_escape_token1] = ACTIONS(364),
    [aux_sym_character_class_escape_token2] = ACTIONS(364),
    [anon_sym_BSLASHu] = ACTIONS(364),
    [anon_sym_BSLASHx] = ACTIONS(364),
    [anon_sym_BSLASHc] = ACTIONS(364),
    [sym_special_escape] = ACTIONS(364),
    [sym_end_assertion] = ACTIONS(364),
    [sym_non_boundary_assertion] = ACTIONS(364),
    [sym_any_character] = ACTIONS(364),
    [sym_non_syntax_character] = ACTIONS(364),
    [sym_null_character] = ACTIONS(364),
  },
  [80] = {
    [ts_builtin_sym_end] = ACTIONS(368),
    [sym_disjunction_delimiter] = ACTIONS(368),
    [aux_sym__invalid_secondary_quantifier_token1] = ACTIONS(368),
    [aux_sym__invalid_secondary_quantifier_token2] = ACTIONS(368),
    [anon_sym_BSLASH] = ACTIONS(370),
    [anon_sym_BSLASHk_LT] = ACTIONS(368),
    [sym_group_begin] = ACTIONS(368),
    [sym_group_end] = ACTIONS(368),
    [anon_sym_LBRACK] = ACTIONS(368),
    [anon_sym_CARET] = ACTIONS(368),
    [anon_sym_BSLASHb] = ACTIONS(368),
    [aux_sym_character_class_escape_token1] = ACTIONS(368),
    [aux_sym_character_class_escape_token2] = ACTIONS(368),
    [anon_sym_BSLASHu] = ACTIONS(368),
    [anon_sym_BSLASHx] = ACTIONS(368),
    [anon_sym_BSLASHc] = ACTIONS(368),
    [sym_special_escape] = ACTIONS(368),
    [sym_end_assertion] = ACTIONS(368),
    [sym_non_boundary_assertion] = ACTIONS(368),
    [sym_any_character] = ACTIONS(368),
    [sym_non_syntax_character] = ACTIONS(368),
    [sym_null_character] = ACTIONS(368),
  },
  [81] = {
    [sym_set_range] = STATE(84),
    [sym_set_identity_escape] = STATE(102),
    [sym_character_class_escape] = STATE(111),
    [sym_identity_escape] = STATE(102),
    [sym_unicode_escape] = STATE(108),
    [sym_hexadecimal_escape] = STATE(108),
    [sym_control_letter_escape] = STATE(108),
    [sym__escape_operator] = STATE(148),
    [aux_sym_character_set_repeat1] = STATE(84),
    [anon_sym_BSLASH] = ACTIONS(372),
    [anon_sym_CARET] = ACTIONS(374),
    [anon_sym_RBRACK] = ACTIONS(376),
    [aux_sym_set_atom_token1] = ACTIONS(378),
    [anon_sym_BSLASHb] = ACTIONS(380),
    [aux_sym_character_class_escape_token1] = ACTIONS(382),
    [aux_sym_character_class_escape_token2] = ACTIONS(384),
    [anon_sym_BSLASHu] = ACTIONS(386),
    [anon_sym_BSLASHx] = ACTIONS(388),
    [anon_sym_BSLASHc] = ACTIONS(390),
    [sym_special_escape] = ACTIONS(392),
    [sym_null_character] = ACTIONS(392),
  },
  [82] = {
    [ts_builtin_sym_end] = ACTIONS(61),
    [sym_disjunction_delimiter] = ACTIONS(61),
    [anon_sym_BSLASH] = ACTIONS(130),
    [anon_sym_BSLASHk_LT] = ACTIONS(61),
    [sym_group_begin] = ACTIONS(61),
    [sym_group_end] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_CARET] = ACTIONS(61),
    [anon_sym_BSLASHb] = ACTIONS(61),
    [aux_sym_character_class_escape_token1] = ACTIONS(61),
    [aux_sym_character_class_escape_token2] = ACTIONS(61),
    [anon_sym_BSLASHu] = ACTIONS(61),
    [anon_sym_BSLASHx] = ACTIONS(61),
    [anon_sym_BSLASHc] = ACTIONS(61),
    [sym_special_escape] = ACTIONS(61),
    [sym_end_assertion] = ACTIONS(61),
    [sym_non_boundary_assertion] = ACTIONS(61),
    [sym_any_character] = ACTIONS(61),
    [sym_non_syntax_character] = ACTIONS(61),
    [sym_null_character] = ACTIONS(61),
  },
  [83] = {
    [sym_set_range] = STATE(85),
    [sym_set_identity_escape] = STATE(102),
    [sym_character_class_escape] = STATE(111),
    [sym_identity_escape] = STATE(102),
    [sym_unicode_escape] = STATE(108),
    [sym_hexadecimal_escape] = STATE(108),
    [sym_control_letter_escape] = STATE(108),
    [sym__escape_operator] = STATE(148),
    [aux_sym_character_set_repeat1] = STATE(85),
    [anon_sym_BSLASH] = ACTIONS(372),
    [anon_sym_RBRACK] = ACTIONS(394),
    [aux_sym_set_atom_token1] = ACTIONS(396),
    [anon_sym_BSLASHb] = ACTIONS(380),
    [aux_sym_character_class_escape_token1] = ACTIONS(382),
    [aux_sym_character_class_escape_token2] = ACTIONS(384),
    [anon_sym_BSLASHu] = ACTIONS(386),
    [anon_sym_BSLASHx] = ACTIONS(388),
    [anon_sym_BSLASHc] = ACTIONS(390),
    [sym_special_escape] = ACTIONS(392),
    [sym_null_character] = ACTIONS(392),
  },
  [84] = {
    [sym_set_range] = STATE(85),
    [sym_set_identity_escape] = STATE(102),
    [sym_character_class_escape] = STATE(111),
    [sym_identity_escape] = STATE(102),
    [sym_unicode_escape] = STATE(108),
    [sym_hexadecimal_escape] = STATE(108),
    [sym_control_letter_escape] = STATE(108),
    [sym__escape_operator] = STATE(148),
    [aux_sym_character_set_repeat1] = STATE(85),
    [anon_sym_BSLASH] = ACTIONS(372),
    [anon_sym_RBRACK] = ACTIONS(398),
    [aux_sym_set_atom_token1] = ACTIONS(396),
    [anon_sym_BSLASHb] = ACTIONS(380),
    [aux_sym_character_class_escape_token1] = ACTIONS(382),
    [aux_sym_character_class_escape_token2] = ACTIONS(384),
    [anon_sym_BSLASHu] = ACTIONS(386),
    [anon_sym_BSLASHx] = ACTIONS(388),
    [anon_sym_BSLASHc] = ACTIONS(390),
    [sym_special_escape] = ACTIONS(392),
    [sym_null_character] = ACTIONS(392),
  },
  [85] = {
    [sym_set_range] = STATE(85),
    [sym_set_identity_escape] = STATE(102),
    [sym_character_class_escape] = STATE(111),
    [sym_identity_escape] = STATE(102),
    [sym_unicode_escape] = STATE(108),
    [sym_hexadecimal_escape] = STATE(108),
    [sym_control_letter_escape] = STATE(108),
    [sym__escape_operator] = STATE(148),
    [aux_sym_character_set_repeat1] = STATE(85),
    [anon_sym_BSLASH] = ACTIONS(400),
    [anon_sym_RBRACK] = ACTIONS(403),
    [aux_sym_set_atom_token1] = ACTIONS(405),
    [anon_sym_BSLASHb] = ACTIONS(408),
    [aux_sym_character_class_escape_token1] = ACTIONS(411),
    [aux_sym_character_class_escape_token2] = ACTIONS(414),
    [anon_sym_BSLASHu] = ACTIONS(417),
    [anon_sym_BSLASHx] = ACTIONS(420),
    [anon_sym_BSLASHc] = ACTIONS(423),
    [sym_special_escape] = ACTIONS(426),
    [sym_null_character] = ACTIONS(426),
  },
  [86] = {
    [ts_builtin_sym_end] = ACTIONS(150),
    [sym_disjunction_delimiter] = ACTIONS(150),
    [anon_sym_BSLASH] = ACTIONS(156),
    [anon_sym_BSLASHk_LT] = ACTIONS(150),
    [sym_group_begin] = ACTIONS(150),
    [sym_group_end] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_CARET] = ACTIONS(150),
    [anon_sym_BSLASHb] = ACTIONS(150),
    [aux_sym_character_class_escape_token1] = ACTIONS(150),
    [aux_sym_character_class_escape_token2] = ACTIONS(150),
    [anon_sym_BSLASHu] = ACTIONS(150),
    [anon_sym_BSLASHx] = ACTIONS(150),
    [anon_sym_BSLASHc] = ACTIONS(150),
    [sym_special_escape] = ACTIONS(150),
    [sym_end_assertion] = ACTIONS(150),
    [sym_non_boundary_assertion] = ACTIONS(150),
    [sym_any_character] = ACTIONS(150),
    [sym_non_syntax_character] = ACTIONS(150),
    [sym_null_character] = ACTIONS(150),
  },
  [87] = {
    [sym_set_range] = STATE(83),
    [sym_set_identity_escape] = STATE(102),
    [sym_character_class_escape] = STATE(111),
    [sym_identity_escape] = STATE(102),
    [sym_unicode_escape] = STATE(108),
    [sym_hexadecimal_escape] = STATE(108),
    [sym_control_letter_escape] = STATE(108),
    [sym__escape_operator] = STATE(148),
    [aux_sym_character_set_repeat1] = STATE(83),
    [anon_sym_BSLASH] = ACTIONS(372),
    [anon_sym_RBRACK] = ACTIONS(429),
    [aux_sym_set_atom_token1] = ACTIONS(396),
    [anon_sym_BSLASHb] = ACTIONS(380),
    [aux_sym_character_class_escape_token1] = ACTIONS(382),
    [aux_sym_character_class_escape_token2] = ACTIONS(384),
    [anon_sym_BSLASHu] = ACTIONS(386),
    [anon_sym_BSLASHx] = ACTIONS(388),
    [anon_sym_BSLASHc] = ACTIONS(390),
    [sym_special_escape] = ACTIONS(392),
    [sym_null_character] = ACTIONS(392),
  },
  [88] = {
    [ts_builtin_sym_end] = ACTIONS(342),
    [sym_disjunction_delimiter] = ACTIONS(342),
    [anon_sym_BSLASH] = ACTIONS(346),
    [anon_sym_BSLASHk_LT] = ACTIONS(342),
    [sym_group_begin] = ACTIONS(342),
    [sym_group_end] = ACTIONS(342),
    [anon_sym_LBRACK] = ACTIONS(342),
    [anon_sym_CARET] = ACTIONS(342),
    [anon_sym_BSLASHb] = ACTIONS(342),
    [aux_sym_character_class_escape_token1] = ACTIONS(342),
    [aux_sym_character_class_escape_token2] = ACTIONS(342),
    [anon_sym_BSLASHu] = ACTIONS(342),
    [anon_sym_BSLASHx] = ACTIONS(342),
    [anon_sym_BSLASHc] = ACTIONS(342),
    [sym_special_escape] = ACTIONS(342),
    [sym_end_assertion] = ACTIONS(342),
    [sym_non_boundary_assertion] = ACTIONS(342),
    [sym_any_character] = ACTIONS(342),
    [sym_non_syntax_character] = ACTIONS(342),
    [sym_null_character] = ACTIONS(342),
  },
  [89] = {
    [ts_builtin_sym_end] = ACTIONS(431),
    [sym_disjunction_delimiter] = ACTIONS(431),
    [anon_sym_BSLASH] = ACTIONS(433),
    [anon_sym_BSLASHk_LT] = ACTIONS(431),
    [sym_group_begin] = ACTIONS(431),
    [sym_group_end] = ACTIONS(431),
    [anon_sym_LBRACK] = ACTIONS(431),
    [anon_sym_CARET] = ACTIONS(431),
    [anon_sym_BSLASHb] = ACTIONS(431),
    [aux_sym_character_class_escape_token1] = ACTIONS(431),
    [aux_sym_character_class_escape_token2] = ACTIONS(431),
    [anon_sym_BSLASHu] = ACTIONS(431),
    [anon_sym_BSLASHx] = ACTIONS(431),
    [anon_sym_BSLASHc] = ACTIONS(431),
    [sym_special_escape] = ACTIONS(431),
    [sym_end_assertion] = ACTIONS(431),
    [sym_non_boundary_assertion] = ACTIONS(431),
    [sym_any_character] = ACTIONS(431),
    [sym_non_syntax_character] = ACTIONS(431),
    [sym_null_character] = ACTIONS(431),
  },
  [90] = {
    [ts_builtin_sym_end] = ACTIONS(142),
    [sym_disjunction_delimiter] = ACTIONS(142),
    [anon_sym_BSLASH] = ACTIONS(148),
    [anon_sym_BSLASHk_LT] = ACTIONS(142),
    [sym_group_begin] = ACTIONS(142),
    [sym_group_end] = ACTIONS(142),
    [anon_sym_LBRACK] = ACTIONS(142),
    [anon_sym_CARET] = ACTIONS(142),
    [anon_sym_BSLASHb] = ACTIONS(142),
    [aux_sym_character_class_escape_token1] = ACTIONS(142),
    [aux_sym_character_class_escape_token2] = ACTIONS(142),
    [anon_sym_BSLASHu] = ACTIONS(142),
    [anon_sym_BSLASHx] = ACTIONS(142),
    [anon_sym_BSLASHc] = ACTIONS(142),
    [sym_special_escape] = ACTIONS(142),
    [sym_end_assertion] = ACTIONS(142),
    [sym_non_boundary_assertion] = ACTIONS(142),
    [sym_any_character] = ACTIONS(142),
    [sym_non_syntax_character] = ACTIONS(142),
    [sym_null_character] = ACTIONS(142),
  },
  [91] = {
    [anon_sym_BSLASH] = ACTIONS(435),
    [anon_sym_BSLASHk_LT] = ACTIONS(437),
    [sym_group_begin] = ACTIONS(437),
    [sym_group_end] = ACTIONS(437),
    [anon_sym_LBRACK] = ACTIONS(437),
    [anon_sym_CARET] = ACTIONS(437),
    [anon_sym_BSLASHb] = ACTIONS(437),
    [aux_sym_character_class_escape_token1] = ACTIONS(437),
    [aux_sym_character_class_escape_token2] = ACTIONS(437),
    [anon_sym_BSLASHu] = ACTIONS(437),
    [anon_sym_BSLASHx] = ACTIONS(437),
    [anon_sym_BSLASHc] = ACTIONS(437),
    [sym_special_escape] = ACTIONS(437),
    [sym_end_assertion] = ACTIONS(437),
    [sym_non_boundary_assertion] = ACTIONS(437),
    [sym_any_character] = ACTIONS(437),
    [sym_non_syntax_character] = ACTIONS(437),
    [sym_null_character] = ACTIONS(437),
  },
  [92] = {
    [sym_set_identity_escape] = STATE(123),
    [sym_identity_escape] = STATE(123),
    [sym_unicode_escape] = STATE(122),
    [sym_hexadecimal_escape] = STATE(122),
    [sym_control_letter_escape] = STATE(122),
    [sym__escape_operator] = STATE(141),
    [anon_sym_BSLASH] = ACTIONS(372),
    [anon_sym_RBRACK] = ACTIONS(439),
    [aux_sym_set_atom_token1] = ACTIONS(441),
    [anon_sym_BSLASHb] = ACTIONS(443),
    [aux_sym_character_class_escape_token1] = ACTIONS(439),
    [aux_sym_character_class_escape_token2] = ACTIONS(439),
    [anon_sym_BSLASHu] = ACTIONS(445),
    [anon_sym_BSLASHx] = ACTIONS(447),
    [anon_sym_BSLASHc] = ACTIONS(449),
    [sym_special_escape] = ACTIONS(451),
    [sym_null_character] = ACTIONS(451),
  },
  [93] = {
    [sym_set_identity_escape] = STATE(113),
    [sym_identity_escape] = STATE(113),
    [sym_unicode_escape] = STATE(118),
    [sym_hexadecimal_escape] = STATE(118),
    [sym_control_letter_escape] = STATE(118),
    [sym__escape_operator] = STATE(141),
    [anon_sym_BSLASH] = ACTIONS(372),
    [anon_sym_RBRACK] = ACTIONS(453),
    [aux_sym_set_atom_token1] = ACTIONS(455),
    [anon_sym_BSLASHb] = ACTIONS(457),
    [aux_sym_character_class_escape_token1] = ACTIONS(453),
    [aux_sym_character_class_escape_token2] = ACTIONS(453),
    [anon_sym_BSLASHu] = ACTIONS(445),
    [anon_sym_BSLASHx] = ACTIONS(447),
    [anon_sym_BSLASHc] = ACTIONS(449),
    [sym_special_escape] = ACTIONS(459),
    [sym_null_character] = ACTIONS(459),
  },
  [94] = {
    [anon_sym_RBRACE] = ACTIONS(461),
    [anon_sym_BSLASH] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(465),
    [anon_sym_RBRACK] = ACTIONS(403),
    [aux_sym_set_atom_token1] = ACTIONS(463),
    [anon_sym_BSLASHb] = ACTIONS(403),
    [aux_sym_character_class_escape_token1] = ACTIONS(403),
    [aux_sym_character_class_escape_token2] = ACTIONS(403),
    [anon_sym_EQ] = ACTIONS(467),
    [anon_sym_BSLASHu] = ACTIONS(403),
    [anon_sym_BSLASHx] = ACTIONS(403),
    [anon_sym_BSLASHc] = ACTIONS(403),
    [sym_special_escape] = ACTIONS(403),
    [sym_null_character] = ACTIONS(403),
  },
  [95] = {
    [anon_sym_RBRACE] = ACTIONS(469),
    [anon_sym_BSLASH] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_RBRACK] = ACTIONS(475),
    [aux_sym_set_atom_token1] = ACTIONS(471),
    [anon_sym_BSLASHb] = ACTIONS(475),
    [aux_sym_character_class_escape_token1] = ACTIONS(475),
    [aux_sym_character_class_escape_token2] = ACTIONS(475),
    [anon_sym_BSLASHu] = ACTIONS(475),
    [anon_sym_BSLASHx] = ACTIONS(475),
    [anon_sym_BSLASHc] = ACTIONS(475),
    [sym_special_escape] = ACTIONS(475),
    [sym_null_character] = ACTIONS(475),
  },
  [96] = {
    [anon_sym_RBRACE] = ACTIONS(477),
    [anon_sym_BSLASH] = ACTIONS(479),
    [anon_sym_DASH] = ACTIONS(481),
    [anon_sym_RBRACK] = ACTIONS(483),
    [aux_sym_set_atom_token1] = ACTIONS(479),
    [anon_sym_BSLASHb] = ACTIONS(483),
    [aux_sym_character_class_escape_token1] = ACTIONS(483),
    [aux_sym_character_class_escape_token2] = ACTIONS(483),
    [anon_sym_BSLASHu] = ACTIONS(483),
    [anon_sym_BSLASHx] = ACTIONS(483),
    [anon_sym_BSLASHc] = ACTIONS(483),
    [sym_special_escape] = ACTIONS(483),
    [sym_null_character] = ACTIONS(483),
  },
  [97] = {
    [anon_sym_BSLASH] = ACTIONS(485),
    [anon_sym_DASH] = ACTIONS(487),
    [anon_sym_RBRACK] = ACTIONS(489),
    [aux_sym_set_atom_token1] = ACTIONS(485),
    [anon_sym_BSLASHb] = ACTIONS(489),
    [aux_sym_character_class_escape_token1] = ACTIONS(489),
    [aux_sym_character_class_escape_token2] = ACTIONS(489),
    [anon_sym_BSLASHu] = ACTIONS(489),
    [anon_sym_BSLASHx] = ACTIONS(489),
    [aux_sym_hexadecimal_escape_token1] = ACTIONS(491),
    [anon_sym_BSLASHc] = ACTIONS(489),
    [sym_special_escape] = ACTIONS(489),
    [sym_null_character] = ACTIONS(489),
  },
  [98] = {
    [anon_sym_BSLASH] = ACTIONS(264),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_RBRACK] = ACTIONS(262),
    [aux_sym_set_atom_token1] = ACTIONS(264),
    [anon_sym_BSLASHb] = ACTIONS(262),
    [aux_sym_character_class_escape_token1] = ACTIONS(262),
    [aux_sym_character_class_escape_token2] = ACTIONS(262),
    [anon_sym_BSLASHu] = ACTIONS(262),
    [anon_sym_BSLASHx] = ACTIONS(262),
    [anon_sym_BSLASHc] = ACTIONS(262),
    [sym_special_escape] = ACTIONS(262),
    [sym_null_character] = ACTIONS(262),
  },
  [99] = {
    [anon_sym_BSLASH] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(495),
    [anon_sym_RBRACK] = ACTIONS(495),
    [aux_sym_set_atom_token1] = ACTIONS(493),
    [anon_sym_BSLASHb] = ACTIONS(495),
    [aux_sym_character_class_escape_token1] = ACTIONS(495),
    [aux_sym_character_class_escape_token2] = ACTIONS(495),
    [anon_sym_BSLASHu] = ACTIONS(495),
    [anon_sym_BSLASHx] = ACTIONS(495),
    [anon_sym_BSLASHc] = ACTIONS(495),
    [sym_special_escape] = ACTIONS(495),
    [sym_null_character] = ACTIONS(495),
  },
  [100] = {
    [anon_sym_BSLASH] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(465),
    [anon_sym_RBRACK] = ACTIONS(403),
    [aux_sym_set_atom_token1] = ACTIONS(463),
    [anon_sym_BSLASHb] = ACTIONS(403),
    [aux_sym_character_class_escape_token1] = ACTIONS(403),
    [aux_sym_character_class_escape_token2] = ACTIONS(403),
    [anon_sym_BSLASHu] = ACTIONS(403),
    [anon_sym_BSLASHx] = ACTIONS(403),
    [anon_sym_BSLASHc] = ACTIONS(403),
    [sym_special_escape] = ACTIONS(403),
    [sym_null_character] = ACTIONS(403),
  },
  [101] = {
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_DASH] = ACTIONS(218),
    [anon_sym_RBRACK] = ACTIONS(218),
    [aux_sym_set_atom_token1] = ACTIONS(220),
    [anon_sym_BSLASHb] = ACTIONS(218),
    [aux_sym_character_class_escape_token1] = ACTIONS(218),
    [aux_sym_character_class_escape_token2] = ACTIONS(218),
    [anon_sym_BSLASHu] = ACTIONS(218),
    [anon_sym_BSLASHx] = ACTIONS(218),
    [anon_sym_BSLASHc] = ACTIONS(218),
    [sym_special_escape] = ACTIONS(218),
    [sym_null_character] = ACTIONS(218),
  },
  [102] = {
    [anon_sym_BSLASH] = ACTIONS(485),
    [anon_sym_DASH] = ACTIONS(497),
    [anon_sym_RBRACK] = ACTIONS(489),
    [aux_sym_set_atom_token1] = ACTIONS(485),
    [anon_sym_BSLASHb] = ACTIONS(489),
    [aux_sym_character_class_escape_token1] = ACTIONS(489),
    [aux_sym_character_class_escape_token2] = ACTIONS(489),
    [anon_sym_BSLASHu] = ACTIONS(489),
    [anon_sym_BSLASHx] = ACTIONS(489),
    [anon_sym_BSLASHc] = ACTIONS(489),
    [sym_special_escape] = ACTIONS(489),
    [sym_null_character] = ACTIONS(489),
  },
  [103] = {
    [anon_sym_BSLASH] = ACTIONS(224),
    [anon_sym_DASH] = ACTIONS(222),
    [anon_sym_RBRACK] = ACTIONS(222),
    [aux_sym_set_atom_token1] = ACTIONS(224),
    [anon_sym_BSLASHb] = ACTIONS(222),
    [aux_sym_character_class_escape_token1] = ACTIONS(222),
    [aux_sym_character_class_escape_token2] = ACTIONS(222),
    [anon_sym_BSLASHu] = ACTIONS(222),
    [anon_sym_BSLASHx] = ACTIONS(222),
    [anon_sym_BSLASHc] = ACTIONS(222),
    [sym_special_escape] = ACTIONS(222),
    [sym_null_character] = ACTIONS(222),
  },
  [104] = {
    [anon_sym_BSLASH] = ACTIONS(208),
    [anon_sym_DASH] = ACTIONS(206),
    [anon_sym_RBRACK] = ACTIONS(206),
    [aux_sym_set_atom_token1] = ACTIONS(208),
    [anon_sym_BSLASHb] = ACTIONS(206),
    [aux_sym_character_class_escape_token1] = ACTIONS(206),
    [aux_sym_character_class_escape_token2] = ACTIONS(206),
    [anon_sym_BSLASHu] = ACTIONS(206),
    [anon_sym_BSLASHx] = ACTIONS(206),
    [anon_sym_BSLASHc] = ACTIONS(206),
    [sym_special_escape] = ACTIONS(206),
    [sym_null_character] = ACTIONS(206),
  },
  [105] = {
    [anon_sym_BSLASH] = ACTIONS(268),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_RBRACK] = ACTIONS(266),
    [aux_sym_set_atom_token1] = ACTIONS(268),
    [anon_sym_BSLASHb] = ACTIONS(266),
    [aux_sym_character_class_escape_token1] = ACTIONS(266),
    [aux_sym_character_class_escape_token2] = ACTIONS(266),
    [anon_sym_BSLASHu] = ACTIONS(266),
    [anon_sym_BSLASHx] = ACTIONS(266),
    [anon_sym_BSLASHc] = ACTIONS(266),
    [sym_special_escape] = ACTIONS(266),
    [sym_null_character] = ACTIONS(266),
  },
  [106] = {
    [anon_sym_BSLASH] = ACTIONS(260),
    [anon_sym_DASH] = ACTIONS(258),
    [anon_sym_RBRACK] = ACTIONS(258),
    [aux_sym_set_atom_token1] = ACTIONS(260),
    [anon_sym_BSLASHb] = ACTIONS(258),
    [aux_sym_character_class_escape_token1] = ACTIONS(258),
    [aux_sym_character_class_escape_token2] = ACTIONS(258),
    [anon_sym_BSLASHu] = ACTIONS(258),
    [anon_sym_BSLASHx] = ACTIONS(258),
    [anon_sym_BSLASHc] = ACTIONS(258),
    [sym_special_escape] = ACTIONS(258),
    [sym_null_character] = ACTIONS(258),
  },
  [107] = {
    [anon_sym_BSLASH] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(282),
    [anon_sym_RBRACK] = ACTIONS(282),
    [aux_sym_set_atom_token1] = ACTIONS(284),
    [anon_sym_BSLASHb] = ACTIONS(282),
    [aux_sym_character_class_escape_token1] = ACTIONS(282),
    [aux_sym_character_class_escape_token2] = ACTIONS(282),
    [anon_sym_BSLASHu] = ACTIONS(282),
    [anon_sym_BSLASHx] = ACTIONS(282),
    [anon_sym_BSLASHc] = ACTIONS(282),
    [sym_special_escape] = ACTIONS(282),
    [sym_null_character] = ACTIONS(282),
  },
  [108] = {
    [anon_sym_BSLASH] = ACTIONS(485),
    [anon_sym_DASH] = ACTIONS(497),
    [anon_sym_RBRACK] = ACTIONS(489),
    [aux_sym_set_atom_token1] = ACTIONS(485),
    [anon_sym_BSLASHb] = ACTIONS(489),
    [aux_sym_character_class_escape_token1] = ACTIONS(489),
    [aux_sym_character_class_escape_token2] = ACTIONS(489),
    [anon_sym_BSLASHu] = ACTIONS(489),
    [anon_sym_BSLASHx] = ACTIONS(489),
    [anon_sym_BSLASHc] = ACTIONS(489),
    [sym_special_escape] = ACTIONS(489),
    [sym_null_character] = ACTIONS(489),
  },
  [109] = {
    [anon_sym_BSLASH] = ACTIONS(252),
    [anon_sym_DASH] = ACTIONS(250),
    [anon_sym_RBRACK] = ACTIONS(250),
    [aux_sym_set_atom_token1] = ACTIONS(252),
    [anon_sym_BSLASHb] = ACTIONS(250),
    [aux_sym_character_class_escape_token1] = ACTIONS(250),
    [aux_sym_character_class_escape_token2] = ACTIONS(250),
    [anon_sym_BSLASHu] = ACTIONS(250),
    [anon_sym_BSLASHx] = ACTIONS(250),
    [anon_sym_BSLASHc] = ACTIONS(250),
    [sym_special_escape] = ACTIONS(250),
    [sym_null_character] = ACTIONS(250),
  },
  [110] = {
    [anon_sym_BSLASH] = ACTIONS(499),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_RBRACK] = ACTIONS(503),
    [aux_sym_set_atom_token1] = ACTIONS(499),
    [anon_sym_BSLASHb] = ACTIONS(503),
    [aux_sym_character_class_escape_token1] = ACTIONS(503),
    [aux_sym_character_class_escape_token2] = ACTIONS(503),
    [anon_sym_BSLASHu] = ACTIONS(503),
    [anon_sym_BSLASHx] = ACTIONS(503),
    [anon_sym_BSLASHc] = ACTIONS(503),
    [sym_special_escape] = ACTIONS(503),
    [sym_null_character] = ACTIONS(503),
  },
  [111] = {
    [anon_sym_BSLASH] = ACTIONS(485),
    [anon_sym_DASH] = ACTIONS(487),
    [anon_sym_RBRACK] = ACTIONS(489),
    [aux_sym_set_atom_token1] = ACTIONS(485),
    [anon_sym_BSLASHb] = ACTIONS(489),
    [aux_sym_character_class_escape_token1] = ACTIONS(489),
    [aux_sym_character_class_escape_token2] = ACTIONS(489),
    [anon_sym_BSLASHu] = ACTIONS(489),
    [anon_sym_BSLASHx] = ACTIONS(489),
    [anon_sym_BSLASHc] = ACTIONS(489),
    [sym_special_escape] = ACTIONS(489),
    [sym_null_character] = ACTIONS(489),
  },
  [112] = {
    [anon_sym_BSLASH] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_RBRACK] = ACTIONS(475),
    [aux_sym_set_atom_token1] = ACTIONS(471),
    [anon_sym_BSLASHb] = ACTIONS(475),
    [aux_sym_character_class_escape_token1] = ACTIONS(475),
    [aux_sym_character_class_escape_token2] = ACTIONS(475),
    [anon_sym_BSLASHu] = ACTIONS(475),
    [anon_sym_BSLASHx] = ACTIONS(475),
    [anon_sym_BSLASHc] = ACTIONS(475),
    [sym_special_escape] = ACTIONS(475),
    [sym_null_character] = ACTIONS(475),
  },
  [113] = {
    [anon_sym_BSLASH] = ACTIONS(505),
    [anon_sym_RBRACK] = ACTIONS(507),
    [aux_sym_set_atom_token1] = ACTIONS(507),
    [anon_sym_BSLASHb] = ACTIONS(507),
    [aux_sym_character_class_escape_token1] = ACTIONS(507),
    [aux_sym_character_class_escape_token2] = ACTIONS(507),
    [anon_sym_BSLASHu] = ACTIONS(507),
    [anon_sym_BSLASHx] = ACTIONS(507),
    [anon_sym_BSLASHc] = ACTIONS(507),
    [sym_special_escape] = ACTIONS(507),
    [sym_null_character] = ACTIONS(507),
  },
  [114] = {
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_RBRACK] = ACTIONS(218),
    [aux_sym_set_atom_token1] = ACTIONS(218),
    [anon_sym_BSLASHb] = ACTIONS(218),
    [aux_sym_character_class_escape_token1] = ACTIONS(218),
    [aux_sym_character_class_escape_token2] = ACTIONS(218),
    [anon_sym_BSLASHu] = ACTIONS(218),
    [anon_sym_BSLASHx] = ACTIONS(218),
    [anon_sym_BSLASHc] = ACTIONS(218),
    [sym_special_escape] = ACTIONS(218),
    [sym_null_character] = ACTIONS(218),
  },
  [115] = {
    [anon_sym_BSLASH] = ACTIONS(252),
    [anon_sym_RBRACK] = ACTIONS(250),
    [aux_sym_set_atom_token1] = ACTIONS(250),
    [anon_sym_BSLASHb] = ACTIONS(250),
    [aux_sym_character_class_escape_token1] = ACTIONS(250),
    [aux_sym_character_class_escape_token2] = ACTIONS(250),
    [anon_sym_BSLASHu] = ACTIONS(250),
    [anon_sym_BSLASHx] = ACTIONS(250),
    [anon_sym_BSLASHc] = ACTIONS(250),
    [sym_special_escape] = ACTIONS(250),
    [sym_null_character] = ACTIONS(250),
  },
  [116] = {
    [anon_sym_BSLASH] = ACTIONS(268),
    [anon_sym_RBRACK] = ACTIONS(266),
    [aux_sym_set_atom_token1] = ACTIONS(266),
    [anon_sym_BSLASHb] = ACTIONS(266),
    [aux_sym_character_class_escape_token1] = ACTIONS(266),
    [aux_sym_character_class_escape_token2] = ACTIONS(266),
    [anon_sym_BSLASHu] = ACTIONS(266),
    [anon_sym_BSLASHx] = ACTIONS(266),
    [anon_sym_BSLASHc] = ACTIONS(266),
    [sym_special_escape] = ACTIONS(266),
    [sym_null_character] = ACTIONS(266),
  },
  [117] = {
    [anon_sym_BSLASH] = ACTIONS(264),
    [anon_sym_RBRACK] = ACTIONS(262),
    [aux_sym_set_atom_token1] = ACTIONS(262),
    [anon_sym_BSLASHb] = ACTIONS(262),
    [aux_sym_character_class_escape_token1] = ACTIONS(262),
    [aux_sym_character_class_escape_token2] = ACTIONS(262),
    [anon_sym_BSLASHu] = ACTIONS(262),
    [anon_sym_BSLASHx] = ACTIONS(262),
    [anon_sym_BSLASHc] = ACTIONS(262),
    [sym_special_escape] = ACTIONS(262),
    [sym_null_character] = ACTIONS(262),
  },
  [118] = {
    [anon_sym_BSLASH] = ACTIONS(505),
    [anon_sym_RBRACK] = ACTIONS(507),
    [aux_sym_set_atom_token1] = ACTIONS(507),
    [anon_sym_BSLASHb] = ACTIONS(507),
    [aux_sym_character_class_escape_token1] = ACTIONS(507),
    [aux_sym_character_class_escape_token2] = ACTIONS(507),
    [anon_sym_BSLASHu] = ACTIONS(507),
    [anon_sym_BSLASHx] = ACTIONS(507),
    [anon_sym_BSLASHc] = ACTIONS(507),
    [sym_special_escape] = ACTIONS(507),
    [sym_null_character] = ACTIONS(507),
  },
  [119] = {
    [anon_sym_BSLASH] = ACTIONS(493),
    [anon_sym_RBRACK] = ACTIONS(495),
    [aux_sym_set_atom_token1] = ACTIONS(495),
    [anon_sym_BSLASHb] = ACTIONS(495),
    [aux_sym_character_class_escape_token1] = ACTIONS(495),
    [aux_sym_character_class_escape_token2] = ACTIONS(495),
    [anon_sym_BSLASHu] = ACTIONS(495),
    [anon_sym_BSLASHx] = ACTIONS(495),
    [anon_sym_BSLASHc] = ACTIONS(495),
    [sym_special_escape] = ACTIONS(495),
    [sym_null_character] = ACTIONS(495),
  },
  [120] = {
    [anon_sym_BSLASH] = ACTIONS(509),
    [anon_sym_RBRACK] = ACTIONS(511),
    [aux_sym_set_atom_token1] = ACTIONS(511),
    [anon_sym_BSLASHb] = ACTIONS(511),
    [aux_sym_character_class_escape_token1] = ACTIONS(511),
    [aux_sym_character_class_escape_token2] = ACTIONS(511),
    [anon_sym_BSLASHu] = ACTIONS(511),
    [anon_sym_BSLASHx] = ACTIONS(511),
    [anon_sym_BSLASHc] = ACTIONS(511),
    [sym_special_escape] = ACTIONS(511),
    [sym_null_character] = ACTIONS(511),
  },
  [121] = {
    [anon_sym_BSLASH] = ACTIONS(513),
    [anon_sym_RBRACK] = ACTIONS(453),
    [aux_sym_set_atom_token1] = ACTIONS(453),
    [anon_sym_BSLASHb] = ACTIONS(453),
    [aux_sym_character_class_escape_token1] = ACTIONS(453),
    [aux_sym_character_class_escape_token2] = ACTIONS(453),
    [anon_sym_BSLASHu] = ACTIONS(453),
    [anon_sym_BSLASHx] = ACTIONS(453),
    [anon_sym_BSLASHc] = ACTIONS(453),
    [sym_special_escape] = ACTIONS(453),
    [sym_null_character] = ACTIONS(453),
  },
  [122] = {
    [anon_sym_BSLASH] = ACTIONS(515),
    [anon_sym_RBRACK] = ACTIONS(517),
    [aux_sym_set_atom_token1] = ACTIONS(517),
    [anon_sym_BSLASHb] = ACTIONS(517),
    [aux_sym_character_class_escape_token1] = ACTIONS(517),
    [aux_sym_character_class_escape_token2] = ACTIONS(517),
    [anon_sym_BSLASHu] = ACTIONS(517),
    [anon_sym_BSLASHx] = ACTIONS(517),
    [anon_sym_BSLASHc] = ACTIONS(517),
    [sym_special_escape] = ACTIONS(517),
    [sym_null_character] = ACTIONS(517),
  },
  [123] = {
    [anon_sym_BSLASH] = ACTIONS(515),
    [anon_sym_RBRACK] = ACTIONS(517),
    [aux_sym_set_atom_token1] = ACTIONS(517),
    [anon_sym_BSLASHb] = ACTIONS(517),
    [aux_sym_character_class_escape_token1] = ACTIONS(517),
    [aux_sym_character_class_escape_token2] = ACTIONS(517),
    [anon_sym_BSLASHu] = ACTIONS(517),
    [anon_sym_BSLASHx] = ACTIONS(517),
    [anon_sym_BSLASHc] = ACTIONS(517),
    [sym_special_escape] = ACTIONS(517),
    [sym_null_character] = ACTIONS(517),
  },
  [124] = {
    [anon_sym_BSLASH] = ACTIONS(519),
    [anon_sym_RBRACK] = ACTIONS(521),
    [aux_sym_set_atom_token1] = ACTIONS(521),
    [anon_sym_BSLASHb] = ACTIONS(521),
    [aux_sym_character_class_escape_token1] = ACTIONS(521),
    [aux_sym_character_class_escape_token2] = ACTIONS(521),
    [anon_sym_BSLASHu] = ACTIONS(521),
    [anon_sym_BSLASHx] = ACTIONS(521),
    [anon_sym_BSLASHc] = ACTIONS(521),
    [sym_special_escape] = ACTIONS(521),
    [sym_null_character] = ACTIONS(521),
  },
  [125] = {
    [anon_sym_BSLASH] = ACTIONS(523),
    [anon_sym_RBRACK] = ACTIONS(525),
    [aux_sym_set_atom_token1] = ACTIONS(525),
    [anon_sym_BSLASHb] = ACTIONS(525),
    [aux_sym_character_class_escape_token1] = ACTIONS(525),
    [aux_sym_character_class_escape_token2] = ACTIONS(525),
    [anon_sym_BSLASHu] = ACTIONS(525),
    [anon_sym_BSLASHx] = ACTIONS(525),
    [anon_sym_BSLASHc] = ACTIONS(525),
    [sym_special_escape] = ACTIONS(525),
    [sym_null_character] = ACTIONS(525),
  },
  [126] = {
    [anon_sym_BSLASH] = ACTIONS(527),
    [anon_sym_RBRACK] = ACTIONS(529),
    [aux_sym_set_atom_token1] = ACTIONS(529),
    [anon_sym_BSLASHb] = ACTIONS(529),
    [aux_sym_character_class_escape_token1] = ACTIONS(529),
    [aux_sym_character_class_escape_token2] = ACTIONS(529),
    [anon_sym_BSLASHu] = ACTIONS(529),
    [anon_sym_BSLASHx] = ACTIONS(529),
    [anon_sym_BSLASHc] = ACTIONS(529),
    [sym_special_escape] = ACTIONS(529),
    [sym_null_character] = ACTIONS(529),
  },
  [127] = {
    [anon_sym_BSLASH] = ACTIONS(531),
    [anon_sym_RBRACK] = ACTIONS(533),
    [aux_sym_set_atom_token1] = ACTIONS(533),
    [anon_sym_BSLASHb] = ACTIONS(533),
    [aux_sym_character_class_escape_token1] = ACTIONS(533),
    [aux_sym_character_class_escape_token2] = ACTIONS(533),
    [anon_sym_BSLASHu] = ACTIONS(533),
    [anon_sym_BSLASHx] = ACTIONS(533),
    [anon_sym_BSLASHc] = ACTIONS(533),
    [sym_special_escape] = ACTIONS(533),
    [sym_null_character] = ACTIONS(533),
  },
  [128] = {
    [anon_sym_BSLASH] = ACTIONS(260),
    [anon_sym_RBRACK] = ACTIONS(258),
    [aux_sym_set_atom_token1] = ACTIONS(258),
    [anon_sym_BSLASHb] = ACTIONS(258),
    [aux_sym_character_class_escape_token1] = ACTIONS(258),
    [aux_sym_character_class_escape_token2] = ACTIONS(258),
    [anon_sym_BSLASHu] = ACTIONS(258),
    [anon_sym_BSLASHx] = ACTIONS(258),
    [anon_sym_BSLASHc] = ACTIONS(258),
    [sym_special_escape] = ACTIONS(258),
    [sym_null_character] = ACTIONS(258),
  },
  [129] = {
    [sym_unicode_escape] = STATE(131),
    [aux_sym_group_name_repeat1] = STATE(131),
    [anon_sym_GT] = ACTIONS(535),
    [aux_sym_group_name_token2] = ACTIONS(537),
    [anon_sym_BSLASHu] = ACTIONS(539),
  },
  [130] = {
    [sym_unicode_escape] = STATE(129),
    [aux_sym_group_name_repeat1] = STATE(129),
    [anon_sym_GT] = ACTIONS(541),
    [aux_sym_group_name_token2] = ACTIONS(543),
    [anon_sym_BSLASHu] = ACTIONS(539),
  },
  [131] = {
    [sym_unicode_escape] = STATE(131),
    [aux_sym_group_name_repeat1] = STATE(131),
    [anon_sym_GT] = ACTIONS(545),
    [aux_sym_group_name_token2] = ACTIONS(547),
    [anon_sym_BSLASHu] = ACTIONS(550),
  },
  [132] = {
    [sym_group_name] = STATE(149),
    [sym_unicode_escape] = STATE(130),
    [aux_sym_group_name_token1] = ACTIONS(553),
    [anon_sym_BSLASHu] = ACTIONS(539),
  },
  [133] = {
    [sym_group_name] = STATE(164),
    [sym_unicode_escape] = STATE(130),
    [aux_sym_group_name_token1] = ACTIONS(553),
    [anon_sym_BSLASHu] = ACTIONS(539),
  },
  [134] = {
    [anon_sym_GT] = ACTIONS(218),
    [aux_sym_group_name_token2] = ACTIONS(218),
    [anon_sym_BSLASHu] = ACTIONS(218),
  },
  [135] = {
    [anon_sym_LBRACE] = ACTIONS(555),
    [aux_sym_unicode_escape_token1] = ACTIONS(557),
    [aux_sym__invalid_unicode_escape_token1] = ACTIONS(559),
  },
  [136] = {
    [anon_sym_RBRACE] = ACTIONS(561),
    [aux_sym_unicode_escape_token2] = ACTIONS(563),
    [aux_sym__invalid_unicode_escape_token2] = ACTIONS(565),
  },
  [137] = {
    [anon_sym_LBRACE] = ACTIONS(567),
    [aux_sym_unicode_escape_token1] = ACTIONS(569),
    [aux_sym__invalid_unicode_escape_token1] = ACTIONS(571),
  },
  [138] = {
    [anon_sym_GT] = ACTIONS(250),
    [aux_sym_group_name_token2] = ACTIONS(250),
    [anon_sym_BSLASHu] = ACTIONS(250),
  },
  [139] = {
    [anon_sym_RBRACE] = ACTIONS(573),
    [aux_sym_unicode_escape_token2] = ACTIONS(575),
    [aux_sym__invalid_unicode_escape_token2] = ACTIONS(577),
  },
  [140] = {
    [ts_builtin_sym_end] = ACTIONS(579),
    [sym_group_end] = ACTIONS(579),
  },
  [141] = {
    [anon_sym_DASH] = ACTIONS(581),
    [aux_sym_identity_escape_token1] = ACTIONS(583),
  },
  [142] = {
    [anon_sym_LBRACE] = ACTIONS(585),
    [aux_sym_unicode_escape_token1] = ACTIONS(587),
  },
  [143] = {
    [anon_sym_DASH] = ACTIONS(589),
    [aux_sym_identity_escape_token1] = ACTIONS(589),
  },
  [144] = {
    [anon_sym_LBRACE] = ACTIONS(591),
    [aux_sym_unicode_escape_token1] = ACTIONS(593),
  },
  [145] = {
    [anon_sym_COMMA] = ACTIONS(595),
    [anon_sym_RBRACE] = ACTIONS(597),
  },
  [146] = {
    [aux_sym_count_quantifier_token1] = ACTIONS(599),
    [anon_sym_RBRACE] = ACTIONS(601),
  },
  [147] = {
    [aux_sym_backreference_token1] = ACTIONS(603),
    [aux_sym_identity_escape_token1] = ACTIONS(589),
  },
  [148] = {
    [anon_sym_DASH] = ACTIONS(605),
    [aux_sym_identity_escape_token1] = ACTIONS(607),
  },
  [149] = {
    [anon_sym_GT] = ACTIONS(609),
  },
  [150] = {
    [sym_group_end] = ACTIONS(611),
  },
  [151] = {
    [sym__unicode_property] = ACTIONS(613),
  },
  [152] = {
    [sym__unicode_property] = ACTIONS(615),
  },
  [153] = {
    [sym_group_end] = ACTIONS(617),
  },
  [154] = {
    [anon_sym_RBRACE] = ACTIONS(619),
  },
  [155] = {
    [sym__unicode_property] = ACTIONS(621),
  },
  [156] = {
    [ts_builtin_sym_end] = ACTIONS(623),
  },
  [157] = {
    [sym_group_end] = ACTIONS(625),
  },
  [158] = {
    [aux_sym_hexadecimal_escape_token1] = ACTIONS(627),
  },
  [159] = {
    [aux_sym_unicode_escape_token2] = ACTIONS(629),
  },
  [160] = {
    [aux_sym_count_quantifier_token1] = ACTIONS(631),
  },
  [161] = {
    [sym_group_end] = ACTIONS(633),
  },
  [162] = {
    [aux_sym_control_letter_escape_token1] = ACTIONS(635),
  },
  [163] = {
    [sym__unicode_property] = ACTIONS(637),
  },
  [164] = {
    [anon_sym_GT] = ACTIONS(639),
  },
  [165] = {
    [sym_group_end] = ACTIONS(641),
  },
  [166] = {
    [anon_sym_RBRACE] = ACTIONS(643),
  },
  [167] = {
    [ts_builtin_sym_end] = ACTIONS(645),
  },
  [168] = {
    [sym_group_end] = ACTIONS(647),
  },
  [169] = {
    [aux_sym_control_letter_escape_token1] = ACTIONS(649),
  },
  [170] = {
    [aux_sym_identity_escape_token1] = ACTIONS(651),
  },
  [171] = {
    [sym_group_end] = ACTIONS(653),
  },
  [172] = {
    [anon_sym_RBRACE] = ACTIONS(655),
  },
  [173] = {
    [aux_sym_control_letter_escape_token1] = ACTIONS(657),
  },
  [174] = {
    [aux_sym_unicode_escape_token2] = ACTIONS(659),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = false}, RECOVER(),
  [3] = {.count = 1, .reusable = false}, SHIFT(147),
  [5] = {.count = 1, .reusable = true}, SHIFT(133),
  [7] = {.count = 1, .reusable = true}, SHIFT(2),
  [9] = {.count = 1, .reusable = true}, SHIFT(81),
  [11] = {.count = 1, .reusable = true}, SHIFT(39),
  [13] = {.count = 1, .reusable = true}, SHIFT(48),
  [15] = {.count = 1, .reusable = true}, SHIFT(59),
  [17] = {.count = 1, .reusable = true}, SHIFT(151),
  [19] = {.count = 1, .reusable = true}, SHIFT(135),
  [21] = {.count = 1, .reusable = true}, SHIFT(21),
  [23] = {.count = 1, .reusable = true}, SHIFT(162),
  [25] = {.count = 1, .reusable = true}, SHIFT(25),
  [27] = {.count = 1, .reusable = true}, SHIFT(24),
  [29] = {.count = 1, .reusable = true}, SHIFT(15),
  [31] = {.count = 1, .reusable = true}, SHIFT(14),
  [33] = {.count = 1, .reusable = true}, SHIFT(16),
  [35] = {.count = 1, .reusable = true}, SHIFT(17),
  [37] = {.count = 1, .reusable = false}, SHIFT(132),
  [39] = {.count = 1, .reusable = true}, SHIFT(18),
  [41] = {.count = 1, .reusable = true}, SHIFT(37),
  [43] = {.count = 1, .reusable = true}, REDUCE(sym_disjunction, 2),
  [45] = {.count = 1, .reusable = true}, SHIFT(13),
  [47] = {.count = 1, .reusable = true}, SHIFT(32),
  [49] = {.count = 1, .reusable = true}, SHIFT(58),
  [51] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 1),
  [53] = {.count = 1, .reusable = true}, SHIFT(50),
  [55] = {.count = 1, .reusable = true}, SHIFT(57),
  [57] = {.count = 1, .reusable = true}, SHIFT(62),
  [59] = {.count = 1, .reusable = true}, SHIFT(63),
  [61] = {.count = 1, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2),
  [63] = {.count = 2, .reusable = false}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(147),
  [66] = {.count = 2, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(133),
  [69] = {.count = 2, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(2),
  [72] = {.count = 2, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(81),
  [75] = {.count = 2, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(39),
  [78] = {.count = 2, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(48),
  [81] = {.count = 2, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(59),
  [84] = {.count = 2, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(151),
  [87] = {.count = 2, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(135),
  [90] = {.count = 2, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(21),
  [93] = {.count = 2, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(162),
  [96] = {.count = 2, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(25),
  [99] = {.count = 2, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(24),
  [102] = {.count = 1, .reusable = true}, SHIFT(49),
  [104] = {.count = 1, .reusable = true}, REDUCE(sym_disjunction, 1),
  [106] = {.count = 1, .reusable = true}, SHIFT(52),
  [108] = {.count = 1, .reusable = true}, SHIFT(56),
  [110] = {.count = 1, .reusable = true}, SHIFT(42),
  [112] = {.count = 1, .reusable = true}, SHIFT(31),
  [114] = {.count = 1, .reusable = true}, SHIFT(61),
  [116] = {.count = 1, .reusable = true}, SHIFT(60),
  [118] = {.count = 1, .reusable = true}, SHIFT(90),
  [120] = {.count = 1, .reusable = true}, SHIFT(65),
  [122] = {.count = 1, .reusable = true}, SHIFT(66),
  [124] = {.count = 1, .reusable = true}, SHIFT(67),
  [126] = {.count = 1, .reusable = false}, SHIFT(160),
  [128] = {.count = 1, .reusable = true}, SHIFT(40),
  [130] = {.count = 1, .reusable = false}, REDUCE(aux_sym_pattern_repeat1, 2),
  [132] = {.count = 1, .reusable = true}, SHIFT(163),
  [134] = {.count = 1, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 1),
  [136] = {.count = 1, .reusable = true}, SHIFT(82),
  [138] = {.count = 1, .reusable = false}, REDUCE(aux_sym_pattern_repeat1, 1),
  [140] = {.count = 1, .reusable = true}, SHIFT(53),
  [142] = {.count = 1, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 3),
  [144] = {.count = 1, .reusable = true}, SHIFT(86),
  [146] = {.count = 1, .reusable = true}, SHIFT(43),
  [148] = {.count = 1, .reusable = false}, REDUCE(aux_sym_pattern_repeat1, 3),
  [150] = {.count = 1, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 4),
  [152] = {.count = 1, .reusable = true}, SHIFT(88),
  [154] = {.count = 1, .reusable = true}, SHIFT(44),
  [156] = {.count = 1, .reusable = false}, REDUCE(aux_sym_pattern_repeat1, 4),
  [158] = {.count = 1, .reusable = true}, REDUCE(sym_backreference, 2),
  [160] = {.count = 1, .reusable = false}, REDUCE(sym_backreference, 2),
  [162] = {.count = 1, .reusable = true}, REDUCE(sym_character_set, 3, .production_id = 4),
  [164] = {.count = 1, .reusable = false}, REDUCE(sym_character_set, 3, .production_id = 4),
  [166] = {.count = 1, .reusable = true}, REDUCE(sym_named_capturing_group, 5),
  [168] = {.count = 1, .reusable = false}, REDUCE(sym_named_capturing_group, 5),
  [170] = {.count = 1, .reusable = true}, REDUCE(sym_negative_lookbehind_assertion, 3),
  [172] = {.count = 1, .reusable = false}, REDUCE(sym_negative_lookbehind_assertion, 3),
  [174] = {.count = 1, .reusable = true}, REDUCE(sym_lookahead_assertion, 4),
  [176] = {.count = 1, .reusable = false}, REDUCE(sym_lookahead_assertion, 4),
  [178] = {.count = 1, .reusable = true}, REDUCE(sym_non_capturing_group, 5),
  [180] = {.count = 1, .reusable = false}, REDUCE(sym_non_capturing_group, 5),
  [182] = {.count = 1, .reusable = true}, REDUCE(sym_negative_lookbehind_assertion, 5),
  [184] = {.count = 1, .reusable = false}, REDUCE(sym_negative_lookbehind_assertion, 5),
  [186] = {.count = 1, .reusable = true}, REDUCE(sym_lookbehind_assertion, 5),
  [188] = {.count = 1, .reusable = false}, REDUCE(sym_lookbehind_assertion, 5),
  [190] = {.count = 1, .reusable = true}, REDUCE(sym_negative_lookahead_assertion, 5),
  [192] = {.count = 1, .reusable = false}, REDUCE(sym_negative_lookahead_assertion, 5),
  [194] = {.count = 1, .reusable = true}, REDUCE(sym_anonymous_capturing_group, 2),
  [196] = {.count = 1, .reusable = false}, REDUCE(sym_anonymous_capturing_group, 2),
  [198] = {.count = 1, .reusable = true}, REDUCE(sym_lookahead_assertion, 5),
  [200] = {.count = 1, .reusable = false}, REDUCE(sym_lookahead_assertion, 5),
  [202] = {.count = 1, .reusable = true}, REDUCE(sym_start_assertion, 1),
  [204] = {.count = 1, .reusable = false}, REDUCE(sym_start_assertion, 1),
  [206] = {.count = 1, .reusable = true}, REDUCE(sym_character_class_escape, 3, .production_id = 6),
  [208] = {.count = 1, .reusable = false}, REDUCE(sym_character_class_escape, 3, .production_id = 6),
  [210] = {.count = 1, .reusable = true}, REDUCE(sym_character_set, 2),
  [212] = {.count = 1, .reusable = false}, REDUCE(sym_character_set, 2),
  [214] = {.count = 1, .reusable = true}, REDUCE(sym_lookbehind_assertion, 3),
  [216] = {.count = 1, .reusable = false}, REDUCE(sym_lookbehind_assertion, 3),
  [218] = {.count = 1, .reusable = true}, REDUCE(sym_unicode_escape, 4, .production_id = 12),
  [220] = {.count = 1, .reusable = false}, REDUCE(sym_unicode_escape, 4, .production_id = 12),
  [222] = {.count = 1, .reusable = true}, REDUCE(sym_character_class_escape, 5, .production_id = 15),
  [224] = {.count = 1, .reusable = false}, REDUCE(sym_character_class_escape, 5, .production_id = 15),
  [226] = {.count = 1, .reusable = true}, REDUCE(sym_character_set, 3),
  [228] = {.count = 1, .reusable = false}, REDUCE(sym_character_set, 3),
  [230] = {.count = 1, .reusable = true}, REDUCE(sym_character_set, 4, .production_id = 4),
  [232] = {.count = 1, .reusable = false}, REDUCE(sym_character_set, 4, .production_id = 4),
  [234] = {.count = 1, .reusable = true}, REDUCE(sym_anonymous_capturing_group, 4),
  [236] = {.count = 1, .reusable = false}, REDUCE(sym_anonymous_capturing_group, 4),
  [238] = {.count = 1, .reusable = true}, REDUCE(sym_boundary_assertion, 1),
  [240] = {.count = 1, .reusable = false}, REDUCE(sym_boundary_assertion, 1),
  [242] = {.count = 1, .reusable = true}, REDUCE(sym_negative_lookahead_assertion, 4),
  [244] = {.count = 1, .reusable = false}, REDUCE(sym_negative_lookahead_assertion, 4),
  [246] = {.count = 1, .reusable = true}, REDUCE(sym_named_capturing_group, 4),
  [248] = {.count = 1, .reusable = false}, REDUCE(sym_named_capturing_group, 4),
  [250] = {.count = 1, .reusable = true}, REDUCE(sym_unicode_escape, 2),
  [252] = {.count = 1, .reusable = false}, REDUCE(sym_unicode_escape, 2),
  [254] = {.count = 1, .reusable = true}, REDUCE(sym_negative_lookahead_assertion, 3),
  [256] = {.count = 1, .reusable = false}, REDUCE(sym_negative_lookahead_assertion, 3),
  [258] = {.count = 1, .reusable = true}, REDUCE(sym_hexadecimal_escape, 2),
  [260] = {.count = 1, .reusable = false}, REDUCE(sym_hexadecimal_escape, 2),
  [262] = {.count = 1, .reusable = true}, REDUCE(sym_control_letter_escape, 2),
  [264] = {.count = 1, .reusable = false}, REDUCE(sym_control_letter_escape, 2),
  [266] = {.count = 1, .reusable = true}, REDUCE(sym_identity_escape, 2),
  [268] = {.count = 1, .reusable = false}, REDUCE(sym_identity_escape, 2),
  [270] = {.count = 1, .reusable = true}, REDUCE(sym_lookahead_assertion, 3),
  [272] = {.count = 1, .reusable = false}, REDUCE(sym_lookahead_assertion, 3),
  [274] = {.count = 1, .reusable = true}, REDUCE(sym_non_capturing_group, 4),
  [276] = {.count = 1, .reusable = false}, REDUCE(sym_non_capturing_group, 4),
  [278] = {.count = 1, .reusable = true}, REDUCE(sym_anonymous_capturing_group, 3),
  [280] = {.count = 1, .reusable = false}, REDUCE(sym_anonymous_capturing_group, 3),
  [282] = {.count = 1, .reusable = true}, REDUCE(sym_character_class_escape, 1),
  [284] = {.count = 1, .reusable = false}, REDUCE(sym_character_class_escape, 1),
  [286] = {.count = 1, .reusable = true}, REDUCE(sym_named_capturing_group, 3),
  [288] = {.count = 1, .reusable = false}, REDUCE(sym_named_capturing_group, 3),
  [290] = {.count = 1, .reusable = true}, REDUCE(sym_non_capturing_group, 3),
  [292] = {.count = 1, .reusable = false}, REDUCE(sym_non_capturing_group, 3),
  [294] = {.count = 1, .reusable = true}, REDUCE(sym_negative_lookbehind_assertion, 4),
  [296] = {.count = 1, .reusable = false}, REDUCE(sym_negative_lookbehind_assertion, 4),
  [298] = {.count = 1, .reusable = true}, REDUCE(sym_lookbehind_assertion, 4),
  [300] = {.count = 1, .reusable = false}, REDUCE(sym_lookbehind_assertion, 4),
  [302] = {.count = 1, .reusable = true}, REDUCE(sym_backreference, 3),
  [304] = {.count = 1, .reusable = false}, REDUCE(sym_backreference, 3),
  [306] = {.count = 1, .reusable = true}, REDUCE(sym_zero_or_more, 1),
  [308] = {.count = 1, .reusable = false}, REDUCE(sym_zero_or_more, 1),
  [310] = {.count = 1, .reusable = true}, SHIFT(79),
  [312] = {.count = 1, .reusable = true}, REDUCE(sym_optional, 1),
  [314] = {.count = 1, .reusable = false}, REDUCE(sym_optional, 1),
  [316] = {.count = 1, .reusable = true}, SHIFT(78),
  [318] = {.count = 1, .reusable = true}, REDUCE(sym_one_or_more, 1),
  [320] = {.count = 1, .reusable = false}, REDUCE(sym_one_or_more, 1),
  [322] = {.count = 1, .reusable = true}, SHIFT(77),
  [324] = {.count = 1, .reusable = true}, REDUCE(sym_count_quantifier, 4),
  [326] = {.count = 1, .reusable = false}, REDUCE(sym_count_quantifier, 4),
  [328] = {.count = 1, .reusable = true}, SHIFT(76),
  [330] = {.count = 1, .reusable = true}, REDUCE(sym_count_quantifier, 3),
  [332] = {.count = 1, .reusable = false}, REDUCE(sym_count_quantifier, 3),
  [334] = {.count = 1, .reusable = true}, SHIFT(73),
  [336] = {.count = 1, .reusable = true}, REDUCE(sym_count_quantifier, 5),
  [338] = {.count = 1, .reusable = false}, REDUCE(sym_count_quantifier, 5),
  [340] = {.count = 1, .reusable = true}, SHIFT(80),
  [342] = {.count = 1, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 5),
  [344] = {.count = 1, .reusable = true}, SHIFT(89),
  [346] = {.count = 1, .reusable = false}, REDUCE(aux_sym_pattern_repeat1, 5),
  [348] = {.count = 1, .reusable = true}, REDUCE(sym_count_quantifier, 4, .production_id = 13),
  [350] = {.count = 1, .reusable = false}, REDUCE(sym_count_quantifier, 4, .production_id = 13),
  [352] = {.count = 1, .reusable = true}, REDUCE(sym_count_quantifier, 5, .production_id = 16),
  [354] = {.count = 1, .reusable = false}, REDUCE(sym_count_quantifier, 5, .production_id = 16),
  [356] = {.count = 1, .reusable = true}, REDUCE(sym_one_or_more, 2, .production_id = 2),
  [358] = {.count = 1, .reusable = false}, REDUCE(sym_one_or_more, 2, .production_id = 2),
  [360] = {.count = 1, .reusable = true}, REDUCE(sym_optional, 2, .production_id = 2),
  [362] = {.count = 1, .reusable = false}, REDUCE(sym_optional, 2, .production_id = 2),
  [364] = {.count = 1, .reusable = true}, REDUCE(sym_zero_or_more, 2, .production_id = 2),
  [366] = {.count = 1, .reusable = false}, REDUCE(sym_zero_or_more, 2, .production_id = 2),
  [368] = {.count = 1, .reusable = true}, REDUCE(sym_count_quantifier, 6, .production_id = 18),
  [370] = {.count = 1, .reusable = false}, REDUCE(sym_count_quantifier, 6, .production_id = 18),
  [372] = {.count = 1, .reusable = false}, SHIFT(143),
  [374] = {.count = 1, .reusable = true}, SHIFT(87),
  [376] = {.count = 1, .reusable = true}, SHIFT(41),
  [378] = {.count = 1, .reusable = false}, SHIFT(102),
  [380] = {.count = 1, .reusable = true}, SHIFT(110),
  [382] = {.count = 1, .reusable = true}, SHIFT(107),
  [384] = {.count = 1, .reusable = true}, SHIFT(155),
  [386] = {.count = 1, .reusable = true}, SHIFT(137),
  [388] = {.count = 1, .reusable = true}, SHIFT(97),
  [390] = {.count = 1, .reusable = true}, SHIFT(169),
  [392] = {.count = 1, .reusable = true}, SHIFT(108),
  [394] = {.count = 1, .reusable = true}, SHIFT(46),
  [396] = {.count = 1, .reusable = true}, SHIFT(102),
  [398] = {.count = 1, .reusable = true}, SHIFT(45),
  [400] = {.count = 2, .reusable = false}, REDUCE(aux_sym_character_set_repeat1, 2), SHIFT_REPEAT(143),
  [403] = {.count = 1, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 2),
  [405] = {.count = 2, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 2), SHIFT_REPEAT(102),
  [408] = {.count = 2, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 2), SHIFT_REPEAT(110),
  [411] = {.count = 2, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 2), SHIFT_REPEAT(107),
  [414] = {.count = 2, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 2), SHIFT_REPEAT(155),
  [417] = {.count = 2, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 2), SHIFT_REPEAT(137),
  [420] = {.count = 2, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 2), SHIFT_REPEAT(97),
  [423] = {.count = 2, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 2), SHIFT_REPEAT(169),
  [426] = {.count = 2, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 2), SHIFT_REPEAT(108),
  [429] = {.count = 1, .reusable = true}, SHIFT(29),
  [431] = {.count = 1, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 6),
  [433] = {.count = 1, .reusable = false}, REDUCE(aux_sym_pattern_repeat1, 6),
  [435] = {.count = 1, .reusable = false}, REDUCE(sym_named_capturing_group_identifier, 3),
  [437] = {.count = 1, .reusable = true}, REDUCE(sym_named_capturing_group_identifier, 3),
  [439] = {.count = 1, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 2, .production_id = 5),
  [441] = {.count = 1, .reusable = true}, SHIFT(123),
  [443] = {.count = 1, .reusable = true}, SHIFT(124),
  [445] = {.count = 1, .reusable = true}, SHIFT(142),
  [447] = {.count = 1, .reusable = true}, SHIFT(158),
  [449] = {.count = 1, .reusable = true}, SHIFT(173),
  [451] = {.count = 1, .reusable = true}, SHIFT(122),
  [453] = {.count = 1, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 2, .production_id = 3),
  [455] = {.count = 1, .reusable = true}, SHIFT(113),
  [457] = {.count = 1, .reusable = true}, SHIFT(120),
  [459] = {.count = 1, .reusable = true}, SHIFT(118),
  [461] = {.count = 1, .reusable = true}, SHIFT(104),
  [463] = {.count = 1, .reusable = false}, REDUCE(aux_sym_character_set_repeat1, 2),
  [465] = {.count = 1, .reusable = true}, SHIFT(125),
  [467] = {.count = 1, .reusable = true}, SHIFT(152),
  [469] = {.count = 1, .reusable = true}, SHIFT(101),
  [471] = {.count = 1, .reusable = false}, REDUCE(aux_sym_character_set_repeat1, 3),
  [473] = {.count = 1, .reusable = true}, SHIFT(127),
  [475] = {.count = 1, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 3),
  [477] = {.count = 1, .reusable = true}, SHIFT(103),
  [479] = {.count = 1, .reusable = false}, REDUCE(aux_sym_character_set_repeat1, 4),
  [481] = {.count = 1, .reusable = true}, SHIFT(126),
  [483] = {.count = 1, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 4),
  [485] = {.count = 1, .reusable = false}, REDUCE(aux_sym_character_set_repeat1, 1),
  [487] = {.count = 1, .reusable = true}, SHIFT(121),
  [489] = {.count = 1, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 1),
  [491] = {.count = 1, .reusable = true}, SHIFT(106),
  [493] = {.count = 1, .reusable = false}, REDUCE(sym_set_identity_escape, 2),
  [495] = {.count = 1, .reusable = true}, REDUCE(sym_set_identity_escape, 2),
  [497] = {.count = 1, .reusable = true}, SHIFT(93),
  [499] = {.count = 1, .reusable = false}, REDUCE(aux_sym_character_set_repeat1, 1, .production_id = 1),
  [501] = {.count = 1, .reusable = true}, SHIFT(92),
  [503] = {.count = 1, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 1, .production_id = 1),
  [505] = {.count = 1, .reusable = false}, REDUCE(sym_set_range, 3, .production_id = 7),
  [507] = {.count = 1, .reusable = true}, REDUCE(sym_set_range, 3, .production_id = 7),
  [509] = {.count = 1, .reusable = false}, REDUCE(sym_set_range, 3, .production_id = 8),
  [511] = {.count = 1, .reusable = true}, REDUCE(sym_set_range, 3, .production_id = 8),
  [513] = {.count = 1, .reusable = false}, REDUCE(aux_sym_character_set_repeat1, 2, .production_id = 3),
  [515] = {.count = 1, .reusable = false}, REDUCE(sym_set_range, 3, .production_id = 9),
  [517] = {.count = 1, .reusable = true}, REDUCE(sym_set_range, 3, .production_id = 9),
  [519] = {.count = 1, .reusable = false}, REDUCE(sym_set_range, 3, .production_id = 10),
  [521] = {.count = 1, .reusable = true}, REDUCE(sym_set_range, 3, .production_id = 10),
  [523] = {.count = 1, .reusable = false}, REDUCE(aux_sym_character_set_repeat1, 3, .production_id = 11),
  [525] = {.count = 1, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 3, .production_id = 11),
  [527] = {.count = 1, .reusable = false}, REDUCE(aux_sym_character_set_repeat1, 5, .production_id = 17),
  [529] = {.count = 1, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 5, .production_id = 17),
  [531] = {.count = 1, .reusable = false}, REDUCE(aux_sym_character_set_repeat1, 4, .production_id = 14),
  [533] = {.count = 1, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 4, .production_id = 14),
  [535] = {.count = 1, .reusable = true}, REDUCE(sym_group_name, 2),
  [537] = {.count = 1, .reusable = true}, SHIFT(131),
  [539] = {.count = 1, .reusable = true}, SHIFT(144),
  [541] = {.count = 1, .reusable = true}, REDUCE(sym_group_name, 1),
  [543] = {.count = 1, .reusable = true}, SHIFT(129),
  [545] = {.count = 1, .reusable = true}, REDUCE(aux_sym_group_name_repeat1, 2),
  [547] = {.count = 2, .reusable = true}, REDUCE(aux_sym_group_name_repeat1, 2), SHIFT_REPEAT(131),
  [550] = {.count = 2, .reusable = true}, REDUCE(aux_sym_group_name_repeat1, 2), SHIFT_REPEAT(144),
  [553] = {.count = 1, .reusable = true}, SHIFT(130),
  [555] = {.count = 1, .reusable = true}, SHIFT(136),
  [557] = {.count = 1, .reusable = true}, SHIFT(51),
  [559] = {.count = 1, .reusable = false}, SHIFT(27),
  [561] = {.count = 1, .reusable = true}, SHIFT(26),
  [563] = {.count = 1, .reusable = true}, SHIFT(22),
  [565] = {.count = 1, .reusable = false}, SHIFT(26),
  [567] = {.count = 1, .reusable = true}, SHIFT(139),
  [569] = {.count = 1, .reusable = true}, SHIFT(109),
  [571] = {.count = 1, .reusable = false}, SHIFT(100),
  [573] = {.count = 1, .reusable = true}, SHIFT(112),
  [575] = {.count = 1, .reusable = true}, SHIFT(95),
  [577] = {.count = 1, .reusable = false}, SHIFT(112),
  [579] = {.count = 1, .reusable = true}, REDUCE(sym_disjunction, 3),
  [581] = {.count = 1, .reusable = true}, SHIFT(119),
  [583] = {.count = 1, .reusable = true}, SHIFT(116),
  [585] = {.count = 1, .reusable = true}, SHIFT(174),
  [587] = {.count = 1, .reusable = true}, SHIFT(115),
  [589] = {.count = 1, .reusable = true}, REDUCE(sym__escape_operator, 1),
  [591] = {.count = 1, .reusable = true}, SHIFT(159),
  [593] = {.count = 1, .reusable = true}, SHIFT(138),
  [595] = {.count = 1, .reusable = true}, SHIFT(146),
  [597] = {.count = 1, .reusable = true}, SHIFT(69),
  [599] = {.count = 1, .reusable = true}, SHIFT(154),
  [601] = {.count = 1, .reusable = true}, SHIFT(68),
  [603] = {.count = 1, .reusable = true}, SHIFT(28),
  [605] = {.count = 1, .reusable = true}, SHIFT(99),
  [607] = {.count = 1, .reusable = true}, SHIFT(105),
  [609] = {.count = 1, .reusable = true}, SHIFT(91),
  [611] = {.count = 1, .reusable = true}, SHIFT(47),
  [613] = {.count = 1, .reusable = true}, SHIFT(20),
  [615] = {.count = 1, .reusable = true}, SHIFT(96),
  [617] = {.count = 1, .reusable = true}, SHIFT(35),
  [619] = {.count = 1, .reusable = true}, SHIFT(70),
  [621] = {.count = 1, .reusable = true}, SHIFT(94),
  [623] = {.count = 1, .reusable = true},  ACCEPT_INPUT(),
  [625] = {.count = 1, .reusable = true}, SHIFT(36),
  [627] = {.count = 1, .reusable = true}, SHIFT(128),
  [629] = {.count = 1, .reusable = true}, SHIFT(166),
  [631] = {.count = 1, .reusable = true}, SHIFT(145),
  [633] = {.count = 1, .reusable = true}, SHIFT(38),
  [635] = {.count = 1, .reusable = true}, SHIFT(54),
  [637] = {.count = 1, .reusable = true}, SHIFT(23),
  [639] = {.count = 1, .reusable = true}, SHIFT(64),
  [641] = {.count = 1, .reusable = true}, SHIFT(30),
  [643] = {.count = 1, .reusable = true}, SHIFT(134),
  [645] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 2),
  [647] = {.count = 1, .reusable = true}, SHIFT(33),
  [649] = {.count = 1, .reusable = true}, SHIFT(98),
  [651] = {.count = 1, .reusable = true}, SHIFT(55),
  [653] = {.count = 1, .reusable = true}, SHIFT(34),
  [655] = {.count = 1, .reusable = true}, SHIFT(114),
  [657] = {.count = 1, .reusable = true}, SHIFT(117),
  [659] = {.count = 1, .reusable = true}, SHIFT(172),
};

void *tree_sitter_regex_external_scanner_create(void);
void tree_sitter_regex_external_scanner_destroy(void *);
bool tree_sitter_regex_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_regex_external_scanner_serialize(void *, char *);
void tree_sitter_regex_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_regex(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_regex_external_scanner_create,
      tree_sitter_regex_external_scanner_destroy,
      tree_sitter_regex_external_scanner_scan,
      tree_sitter_regex_external_scanner_serialize,
      tree_sitter_regex_external_scanner_deserialize,
    },
  };
  return &language;
}
